// This file is automatically generated by Intel rclnodejs
//
// *** DO NOT EDIT directly
//
'use strict';
const ref = require('ref-napi');
const StructType = require('ref-struct-di')(ref);
const ArrayType = require('ref-array-di')(ref);
const primitiveTypes = require('../../rosidl_gen/primitive_types.js');
const deallocator = require('../../rosidl_gen/deallocator.js');
const translator = require('../../rosidl_gen/message_translator.js');
const StringWrapper = require('../../generated/std_msgs/std_msgs__msg__String.js');
const KeyValueRefStruct = StructType({
  key: primitiveTypes.string,
  value: primitiveTypes.string,
});
const KeyValueRefArray = ArrayType(KeyValueRefStruct);
const KeyValueRefStructArray = StructType({
  data: KeyValueRefArray,
  size: ref.types.size_t,
  capacity: ref.types.size_t
});
// Define the wrapper class.
class KeyValueWrapper {
  constructor(other) {
    this._wrapperFields = {};
    if (typeof other === 'object' && other._refObject) {
      this._refObject = new KeyValueRefStruct(other._refObject.toObject());
      this._keyIntialized = true;
      this._wrapperFields.key =  new StringWrapper(other._wrapperFields.key);
      this._valueIntialized = true;
      this._wrapperFields.value =  new StringWrapper(other._wrapperFields.value);
    } else if (typeof other !== 'undefined') {
      this._initMembers();
      translator.constructFromPlanObject(this, other);
    } else {
      this._initMembers();
    }
    this.freeze();
  }
  _initMembers() {
    this._refObject = new KeyValueRefStruct();
    this._keyIntialized = false;
    this._wrapperFields.key = new StringWrapper();
    this._valueIntialized = false;
    this._wrapperFields.value = new StringWrapper();
  }
  static createFromRefObject(refObject) {
    let self = new KeyValueWrapper();
    self.copyRefObject(refObject);
    return self;
  }
  static createArray() {
    return new KeyValueArrayWrapper;
  }
  static get ArrayType() {
    return KeyValueArrayWrapper;
  }
  static get refObjectArrayType() {
    return KeyValueRefStructArray
  }
  static get refObjectType() {
    return KeyValueRefStruct;
  }
  toRawROS() {
    this.freeze(true);
    return this._refObject.ref();
  }
  freeze(own = false, checkConsistency = false) {
    if (checkConsistency) {
      if (!this._keyIntialized) {
        throw new TypeError('Invalid argument: key in KeyValue');
      }
      if (!this._valueIntialized) {
        throw new TypeError('Invalid argument: value in KeyValue');
      }
    }
    if (own) {
      this._wrapperFields.key.freeze(own, checkConsistency);
    }
    this._refObject.key = this._wrapperFields.key.refObject;
    if (own) {
      this._wrapperFields.value.freeze(own, checkConsistency);
    }
    this._refObject.value = this._wrapperFields.value.refObject;
  }
  serialize() {
    this.freeze(false, true);
    return this._refObject.ref();
  }
  deserialize(refObject) {
    this._keyIntialized = true;
    this._wrapperFields.key.data = refObject.key.data;
    this._valueIntialized = true;
    this._wrapperFields.value.data = refObject.value.data;
  }
  toPlainObject(enableTypedArray) {
    return translator.toPlainObject(this, enableTypedArray);
  }
  static freeStruct(refObject) {
    StringWrapper.freeStruct(refObject.key);
    StringWrapper.freeStruct(refObject.value);
  }
  static destoryRawROS(msg) {
    KeyValueWrapper.freeStruct(msg.refObject);
  }
  static type() {
    return {pkgName: 'diagnostic_msgs', subFolder: 'msg', interfaceName: 'KeyValue'};
  }
  static isPrimitive() {
    return false;
  }
  static get isROSArray() {
    return false;
  }
  get refObject() {
    return this._refObject;
  }
  get key() {
    if (!this._keyIntialized) {
      return undefined;
    }
    return this._wrapperFields.key.data;
  }
  set key(value) {
    this._keyIntialized = true;
    this._wrapperFields.key.data = value;
  }
  get value() {
    if (!this._valueIntialized) {
      return undefined;
    }
    return this._wrapperFields.value.data;
  }
  set value(value) {
    this._valueIntialized = true;
    this._wrapperFields.value.data = value;
  }
  copyRefObject(refObject) {
    this._refObject = new KeyValueRefStruct(refObject.toObject());
    this._keyIntialized = true;
    this._wrapperFields.key.copyRefObject(this._refObject.key);
    this._valueIntialized = true;
    this._wrapperFields.value.copyRefObject(this._refObject.value);
  }
  copy(other) {
    this._refObject = new KeyValueRefStruct(other._refObject.toObject());
    this._keyIntialized = true;
    this._wrapperFields.key.copy(other._wrapperFields.key);
    this._valueIntialized = true;
    this._wrapperFields.value.copy(other._wrapperFields.value);
  }
  static get classType() {
    return KeyValueWrapper;
  }
  static get ROSMessageDef() {
    return {"constants":[],"fields":[{"name":"key","type":{"isArray":false,"arraySize":null,"isUpperBound":false,"isDynamicArray":false,"isFixedSizeArray":false,"pkgName":null,"type":"string","stringUpperBound":null,"isPrimitiveType":true},"default_value":null},{"name":"value","type":{"isArray":false,"arraySize":null,"isUpperBound":false,"isDynamicArray":false,"isFixedSizeArray":false,"pkgName":null,"type":"string","stringUpperBound":null,"isPrimitiveType":true},"default_value":null}],"baseType":{"pkgName":"diagnostic_msgs","type":"KeyValue","stringUpperBound":null,"isPrimitiveType":false},"msgName":"KeyValue"};
  }
  hasMember(name) {
    let memberNames = ["key","value"];
    return memberNames.indexOf(name) !== -1;
  }
}
// Define the wrapper of array class.
class KeyValueArrayWrapper {
  constructor(size = 0) {
    this._resize(size);
  }
  toRawROS() {
    return this._refObject.ref();
  }
  fill(values) {
    const length = values.length;
    this._resize(length);
    values.forEach((value, index) => {
      if (value instanceof KeyValueWrapper) {
        this._wrappers[index].copy(value);
      } else {
        this._wrappers[index] = new KeyValueWrapper(value);
      }
    });
  }
  // Put all data currently stored in `this._wrappers` into `this._refObject`
  freeze(own) {
    this._wrappers.forEach((wrapper, index) => {
      wrapper.freeze(own);
      this._refArray[index] = wrapper.refObject;
    });
    this._refObject.size = this._wrappers.length;
    this._refObject.capacity = this._wrappers.length;
    if (this._refObject.capacity === 0) {
      this._refObject.data = null
    } else {
    this._refObject.data = this._refArray.buffer;
    }
  }
  get refObject() {
    return this._refObject;
  }
  get data() {
    return this._wrappers;
  }
  get size() {
    return this._wrappers.length;
  }
  set size(value) {
    if (typeof value != 'number') {
      throw new TypeError('Invalid argument: should provide a number to KeyValueArrayWrapper.size setter');
      return;
    }
    return this._resize(value);
  }
  get capacity() {
    return this._wrappers.length;
  }
  set capacity(value) {
    if (typeof value != 'number') {
      throw new TypeError('Invalid argument: should provide a number to KeyValueArrayWrapper.capacity setter');
    }
    return this._resize(value);
  }
  get refObject() {
    return this._refObject;
  }
  _resize(size) {
    if (size < 0) {
      throw new RangeError('Invalid argument: should provide a positive number');
      return;
    }
    this._refArray = new KeyValueRefArray(size);
    this._refObject = new KeyValueRefStructArray();
    this._refObject.size = size;
    this._refObject.capacity = size;
    this._wrappers = new Array();
    for (let i = 0; i < size; i++) {
      this._wrappers.push(new KeyValueWrapper());
    }
  }
  // Copy all data from `this._refObject` into `this._wrappers`
  copyRefObject(refObject) {
    this._refObject = refObject;
    let refObjectArray = this._refObject.data;
    refObjectArray.length = this._refObject.size;
    this._resize(this._refObject.size);
    for (let index = 0; index < this._refObject.size; index++) {
      this._wrappers[index].copyRefObject(refObjectArray[index]);
    }
  }
  copy(other) {
    if (! (other instanceof KeyValueArrayWrapper)) {
      throw new TypeError('Invalid argument: should provide "KeyValueArrayWrapper".');
    }
    this._resize(other.size);
    // Array deep copy
    other._wrappers.forEach((wrapper, index) => {
      this._wrappers[index].copy(wrapper);
    });
  }
  static freeArray(refObject) {
    let refObjectArray = refObject.data;
    refObjectArray.length = refObject.size;
    for (let index = 0; index < refObject.size; index++) {
      KeyValueWrapper.freeStruct(refObjectArray[index]);
    }
  }
  static get elementType() {
    return KeyValueWrapper;
  }
  static get isROSArray() {
    return true;
  }
  static get useTypedArray() {
    return false;
  }
  get classType() {
    return KeyValueArrayWrapper;
  }
}
module.exports = KeyValueWrapper;
/*
 * The following is the original spec object coming from parser:
{
  "constants": [],
  "fields": [
    {
      "name": "key",
      "type": {
        "isArray": false,
        "arraySize": null,
        "isUpperBound": false,
        "isDynamicArray": false,
        "isFixedSizeArray": false,
        "pkgName": null,
        "type": "string",
        "stringUpperBound": null,
        "isPrimitiveType": true
      },
      "default_value": null
    },
    {
      "name": "value",
      "type": {
        "isArray": false,
        "arraySize": null,
        "isUpperBound": false,
        "isDynamicArray": false,
        "isFixedSizeArray": false,
        "pkgName": null,
        "type": "string",
        "stringUpperBound": null,
        "isPrimitiveType": true
      },
      "default_value": null
    }
  ],
  "baseType": {
    "pkgName": "diagnostic_msgs",
    "type": "KeyValue",
    "stringUpperBound": null,
    "isPrimitiveType": false
  },
  "msgName": "KeyValue"
}
*/
