// This file is automatically generated by Intel rclnodejs
//
// *** DO NOT EDIT directly
//
'use strict';
const ref = require('ref-napi');
const StructType = require('ref-struct-di')(ref);
const ArrayType = require('ref-array-di')(ref);
const primitiveTypes = require('../../rosidl_gen/primitive_types.js');
const deallocator = require('../../rosidl_gen/deallocator.js');
const translator = require('../../rosidl_gen/message_translator.js');
const Vector3Wrapper = require('../../generated/geometry_msgs/geometry_msgs__msg__Vector3.js');
const QuaternionWrapper = require('../../generated/geometry_msgs/geometry_msgs__msg__Quaternion.js');
const TransformRefStruct = StructType({
  translation: Vector3Wrapper.refObjectType,
  rotation: QuaternionWrapper.refObjectType,
});
const TransformRefArray = ArrayType(TransformRefStruct);
const TransformRefStructArray = StructType({
  data: TransformRefArray,
  size: ref.types.size_t,
  capacity: ref.types.size_t
});
// Define the wrapper class.
class TransformWrapper {
  constructor(other) {
    this._wrapperFields = {};
    if (typeof other === 'object' && other._refObject) {
      this._refObject = new TransformRefStruct(other._refObject.toObject());
      this._wrapperFields.translation =  new Vector3Wrapper(other._wrapperFields.translation);
      this._wrapperFields.rotation =  new QuaternionWrapper(other._wrapperFields.rotation);
    } else if (typeof other !== 'undefined') {
      this._initMembers();
      translator.constructFromPlanObject(this, other);
    } else {
      this._initMembers();
    }
    this.freeze();
  }
  _initMembers() {
    this._refObject = new TransformRefStruct();
    this._wrapperFields.translation = new Vector3Wrapper();
    this._wrapperFields.rotation = new QuaternionWrapper();
  }
  static createFromRefObject(refObject) {
    let self = new TransformWrapper();
    self.copyRefObject(refObject);
    return self;
  }
  static createArray() {
    return new TransformArrayWrapper;
  }
  static get ArrayType() {
    return TransformArrayWrapper;
  }
  static get refObjectArrayType() {
    return TransformRefStructArray
  }
  static get refObjectType() {
    return TransformRefStruct;
  }
  toRawROS() {
    this.freeze(true);
    return this._refObject.ref();
  }
  freeze(own = false, checkConsistency = false) {
    if (checkConsistency) {
    }
    this._wrapperFields.translation.freeze(own, checkConsistency);
    this._refObject.translation = this._wrapperFields.translation.refObject;
    this._wrapperFields.rotation.freeze(own, checkConsistency);
    this._refObject.rotation = this._wrapperFields.rotation.refObject;
  }
  serialize() {
    this.freeze(false, true);
    return this._refObject.ref();
  }
  deserialize(refObject) {
    this._wrapperFields.translation.copyRefObject(refObject.translation);
    this._wrapperFields.rotation.copyRefObject(refObject.rotation);
  }
  toPlainObject(enableTypedArray) {
    return translator.toPlainObject(this, enableTypedArray);
  }
  static freeStruct(refObject) {
    Vector3Wrapper.freeStruct(refObject.translation);
    QuaternionWrapper.freeStruct(refObject.rotation);
  }
  static destoryRawROS(msg) {
    TransformWrapper.freeStruct(msg.refObject);
  }
  static type() {
    return {pkgName: 'geometry_msgs', subFolder: 'msg', interfaceName: 'Transform'};
  }
  static isPrimitive() {
    return false;
  }
  static get isROSArray() {
    return false;
  }
  get refObject() {
    return this._refObject;
  }
  get translation() {
    return this._wrapperFields.translation;
  }
  set translation(value) {
    if (value instanceof Vector3Wrapper) {
      this._wrapperFields.translation.copy(value);
    } else {
      this._wrapperFields.translation.copy(new Vector3Wrapper(value));
    }
  }
  get rotation() {
    return this._wrapperFields.rotation;
  }
  set rotation(value) {
    if (value instanceof QuaternionWrapper) {
      this._wrapperFields.rotation.copy(value);
    } else {
      this._wrapperFields.rotation.copy(new QuaternionWrapper(value));
    }
  }
  copyRefObject(refObject) {
    this._refObject = new TransformRefStruct(refObject.toObject());
    this._wrapperFields.translation.copyRefObject(this._refObject.translation);
    this._wrapperFields.rotation.copyRefObject(this._refObject.rotation);
  }
  copy(other) {
    this._refObject = new TransformRefStruct(other._refObject.toObject());
    this._wrapperFields.translation.copy(other._wrapperFields.translation);
    this._wrapperFields.rotation.copy(other._wrapperFields.rotation);
  }
  static get classType() {
    return TransformWrapper;
  }
  static get ROSMessageDef() {
    return {"constants":[],"fields":[{"name":"translation","type":{"isArray":false,"arraySize":null,"isUpperBound":false,"isDynamicArray":false,"isFixedSizeArray":false,"pkgName":"geometry_msgs","type":"Vector3","stringUpperBound":null,"isPrimitiveType":false},"default_value":null},{"name":"rotation","type":{"isArray":false,"arraySize":null,"isUpperBound":false,"isDynamicArray":false,"isFixedSizeArray":false,"pkgName":"geometry_msgs","type":"Quaternion","stringUpperBound":null,"isPrimitiveType":false},"default_value":null}],"baseType":{"pkgName":"geometry_msgs","type":"Transform","stringUpperBound":null,"isPrimitiveType":false},"msgName":"Transform"};
  }
  hasMember(name) {
    let memberNames = ["translation","rotation"];
    return memberNames.indexOf(name) !== -1;
  }
}
// Define the wrapper of array class.
class TransformArrayWrapper {
  constructor(size = 0) {
    this._resize(size);
  }
  toRawROS() {
    return this._refObject.ref();
  }
  fill(values) {
    const length = values.length;
    this._resize(length);
    values.forEach((value, index) => {
      if (value instanceof TransformWrapper) {
        this._wrappers[index].copy(value);
      } else {
        this._wrappers[index] = new TransformWrapper(value);
      }
    });
  }
  // Put all data currently stored in `this._wrappers` into `this._refObject`
  freeze(own) {
    this._wrappers.forEach((wrapper, index) => {
      wrapper.freeze(own);
      this._refArray[index] = wrapper.refObject;
    });
    this._refObject.size = this._wrappers.length;
    this._refObject.capacity = this._wrappers.length;
    if (this._refObject.capacity === 0) {
      this._refObject.data = null
    } else {
    this._refObject.data = this._refArray.buffer;
    }
  }
  get refObject() {
    return this._refObject;
  }
  get data() {
    return this._wrappers;
  }
  get size() {
    return this._wrappers.length;
  }
  set size(value) {
    if (typeof value != 'number') {
      throw new TypeError('Invalid argument: should provide a number to TransformArrayWrapper.size setter');
      return;
    }
    return this._resize(value);
  }
  get capacity() {
    return this._wrappers.length;
  }
  set capacity(value) {
    if (typeof value != 'number') {
      throw new TypeError('Invalid argument: should provide a number to TransformArrayWrapper.capacity setter');
    }
    return this._resize(value);
  }
  get refObject() {
    return this._refObject;
  }
  _resize(size) {
    if (size < 0) {
      throw new RangeError('Invalid argument: should provide a positive number');
      return;
    }
    this._refArray = new TransformRefArray(size);
    this._refObject = new TransformRefStructArray();
    this._refObject.size = size;
    this._refObject.capacity = size;
    this._wrappers = new Array();
    for (let i = 0; i < size; i++) {
      this._wrappers.push(new TransformWrapper());
    }
  }
  // Copy all data from `this._refObject` into `this._wrappers`
  copyRefObject(refObject) {
    this._refObject = refObject;
    let refObjectArray = this._refObject.data;
    refObjectArray.length = this._refObject.size;
    this._resize(this._refObject.size);
    for (let index = 0; index < this._refObject.size; index++) {
      this._wrappers[index].copyRefObject(refObjectArray[index]);
    }
  }
  copy(other) {
    if (! (other instanceof TransformArrayWrapper)) {
      throw new TypeError('Invalid argument: should provide "TransformArrayWrapper".');
    }
    this._resize(other.size);
    // Array deep copy
    other._wrappers.forEach((wrapper, index) => {
      this._wrappers[index].copy(wrapper);
    });
  }
  static freeArray(refObject) {
    let refObjectArray = refObject.data;
    refObjectArray.length = refObject.size;
    for (let index = 0; index < refObject.size; index++) {
      TransformWrapper.freeStruct(refObjectArray[index]);
    }
  }
  static get elementType() {
    return TransformWrapper;
  }
  static get isROSArray() {
    return true;
  }
  static get useTypedArray() {
    return false;
  }
  get classType() {
    return TransformArrayWrapper;
  }
}
module.exports = TransformWrapper;
/*
 * The following is the original spec object coming from parser:
{
  "constants": [],
  "fields": [
    {
      "name": "translation",
      "type": {
        "isArray": false,
        "arraySize": null,
        "isUpperBound": false,
        "isDynamicArray": false,
        "isFixedSizeArray": false,
        "pkgName": "geometry_msgs",
        "type": "Vector3",
        "stringUpperBound": null,
        "isPrimitiveType": false
      },
      "default_value": null
    },
    {
      "name": "rotation",
      "type": {
        "isArray": false,
        "arraySize": null,
        "isUpperBound": false,
        "isDynamicArray": false,
        "isFixedSizeArray": false,
        "pkgName": "geometry_msgs",
        "type": "Quaternion",
        "stringUpperBound": null,
        "isPrimitiveType": false
      },
      "default_value": null
    }
  ],
  "baseType": {
    "pkgName": "geometry_msgs",
    "type": "Transform",
    "stringUpperBound": null,
    "isPrimitiveType": false
  },
  "msgName": "Transform"
}
*/
