// This file is automatically generated by Intel rclnodejs
//
// *** DO NOT EDIT directly
//
'use strict';
const ref = require('ref-napi');
const StructType = require('ref-struct-di')(ref);
const ArrayType = require('ref-array-di')(ref);
const primitiveTypes = require('../../rosidl_gen/primitive_types.js');
const deallocator = require('../../rosidl_gen/deallocator.js');
const translator = require('../../rosidl_gen/message_translator.js');
const HeaderWrapper = require('../../generated/std_msgs/std_msgs__msg__Header.js');
const RelativeHumidityRefStruct = StructType({
  header: HeaderWrapper.refObjectType,
  relative_humidity: primitiveTypes.float64,
  variance: primitiveTypes.float64,
});
const RelativeHumidityRefArray = ArrayType(RelativeHumidityRefStruct);
const RelativeHumidityRefStructArray = StructType({
  data: RelativeHumidityRefArray,
  size: ref.types.size_t,
  capacity: ref.types.size_t
});
// Define the wrapper class.
class RelativeHumidityWrapper {
  constructor(other) {
    this._wrapperFields = {};
    if (typeof other === 'object' && other._refObject) {
      this._refObject = new RelativeHumidityRefStruct(other._refObject.toObject());
      this._wrapperFields.header =  new HeaderWrapper(other._wrapperFields.header);
      this._relative_humidityIntialized = true;
      this._varianceIntialized = true;
    } else if (typeof other !== 'undefined') {
      this._initMembers();
      translator.constructFromPlanObject(this, other);
    } else {
      this._initMembers();
    }
    this.freeze();
  }
  _initMembers() {
    this._refObject = new RelativeHumidityRefStruct();
    this._wrapperFields.header = new HeaderWrapper();
    this._relative_humidityIntialized = false;
    this._varianceIntialized = false;
  }
  static createFromRefObject(refObject) {
    let self = new RelativeHumidityWrapper();
    self.copyRefObject(refObject);
    return self;
  }
  static createArray() {
    return new RelativeHumidityArrayWrapper;
  }
  static get ArrayType() {
    return RelativeHumidityArrayWrapper;
  }
  static get refObjectArrayType() {
    return RelativeHumidityRefStructArray
  }
  static get refObjectType() {
    return RelativeHumidityRefStruct;
  }
  toRawROS() {
    this.freeze(true);
    return this._refObject.ref();
  }
  freeze(own = false, checkConsistency = false) {
    if (checkConsistency) {
      if (!this._relative_humidityIntialized) {
        throw new TypeError('Invalid argument: relative_humidity in RelativeHumidity');
      }
      if (!this._varianceIntialized) {
        throw new TypeError('Invalid argument: variance in RelativeHumidity');
      }
    }
    this._wrapperFields.header.freeze(own, checkConsistency);
    this._refObject.header = this._wrapperFields.header.refObject;
  }
  serialize() {
    this.freeze(false, true);
    return this._refObject.ref();
  }
  deserialize(refObject) {
    this._wrapperFields.header.copyRefObject(refObject.header);
    this._relative_humidityIntialized = true;
    this._refObject.relative_humidity = refObject.relative_humidity;
    this._varianceIntialized = true;
    this._refObject.variance = refObject.variance;
  }
  toPlainObject(enableTypedArray) {
    return translator.toPlainObject(this, enableTypedArray);
  }
  static freeStruct(refObject) {
    HeaderWrapper.freeStruct(refObject.header);
  }
  static destoryRawROS(msg) {
    RelativeHumidityWrapper.freeStruct(msg.refObject);
  }
  static type() {
    return {pkgName: 'sensor_msgs', subFolder: 'msg', interfaceName: 'RelativeHumidity'};
  }
  static isPrimitive() {
    return false;
  }
  static get isROSArray() {
    return false;
  }
  get refObject() {
    return this._refObject;
  }
  get header() {
    return this._wrapperFields.header;
  }
  set header(value) {
    if (value instanceof HeaderWrapper) {
      this._wrapperFields.header.copy(value);
    } else {
      this._wrapperFields.header.copy(new HeaderWrapper(value));
    }
  }
  get relative_humidity() {
    if (!this._relative_humidityIntialized) {
      return undefined;
    }
    return this._refObject.relative_humidity;
  }
  set relative_humidity(value) {
    this._relative_humidityIntialized = true;
    this._refObject.relative_humidity = value;
  }
  get variance() {
    if (!this._varianceIntialized) {
      return undefined;
    }
    return this._refObject.variance;
  }
  set variance(value) {
    this._varianceIntialized = true;
    this._refObject.variance = value;
  }
  copyRefObject(refObject) {
    this._refObject = new RelativeHumidityRefStruct(refObject.toObject());
    this._wrapperFields.header.copyRefObject(this._refObject.header);
    this._relative_humidityIntialized = true;
    this._varianceIntialized = true;
  }
  copy(other) {
    this._refObject = new RelativeHumidityRefStruct(other._refObject.toObject());
    this._wrapperFields.header.copy(other._wrapperFields.header);
    this._relative_humidityIntialized = true;
    this._varianceIntialized = true;
  }
  static get classType() {
    return RelativeHumidityWrapper;
  }
  static get ROSMessageDef() {
    return {"constants":[],"fields":[{"name":"header","type":{"isArray":false,"arraySize":null,"isUpperBound":false,"isDynamicArray":false,"isFixedSizeArray":false,"pkgName":"std_msgs","type":"Header","stringUpperBound":null,"isPrimitiveType":false},"default_value":null},{"name":"relative_humidity","type":{"isArray":false,"arraySize":null,"isUpperBound":false,"isDynamicArray":false,"isFixedSizeArray":false,"pkgName":null,"type":"float64","stringUpperBound":null,"isPrimitiveType":true},"default_value":null},{"name":"variance","type":{"isArray":false,"arraySize":null,"isUpperBound":false,"isDynamicArray":false,"isFixedSizeArray":false,"pkgName":null,"type":"float64","stringUpperBound":null,"isPrimitiveType":true},"default_value":null}],"baseType":{"pkgName":"sensor_msgs","type":"RelativeHumidity","stringUpperBound":null,"isPrimitiveType":false},"msgName":"RelativeHumidity"};
  }
  hasMember(name) {
    let memberNames = ["header","relative_humidity","variance"];
    return memberNames.indexOf(name) !== -1;
  }
}
// Define the wrapper of array class.
class RelativeHumidityArrayWrapper {
  constructor(size = 0) {
    this._resize(size);
  }
  toRawROS() {
    return this._refObject.ref();
  }
  fill(values) {
    const length = values.length;
    this._resize(length);
    values.forEach((value, index) => {
      if (value instanceof RelativeHumidityWrapper) {
        this._wrappers[index].copy(value);
      } else {
        this._wrappers[index] = new RelativeHumidityWrapper(value);
      }
    });
  }
  // Put all data currently stored in `this._wrappers` into `this._refObject`
  freeze(own) {
    this._wrappers.forEach((wrapper, index) => {
      wrapper.freeze(own);
      this._refArray[index] = wrapper.refObject;
    });
    this._refObject.size = this._wrappers.length;
    this._refObject.capacity = this._wrappers.length;
    if (this._refObject.capacity === 0) {
      this._refObject.data = null
    } else {
    this._refObject.data = this._refArray.buffer;
    }
  }
  get refObject() {
    return this._refObject;
  }
  get data() {
    return this._wrappers;
  }
  get size() {
    return this._wrappers.length;
  }
  set size(value) {
    if (typeof value != 'number') {
      throw new TypeError('Invalid argument: should provide a number to RelativeHumidityArrayWrapper.size setter');
      return;
    }
    return this._resize(value);
  }
  get capacity() {
    return this._wrappers.length;
  }
  set capacity(value) {
    if (typeof value != 'number') {
      throw new TypeError('Invalid argument: should provide a number to RelativeHumidityArrayWrapper.capacity setter');
    }
    return this._resize(value);
  }
  get refObject() {
    return this._refObject;
  }
  _resize(size) {
    if (size < 0) {
      throw new RangeError('Invalid argument: should provide a positive number');
      return;
    }
    this._refArray = new RelativeHumidityRefArray(size);
    this._refObject = new RelativeHumidityRefStructArray();
    this._refObject.size = size;
    this._refObject.capacity = size;
    this._wrappers = new Array();
    for (let i = 0; i < size; i++) {
      this._wrappers.push(new RelativeHumidityWrapper());
    }
  }
  // Copy all data from `this._refObject` into `this._wrappers`
  copyRefObject(refObject) {
    this._refObject = refObject;
    let refObjectArray = this._refObject.data;
    refObjectArray.length = this._refObject.size;
    this._resize(this._refObject.size);
    for (let index = 0; index < this._refObject.size; index++) {
      this._wrappers[index].copyRefObject(refObjectArray[index]);
    }
  }
  copy(other) {
    if (! (other instanceof RelativeHumidityArrayWrapper)) {
      throw new TypeError('Invalid argument: should provide "RelativeHumidityArrayWrapper".');
    }
    this._resize(other.size);
    // Array deep copy
    other._wrappers.forEach((wrapper, index) => {
      this._wrappers[index].copy(wrapper);
    });
  }
  static freeArray(refObject) {
    let refObjectArray = refObject.data;
    refObjectArray.length = refObject.size;
    for (let index = 0; index < refObject.size; index++) {
      RelativeHumidityWrapper.freeStruct(refObjectArray[index]);
    }
  }
  static get elementType() {
    return RelativeHumidityWrapper;
  }
  static get isROSArray() {
    return true;
  }
  static get useTypedArray() {
    return false;
  }
  get classType() {
    return RelativeHumidityArrayWrapper;
  }
}
module.exports = RelativeHumidityWrapper;
/*
 * The following is the original spec object coming from parser:
{
  "constants": [],
  "fields": [
    {
      "name": "header",
      "type": {
        "isArray": false,
        "arraySize": null,
        "isUpperBound": false,
        "isDynamicArray": false,
        "isFixedSizeArray": false,
        "pkgName": "std_msgs",
        "type": "Header",
        "stringUpperBound": null,
        "isPrimitiveType": false
      },
      "default_value": null
    },
    {
      "name": "relative_humidity",
      "type": {
        "isArray": false,
        "arraySize": null,
        "isUpperBound": false,
        "isDynamicArray": false,
        "isFixedSizeArray": false,
        "pkgName": null,
        "type": "float64",
        "stringUpperBound": null,
        "isPrimitiveType": true
      },
      "default_value": null
    },
    {
      "name": "variance",
      "type": {
        "isArray": false,
        "arraySize": null,
        "isUpperBound": false,
        "isDynamicArray": false,
        "isFixedSizeArray": false,
        "pkgName": null,
        "type": "float64",
        "stringUpperBound": null,
        "isPrimitiveType": true
      },
      "default_value": null
    }
  ],
  "baseType": {
    "pkgName": "sensor_msgs",
    "type": "RelativeHumidity",
    "stringUpperBound": null,
    "isPrimitiveType": false
  },
  "msgName": "RelativeHumidity"
}
*/
