/* eslint-disable camelcase */
/* eslint-disable max-len */
// DO NOT EDIT
// This file is generated by the rostsd_gen script

declare module 'rclnodejs' {
  namespace action_msgs {
    namespace msg {
      export interface GoalInfo {
        goal_id: unique_identifier_msgs.msg.UUID;
        stamp: builtin_interfaces.msg.Time;
      }
      export interface GoalInfoConstructor {
        new(other?: GoalInfo): GoalInfo;
      }
      export interface GoalStatus {
        goal_info: action_msgs.msg.GoalInfo;
        status: number;
      }
      export interface GoalStatusConstructor {
        readonly STATUS_UNKNOWN: number;
        readonly STATUS_ACCEPTED: number;
        readonly STATUS_EXECUTING: number;
        readonly STATUS_CANCELING: number;
        readonly STATUS_SUCCEEDED: number;
        readonly STATUS_CANCELED: number;
        readonly STATUS_ABORTED: number;
        new(other?: GoalStatus): GoalStatus;
      }
      export interface GoalStatusArray {
        status_list: action_msgs.msg.GoalStatus[];
      }
      export interface GoalStatusArrayConstructor {
        new(other?: GoalStatusArray): GoalStatusArray;
      }
    }
    namespace srv {
      export interface CancelGoalConstructor extends ROSService {
        readonly Request: CancelGoal_RequestConstructor;
        readonly Response: CancelGoal_ResponseConstructor;
      }
      export interface CancelGoal_Request {
        goal_info: action_msgs.msg.GoalInfo;
      }
      export interface CancelGoal_RequestConstructor {
        new(other?: CancelGoal_Request): CancelGoal_Request;
      }
      export interface CancelGoal_Response {
        return_code: number;
        goals_canceling: action_msgs.msg.GoalInfo[];
      }
      export interface CancelGoal_ResponseConstructor {
        readonly ERROR_NONE: number;
        readonly ERROR_REJECTED: number;
        readonly ERROR_UNKNOWN_GOAL_ID: number;
        readonly ERROR_GOAL_TERMINATED: number;
        new(other?: CancelGoal_Response): CancelGoal_Response;
      }
    }
  }

  namespace actionlib_msgs {
    namespace msg {
      export interface GoalID {
        stamp: builtin_interfaces.msg.Time;
        id: string;
      }
      export interface GoalIDConstructor {
        new(other?: GoalID): GoalID;
      }
      export interface GoalStatus {
        goal_id: actionlib_msgs.msg.GoalID;
        status: number;
        text: string;
      }
      export interface GoalStatusConstructor {
        readonly PENDING: number;
        readonly ACTIVE: number;
        readonly PREEMPTED: number;
        readonly SUCCEEDED: number;
        readonly ABORTED: number;
        readonly REJECTED: number;
        readonly PREEMPTING: number;
        readonly RECALLING: number;
        readonly RECALLED: number;
        readonly LOST: number;
        new(other?: GoalStatus): GoalStatus;
      }
      export interface GoalStatusArray {
        header: std_msgs.msg.Header;
        status_list: actionlib_msgs.msg.GoalStatus[];
      }
      export interface GoalStatusArrayConstructor {
        new(other?: GoalStatusArray): GoalStatusArray;
      }
    }
  }

  namespace builtin_interfaces {
    namespace msg {
      export interface Duration {
        sec: number;
        nanosec: number;
      }
      export interface DurationConstructor {
        new(other?: Duration): Duration;
      }
      export interface Time {
        sec: number;
        nanosec: number;
      }
      export interface TimeConstructor {
        new(other?: Time): Time;
      }
    }
  }

  namespace cartographer_ros_msgs {
    namespace msg {
      export interface LandmarkEntry {
        id: string;
        tracking_from_landmark_transform: geometry_msgs.msg.Pose;
        translation_weight: number;
        rotation_weight: number;
      }
      export interface LandmarkEntryConstructor {
        new(other?: LandmarkEntry): LandmarkEntry;
      }
      export interface LandmarkList {
        header: std_msgs.msg.Header;
        landmark: cartographer_ros_msgs.msg.LandmarkEntry[];
      }
      export interface LandmarkListConstructor {
        new(other?: LandmarkList): LandmarkList;
      }
      export interface SensorTopics {
        laser_scan_topic: string;
        multi_echo_laser_scan_topic: string;
        point_cloud2_topic: string;
        imu_topic: string;
        odometry_topic: string;
        nav_sat_fix_topic: string;
        landmark_topic: string;
      }
      export interface SensorTopicsConstructor {
        new(other?: SensorTopics): SensorTopics;
      }
      export interface StatusCode {
      }
      export interface StatusCodeConstructor {
        readonly OK: number;
        readonly CANCELLED: number;
        readonly UNKNOWN: number;
        readonly INVALID_ARGUMENT: number;
        readonly DEADLINE_EXCEEDED: number;
        readonly NOT_FOUND: number;
        readonly ALREADY_EXISTS: number;
        readonly PERMISSION_DENIED: number;
        readonly RESOURCE_EXHAUSTED: number;
        readonly FAILED_PRECONDITION: number;
        readonly ABORTED: number;
        readonly OUT_OF_RANGE: number;
        readonly UNIMPLEMENTED: number;
        readonly INTERNAL: number;
        readonly UNAVAILABLE: number;
        readonly DATA_LOSS: number;
        new(other?: StatusCode): StatusCode;
      }
      export interface StatusResponse {
        code: number;
        message: string;
      }
      export interface StatusResponseConstructor {
        new(other?: StatusResponse): StatusResponse;
      }
      export interface SubmapEntry {
        trajectory_id: number;
        submap_index: number;
        submap_version: number;
        pose: geometry_msgs.msg.Pose;
      }
      export interface SubmapEntryConstructor {
        new(other?: SubmapEntry): SubmapEntry;
      }
      export interface SubmapList {
        header: std_msgs.msg.Header;
        submap: cartographer_ros_msgs.msg.SubmapEntry[];
      }
      export interface SubmapListConstructor {
        new(other?: SubmapList): SubmapList;
      }
      export interface SubmapTexture {
        cells: number[] | Uint8Array;
        width: number;
        height: number;
        resolution: number;
        slice_pose: geometry_msgs.msg.Pose;
      }
      export interface SubmapTextureConstructor {
        new(other?: SubmapTexture): SubmapTexture;
      }
      export interface TrajectoryOptions {
        tracking_frame: string;
        published_frame: string;
        odom_frame: string;
        provide_odom_frame: boolean;
        use_odometry: boolean;
        use_nav_sat: boolean;
        use_landmarks: boolean;
        publish_frame_projected_to_2d: boolean;
        num_laser_scans: number;
        num_multi_echo_laser_scans: number;
        num_subdivisions_per_laser_scan: number;
        num_point_clouds: number;
        rangefinder_sampling_ratio: number;
        odometry_sampling_ratio: number;
        fixed_frame_pose_sampling_ratio: number;
        imu_sampling_ratio: number;
        landmarks_sampling_ratio: number;
        trajectory_builder_options_proto: string;
      }
      export interface TrajectoryOptionsConstructor {
        new(other?: TrajectoryOptions): TrajectoryOptions;
      }
    }
    namespace srv {
      export interface FinishTrajectoryConstructor extends ROSService {
        readonly Request: FinishTrajectory_RequestConstructor;
        readonly Response: FinishTrajectory_ResponseConstructor;
      }
      export interface FinishTrajectory_Request {
        trajectory_id: number;
      }
      export interface FinishTrajectory_RequestConstructor {
        new(other?: FinishTrajectory_Request): FinishTrajectory_Request;
      }
      export interface FinishTrajectory_Response {
        status: cartographer_ros_msgs.msg.StatusResponse;
      }
      export interface FinishTrajectory_ResponseConstructor {
        new(other?: FinishTrajectory_Response): FinishTrajectory_Response;
      }
      export interface StartTrajectoryConstructor extends ROSService {
        readonly Request: StartTrajectory_RequestConstructor;
        readonly Response: StartTrajectory_ResponseConstructor;
      }
      export interface StartTrajectory_Request {
        options: cartographer_ros_msgs.msg.TrajectoryOptions;
        topics: cartographer_ros_msgs.msg.SensorTopics;
      }
      export interface StartTrajectory_RequestConstructor {
        new(other?: StartTrajectory_Request): StartTrajectory_Request;
      }
      export interface StartTrajectory_Response {
        status: cartographer_ros_msgs.msg.StatusResponse;
        trajectory_id: number;
      }
      export interface StartTrajectory_ResponseConstructor {
        new(other?: StartTrajectory_Response): StartTrajectory_Response;
      }
      export interface SubmapQueryConstructor extends ROSService {
        readonly Request: SubmapQuery_RequestConstructor;
        readonly Response: SubmapQuery_ResponseConstructor;
      }
      export interface SubmapQuery_Request {
        trajectory_id: number;
        submap_index: number;
      }
      export interface SubmapQuery_RequestConstructor {
        new(other?: SubmapQuery_Request): SubmapQuery_Request;
      }
      export interface SubmapQuery_Response {
        status: cartographer_ros_msgs.msg.StatusResponse;
        submap_version: number;
        textures: cartographer_ros_msgs.msg.SubmapTexture[];
      }
      export interface SubmapQuery_ResponseConstructor {
        new(other?: SubmapQuery_Response): SubmapQuery_Response;
      }
      export interface WriteStateConstructor extends ROSService {
        readonly Request: WriteState_RequestConstructor;
        readonly Response: WriteState_ResponseConstructor;
      }
      export interface WriteState_Request {
        filename: string;
      }
      export interface WriteState_RequestConstructor {
        new(other?: WriteState_Request): WriteState_Request;
      }
      export interface WriteState_Response {
        status: cartographer_ros_msgs.msg.StatusResponse;
      }
      export interface WriteState_ResponseConstructor {
        new(other?: WriteState_Response): WriteState_Response;
      }
    }
  }

  namespace composition_interfaces {
    namespace srv {
      export interface ListNodesConstructor extends ROSService {
        readonly Request: ListNodes_RequestConstructor;
        readonly Response: ListNodes_ResponseConstructor;
      }
      export interface ListNodes_Request {
      }
      export interface ListNodes_RequestConstructor {
        new(other?: ListNodes_Request): ListNodes_Request;
      }
      export interface ListNodes_Response {
        full_node_names: string[];
        unique_ids: number[];
      }
      export interface ListNodes_ResponseConstructor {
        new(other?: ListNodes_Response): ListNodes_Response;
      }
      export interface LoadNodeConstructor extends ROSService {
        readonly Request: LoadNode_RequestConstructor;
        readonly Response: LoadNode_ResponseConstructor;
      }
      export interface LoadNode_Request {
        package_name: string;
        plugin_name: string;
        node_name: string;
        node_namespace: string;
        log_level: number;
        remap_rules: string[];
        parameters: rcl_interfaces.msg.Parameter[];
        extra_arguments: rcl_interfaces.msg.Parameter[];
      }
      export interface LoadNode_RequestConstructor {
        new(other?: LoadNode_Request): LoadNode_Request;
      }
      export interface LoadNode_Response {
        success: boolean;
        error_message: string;
        full_node_name: string;
        unique_id: number;
      }
      export interface LoadNode_ResponseConstructor {
        new(other?: LoadNode_Response): LoadNode_Response;
      }
      export interface UnloadNodeConstructor extends ROSService {
        readonly Request: UnloadNode_RequestConstructor;
        readonly Response: UnloadNode_ResponseConstructor;
      }
      export interface UnloadNode_Request {
        unique_id: number;
      }
      export interface UnloadNode_RequestConstructor {
        new(other?: UnloadNode_Request): UnloadNode_Request;
      }
      export interface UnloadNode_Response {
        success: boolean;
        error_message: string;
      }
      export interface UnloadNode_ResponseConstructor {
        new(other?: UnloadNode_Response): UnloadNode_Response;
      }
    }
  }

  namespace control_msgs {
    namespace action {
      export interface FollowJointTrajectoryConstructor {
        readonly Goal: FollowJointTrajectory_GoalConstructor;
        readonly Result: FollowJointTrajectory_ResultConstructor;
        readonly Feedback: FollowJointTrajectory_FeedbackConstructor;
      }
      export interface FollowJointTrajectory_Feedback {
        header: std_msgs.msg.Header;
        joint_names: string[];
        desired: trajectory_msgs.msg.JointTrajectoryPoint;
        actual: trajectory_msgs.msg.JointTrajectoryPoint;
        error: trajectory_msgs.msg.JointTrajectoryPoint;
      }
      export interface FollowJointTrajectory_FeedbackConstructor {
        new(other?: FollowJointTrajectory_Feedback): FollowJointTrajectory_Feedback;
      }
      export interface FollowJointTrajectory_FeedbackMessage {
        goal_id: unique_identifier_msgs.msg.UUID;
        feedback: control_msgs.action.FollowJointTrajectory_Feedback;
      }
      export interface FollowJointTrajectory_FeedbackMessageConstructor {
        new(other?: FollowJointTrajectory_FeedbackMessage): FollowJointTrajectory_FeedbackMessage;
      }
      export interface FollowJointTrajectory_GetResultConstructor extends ROSService {
        readonly Request: FollowJointTrajectory_GetResult_RequestConstructor;
        readonly Response: FollowJointTrajectory_GetResult_ResponseConstructor;
      }
      export interface FollowJointTrajectory_GetResult_Request {
        goal_id: unique_identifier_msgs.msg.UUID;
      }
      export interface FollowJointTrajectory_GetResult_RequestConstructor {
        new(other?: FollowJointTrajectory_GetResult_Request): FollowJointTrajectory_GetResult_Request;
      }
      export interface FollowJointTrajectory_GetResult_Response {
        status: number;
        result: control_msgs.action.FollowJointTrajectory_Result;
      }
      export interface FollowJointTrajectory_GetResult_ResponseConstructor {
        new(other?: FollowJointTrajectory_GetResult_Response): FollowJointTrajectory_GetResult_Response;
      }
      export interface FollowJointTrajectory_Goal {
        trajectory: trajectory_msgs.msg.JointTrajectory;
        path_tolerance: control_msgs.msg.JointTolerance[];
        goal_tolerance: control_msgs.msg.JointTolerance[];
        goal_time_tolerance: builtin_interfaces.msg.Duration;
      }
      export interface FollowJointTrajectory_GoalConstructor {
        new(other?: FollowJointTrajectory_Goal): FollowJointTrajectory_Goal;
      }
      export interface FollowJointTrajectory_Result {
        error_code: number;
        error_string: string;
      }
      export interface FollowJointTrajectory_ResultConstructor {
        readonly SUCCESSFUL: number;
        readonly INVALID_GOAL: number;
        readonly INVALID_JOINTS: number;
        readonly OLD_HEADER_TIMESTAMP: number;
        readonly PATH_TOLERANCE_VIOLATED: number;
        readonly GOAL_TOLERANCE_VIOLATED: number;
        new(other?: FollowJointTrajectory_Result): FollowJointTrajectory_Result;
      }
      export interface FollowJointTrajectory_SendGoalConstructor extends ROSService {
        readonly Request: FollowJointTrajectory_SendGoal_RequestConstructor;
        readonly Response: FollowJointTrajectory_SendGoal_ResponseConstructor;
      }
      export interface FollowJointTrajectory_SendGoal_Request {
        goal_id: unique_identifier_msgs.msg.UUID;
        goal: control_msgs.action.FollowJointTrajectory_Goal;
      }
      export interface FollowJointTrajectory_SendGoal_RequestConstructor {
        new(other?: FollowJointTrajectory_SendGoal_Request): FollowJointTrajectory_SendGoal_Request;
      }
      export interface FollowJointTrajectory_SendGoal_Response {
        accepted: boolean;
        stamp: builtin_interfaces.msg.Time;
      }
      export interface FollowJointTrajectory_SendGoal_ResponseConstructor {
        new(other?: FollowJointTrajectory_SendGoal_Response): FollowJointTrajectory_SendGoal_Response;
      }
      export interface GripperCommandConstructor {
        readonly Goal: GripperCommand_GoalConstructor;
        readonly Result: GripperCommand_ResultConstructor;
        readonly Feedback: GripperCommand_FeedbackConstructor;
      }
      export interface GripperCommand_Feedback {
        position: number;
        effort: number;
        stalled: boolean;
        reached_goal: boolean;
      }
      export interface GripperCommand_FeedbackConstructor {
        new(other?: GripperCommand_Feedback): GripperCommand_Feedback;
      }
      export interface GripperCommand_FeedbackMessage {
        goal_id: unique_identifier_msgs.msg.UUID;
        feedback: control_msgs.action.GripperCommand_Feedback;
      }
      export interface GripperCommand_FeedbackMessageConstructor {
        new(other?: GripperCommand_FeedbackMessage): GripperCommand_FeedbackMessage;
      }
      export interface GripperCommand_GetResultConstructor extends ROSService {
        readonly Request: GripperCommand_GetResult_RequestConstructor;
        readonly Response: GripperCommand_GetResult_ResponseConstructor;
      }
      export interface GripperCommand_GetResult_Request {
        goal_id: unique_identifier_msgs.msg.UUID;
      }
      export interface GripperCommand_GetResult_RequestConstructor {
        new(other?: GripperCommand_GetResult_Request): GripperCommand_GetResult_Request;
      }
      export interface GripperCommand_GetResult_Response {
        status: number;
        result: control_msgs.action.GripperCommand_Result;
      }
      export interface GripperCommand_GetResult_ResponseConstructor {
        new(other?: GripperCommand_GetResult_Response): GripperCommand_GetResult_Response;
      }
      export interface GripperCommand_Goal {
        command: control_msgs.msg.GripperCommand;
      }
      export interface GripperCommand_GoalConstructor {
        new(other?: GripperCommand_Goal): GripperCommand_Goal;
      }
      export interface GripperCommand_Result {
        position: number;
        effort: number;
        stalled: boolean;
        reached_goal: boolean;
      }
      export interface GripperCommand_ResultConstructor {
        new(other?: GripperCommand_Result): GripperCommand_Result;
      }
      export interface GripperCommand_SendGoalConstructor extends ROSService {
        readonly Request: GripperCommand_SendGoal_RequestConstructor;
        readonly Response: GripperCommand_SendGoal_ResponseConstructor;
      }
      export interface GripperCommand_SendGoal_Request {
        goal_id: unique_identifier_msgs.msg.UUID;
        goal: control_msgs.action.GripperCommand_Goal;
      }
      export interface GripperCommand_SendGoal_RequestConstructor {
        new(other?: GripperCommand_SendGoal_Request): GripperCommand_SendGoal_Request;
      }
      export interface GripperCommand_SendGoal_Response {
        accepted: boolean;
        stamp: builtin_interfaces.msg.Time;
      }
      export interface GripperCommand_SendGoal_ResponseConstructor {
        new(other?: GripperCommand_SendGoal_Response): GripperCommand_SendGoal_Response;
      }
      export interface JointTrajectoryConstructor {
        readonly Goal: JointTrajectory_GoalConstructor;
        readonly Result: JointTrajectory_ResultConstructor;
        readonly Feedback: JointTrajectory_FeedbackConstructor;
      }
      export interface JointTrajectory_Feedback {
      }
      export interface JointTrajectory_FeedbackConstructor {
        new(other?: JointTrajectory_Feedback): JointTrajectory_Feedback;
      }
      export interface JointTrajectory_FeedbackMessage {
        goal_id: unique_identifier_msgs.msg.UUID;
        feedback: control_msgs.action.JointTrajectory_Feedback;
      }
      export interface JointTrajectory_FeedbackMessageConstructor {
        new(other?: JointTrajectory_FeedbackMessage): JointTrajectory_FeedbackMessage;
      }
      export interface JointTrajectory_GetResultConstructor extends ROSService {
        readonly Request: JointTrajectory_GetResult_RequestConstructor;
        readonly Response: JointTrajectory_GetResult_ResponseConstructor;
      }
      export interface JointTrajectory_GetResult_Request {
        goal_id: unique_identifier_msgs.msg.UUID;
      }
      export interface JointTrajectory_GetResult_RequestConstructor {
        new(other?: JointTrajectory_GetResult_Request): JointTrajectory_GetResult_Request;
      }
      export interface JointTrajectory_GetResult_Response {
        status: number;
        result: control_msgs.action.JointTrajectory_Result;
      }
      export interface JointTrajectory_GetResult_ResponseConstructor {
        new(other?: JointTrajectory_GetResult_Response): JointTrajectory_GetResult_Response;
      }
      export interface JointTrajectory_Goal {
        trajectory: trajectory_msgs.msg.JointTrajectory;
      }
      export interface JointTrajectory_GoalConstructor {
        new(other?: JointTrajectory_Goal): JointTrajectory_Goal;
      }
      export interface JointTrajectory_Result {
      }
      export interface JointTrajectory_ResultConstructor {
        new(other?: JointTrajectory_Result): JointTrajectory_Result;
      }
      export interface JointTrajectory_SendGoalConstructor extends ROSService {
        readonly Request: JointTrajectory_SendGoal_RequestConstructor;
        readonly Response: JointTrajectory_SendGoal_ResponseConstructor;
      }
      export interface JointTrajectory_SendGoal_Request {
        goal_id: unique_identifier_msgs.msg.UUID;
        goal: control_msgs.action.JointTrajectory_Goal;
      }
      export interface JointTrajectory_SendGoal_RequestConstructor {
        new(other?: JointTrajectory_SendGoal_Request): JointTrajectory_SendGoal_Request;
      }
      export interface JointTrajectory_SendGoal_Response {
        accepted: boolean;
        stamp: builtin_interfaces.msg.Time;
      }
      export interface JointTrajectory_SendGoal_ResponseConstructor {
        new(other?: JointTrajectory_SendGoal_Response): JointTrajectory_SendGoal_Response;
      }
      export interface PointHeadConstructor {
        readonly Goal: PointHead_GoalConstructor;
        readonly Result: PointHead_ResultConstructor;
        readonly Feedback: PointHead_FeedbackConstructor;
      }
      export interface PointHead_Feedback {
        pointing_angle_error: number;
      }
      export interface PointHead_FeedbackConstructor {
        new(other?: PointHead_Feedback): PointHead_Feedback;
      }
      export interface PointHead_FeedbackMessage {
        goal_id: unique_identifier_msgs.msg.UUID;
        feedback: control_msgs.action.PointHead_Feedback;
      }
      export interface PointHead_FeedbackMessageConstructor {
        new(other?: PointHead_FeedbackMessage): PointHead_FeedbackMessage;
      }
      export interface PointHead_GetResultConstructor extends ROSService {
        readonly Request: PointHead_GetResult_RequestConstructor;
        readonly Response: PointHead_GetResult_ResponseConstructor;
      }
      export interface PointHead_GetResult_Request {
        goal_id: unique_identifier_msgs.msg.UUID;
      }
      export interface PointHead_GetResult_RequestConstructor {
        new(other?: PointHead_GetResult_Request): PointHead_GetResult_Request;
      }
      export interface PointHead_GetResult_Response {
        status: number;
        result: control_msgs.action.PointHead_Result;
      }
      export interface PointHead_GetResult_ResponseConstructor {
        new(other?: PointHead_GetResult_Response): PointHead_GetResult_Response;
      }
      export interface PointHead_Goal {
        target: geometry_msgs.msg.PointStamped;
        pointing_axis: geometry_msgs.msg.Vector3;
        pointing_frame: string;
        min_duration: builtin_interfaces.msg.Duration;
        max_velocity: number;
      }
      export interface PointHead_GoalConstructor {
        new(other?: PointHead_Goal): PointHead_Goal;
      }
      export interface PointHead_Result {
      }
      export interface PointHead_ResultConstructor {
        new(other?: PointHead_Result): PointHead_Result;
      }
      export interface PointHead_SendGoalConstructor extends ROSService {
        readonly Request: PointHead_SendGoal_RequestConstructor;
        readonly Response: PointHead_SendGoal_ResponseConstructor;
      }
      export interface PointHead_SendGoal_Request {
        goal_id: unique_identifier_msgs.msg.UUID;
        goal: control_msgs.action.PointHead_Goal;
      }
      export interface PointHead_SendGoal_RequestConstructor {
        new(other?: PointHead_SendGoal_Request): PointHead_SendGoal_Request;
      }
      export interface PointHead_SendGoal_Response {
        accepted: boolean;
        stamp: builtin_interfaces.msg.Time;
      }
      export interface PointHead_SendGoal_ResponseConstructor {
        new(other?: PointHead_SendGoal_Response): PointHead_SendGoal_Response;
      }
      export interface SingleJointPositionConstructor {
        readonly Goal: SingleJointPosition_GoalConstructor;
        readonly Result: SingleJointPosition_ResultConstructor;
        readonly Feedback: SingleJointPosition_FeedbackConstructor;
      }
      export interface SingleJointPosition_Feedback {
        header: std_msgs.msg.Header;
        position: number;
        velocity: number;
        error: number;
      }
      export interface SingleJointPosition_FeedbackConstructor {
        new(other?: SingleJointPosition_Feedback): SingleJointPosition_Feedback;
      }
      export interface SingleJointPosition_FeedbackMessage {
        goal_id: unique_identifier_msgs.msg.UUID;
        feedback: control_msgs.action.SingleJointPosition_Feedback;
      }
      export interface SingleJointPosition_FeedbackMessageConstructor {
        new(other?: SingleJointPosition_FeedbackMessage): SingleJointPosition_FeedbackMessage;
      }
      export interface SingleJointPosition_GetResultConstructor extends ROSService {
        readonly Request: SingleJointPosition_GetResult_RequestConstructor;
        readonly Response: SingleJointPosition_GetResult_ResponseConstructor;
      }
      export interface SingleJointPosition_GetResult_Request {
        goal_id: unique_identifier_msgs.msg.UUID;
      }
      export interface SingleJointPosition_GetResult_RequestConstructor {
        new(other?: SingleJointPosition_GetResult_Request): SingleJointPosition_GetResult_Request;
      }
      export interface SingleJointPosition_GetResult_Response {
        status: number;
        result: control_msgs.action.SingleJointPosition_Result;
      }
      export interface SingleJointPosition_GetResult_ResponseConstructor {
        new(other?: SingleJointPosition_GetResult_Response): SingleJointPosition_GetResult_Response;
      }
      export interface SingleJointPosition_Goal {
        position: number;
        min_duration: builtin_interfaces.msg.Duration;
        max_velocity: number;
      }
      export interface SingleJointPosition_GoalConstructor {
        new(other?: SingleJointPosition_Goal): SingleJointPosition_Goal;
      }
      export interface SingleJointPosition_Result {
      }
      export interface SingleJointPosition_ResultConstructor {
        new(other?: SingleJointPosition_Result): SingleJointPosition_Result;
      }
      export interface SingleJointPosition_SendGoalConstructor extends ROSService {
        readonly Request: SingleJointPosition_SendGoal_RequestConstructor;
        readonly Response: SingleJointPosition_SendGoal_ResponseConstructor;
      }
      export interface SingleJointPosition_SendGoal_Request {
        goal_id: unique_identifier_msgs.msg.UUID;
        goal: control_msgs.action.SingleJointPosition_Goal;
      }
      export interface SingleJointPosition_SendGoal_RequestConstructor {
        new(other?: SingleJointPosition_SendGoal_Request): SingleJointPosition_SendGoal_Request;
      }
      export interface SingleJointPosition_SendGoal_Response {
        accepted: boolean;
        stamp: builtin_interfaces.msg.Time;
      }
      export interface SingleJointPosition_SendGoal_ResponseConstructor {
        new(other?: SingleJointPosition_SendGoal_Response): SingleJointPosition_SendGoal_Response;
      }
    }
    namespace msg {
      export interface DynamicJointState {
        header: std_msgs.msg.Header;
        joint_names: string[];
        interface_values: control_msgs.msg.InterfaceValue[];
      }
      export interface DynamicJointStateConstructor {
        new(other?: DynamicJointState): DynamicJointState;
      }
      export interface GripperCommand {
        position: number;
        max_effort: number;
      }
      export interface GripperCommandConstructor {
        new(other?: GripperCommand): GripperCommand;
      }
      export interface InterfaceValue {
        interface_names: string[];
        values: number[] | Float64Array;
      }
      export interface InterfaceValueConstructor {
        new(other?: InterfaceValue): InterfaceValue;
      }
      export interface JointControllerState {
        header: std_msgs.msg.Header;
        set_point: number;
        process_value: number;
        process_value_dot: number;
        error: number;
        time_step: number;
        command: number;
        p: number;
        i: number;
        d: number;
        i_clamp: number;
        antiwindup: boolean;
      }
      export interface JointControllerStateConstructor {
        new(other?: JointControllerState): JointControllerState;
      }
      export interface JointJog {
        header: std_msgs.msg.Header;
        joint_names: string[];
        displacements: number[] | Float64Array;
        velocities: number[] | Float64Array;
        duration: number;
      }
      export interface JointJogConstructor {
        new(other?: JointJog): JointJog;
      }
      export interface JointTolerance {
        name: string;
        position: number;
        velocity: number;
        acceleration: number;
      }
      export interface JointToleranceConstructor {
        new(other?: JointTolerance): JointTolerance;
      }
      export interface JointTrajectoryControllerState {
        header: std_msgs.msg.Header;
        joint_names: string[];
        desired: trajectory_msgs.msg.JointTrajectoryPoint;
        actual: trajectory_msgs.msg.JointTrajectoryPoint;
        error: trajectory_msgs.msg.JointTrajectoryPoint;
      }
      export interface JointTrajectoryControllerStateConstructor {
        new(other?: JointTrajectoryControllerState): JointTrajectoryControllerState;
      }
      export interface PidState {
        header: std_msgs.msg.Header;
        timestep: builtin_interfaces.msg.Duration;
        error: number;
        error_dot: number;
        p_error: number;
        i_error: number;
        d_error: number;
        p_term: number;
        i_term: number;
        d_term: number;
        i_max: number;
        i_min: number;
        output: number;
      }
      export interface PidStateConstructor {
        new(other?: PidState): PidState;
      }
    }
    namespace srv {
      export interface QueryCalibrationStateConstructor extends ROSService {
        readonly Request: QueryCalibrationState_RequestConstructor;
        readonly Response: QueryCalibrationState_ResponseConstructor;
      }
      export interface QueryCalibrationState_Request {
      }
      export interface QueryCalibrationState_RequestConstructor {
        new(other?: QueryCalibrationState_Request): QueryCalibrationState_Request;
      }
      export interface QueryCalibrationState_Response {
        is_calibrated: boolean;
      }
      export interface QueryCalibrationState_ResponseConstructor {
        new(other?: QueryCalibrationState_Response): QueryCalibrationState_Response;
      }
      export interface QueryTrajectoryStateConstructor extends ROSService {
        readonly Request: QueryTrajectoryState_RequestConstructor;
        readonly Response: QueryTrajectoryState_ResponseConstructor;
      }
      export interface QueryTrajectoryState_Request {
        time: builtin_interfaces.msg.Time;
      }
      export interface QueryTrajectoryState_RequestConstructor {
        new(other?: QueryTrajectoryState_Request): QueryTrajectoryState_Request;
      }
      export interface QueryTrajectoryState_Response {
        success: boolean;
        message: string;
        name: string[];
        position: number[] | Float64Array;
        velocity: number[] | Float64Array;
        acceleration: number[] | Float64Array;
      }
      export interface QueryTrajectoryState_ResponseConstructor {
        new(other?: QueryTrajectoryState_Response): QueryTrajectoryState_Response;
      }
    }
  }

  namespace diagnostic_msgs {
    namespace msg {
      export interface DiagnosticArray {
        header: std_msgs.msg.Header;
        status: diagnostic_msgs.msg.DiagnosticStatus[];
      }
      export interface DiagnosticArrayConstructor {
        new(other?: DiagnosticArray): DiagnosticArray;
      }
      export interface DiagnosticStatus {
        level: number;
        name: string;
        message: string;
        hardware_id: string;
        values: diagnostic_msgs.msg.KeyValue[];
      }
      export interface DiagnosticStatusConstructor {
        readonly OK: number;
        readonly WARN: number;
        readonly ERROR: number;
        readonly STALE: number;
        new(other?: DiagnosticStatus): DiagnosticStatus;
      }
      export interface KeyValue {
        key: string;
        value: string;
      }
      export interface KeyValueConstructor {
        new(other?: KeyValue): KeyValue;
      }
    }
    namespace srv {
      export interface AddDiagnosticsConstructor extends ROSService {
        readonly Request: AddDiagnostics_RequestConstructor;
        readonly Response: AddDiagnostics_ResponseConstructor;
      }
      export interface AddDiagnostics_Request {
        load_namespace: string;
      }
      export interface AddDiagnostics_RequestConstructor {
        new(other?: AddDiagnostics_Request): AddDiagnostics_Request;
      }
      export interface AddDiagnostics_Response {
        success: boolean;
        message: string;
      }
      export interface AddDiagnostics_ResponseConstructor {
        new(other?: AddDiagnostics_Response): AddDiagnostics_Response;
      }
      export interface SelfTestConstructor extends ROSService {
        readonly Request: SelfTest_RequestConstructor;
        readonly Response: SelfTest_ResponseConstructor;
      }
      export interface SelfTest_Request {
      }
      export interface SelfTest_RequestConstructor {
        new(other?: SelfTest_Request): SelfTest_Request;
      }
      export interface SelfTest_Response {
        id: string;
        passed: number;
        status: diagnostic_msgs.msg.DiagnosticStatus[];
      }
      export interface SelfTest_ResponseConstructor {
        new(other?: SelfTest_Response): SelfTest_Response;
      }
    }
  }

  namespace geometry_msgs {
    namespace msg {
      export interface Accel {
        linear: geometry_msgs.msg.Vector3;
        angular: geometry_msgs.msg.Vector3;
      }
      export interface AccelConstructor {
        new(other?: Accel): Accel;
      }
      export interface AccelStamped {
        header: std_msgs.msg.Header;
        accel: geometry_msgs.msg.Accel;
      }
      export interface AccelStampedConstructor {
        new(other?: AccelStamped): AccelStamped;
      }
      export interface AccelWithCovariance {
        accel: geometry_msgs.msg.Accel;
        covariance: number[] | Float64Array;
      }
      export interface AccelWithCovarianceConstructor {
        new(other?: AccelWithCovariance): AccelWithCovariance;
      }
      export interface AccelWithCovarianceStamped {
        header: std_msgs.msg.Header;
        accel: geometry_msgs.msg.AccelWithCovariance;
      }
      export interface AccelWithCovarianceStampedConstructor {
        new(other?: AccelWithCovarianceStamped): AccelWithCovarianceStamped;
      }
      export interface Inertia {
        m: number;
        com: geometry_msgs.msg.Vector3;
        ixx: number;
        ixy: number;
        ixz: number;
        iyy: number;
        iyz: number;
        izz: number;
      }
      export interface InertiaConstructor {
        new(other?: Inertia): Inertia;
      }
      export interface InertiaStamped {
        header: std_msgs.msg.Header;
        inertia: geometry_msgs.msg.Inertia;
      }
      export interface InertiaStampedConstructor {
        new(other?: InertiaStamped): InertiaStamped;
      }
      export interface Point {
        x: number;
        y: number;
        z: number;
      }
      export interface PointConstructor {
        new(other?: Point): Point;
      }
      export interface Point32 {
        x: number;
        y: number;
        z: number;
      }
      export interface Point32Constructor {
        new(other?: Point32): Point32;
      }
      export interface PointStamped {
        header: std_msgs.msg.Header;
        point: geometry_msgs.msg.Point;
      }
      export interface PointStampedConstructor {
        new(other?: PointStamped): PointStamped;
      }
      export interface Polygon {
        points: geometry_msgs.msg.Point32[];
      }
      export interface PolygonConstructor {
        new(other?: Polygon): Polygon;
      }
      export interface PolygonStamped {
        header: std_msgs.msg.Header;
        polygon: geometry_msgs.msg.Polygon;
      }
      export interface PolygonStampedConstructor {
        new(other?: PolygonStamped): PolygonStamped;
      }
      export interface Pose {
        position: geometry_msgs.msg.Point;
        orientation: geometry_msgs.msg.Quaternion;
      }
      export interface PoseConstructor {
        new(other?: Pose): Pose;
      }
      export interface Pose2D {
        x: number;
        y: number;
        theta: number;
      }
      export interface Pose2DConstructor {
        new(other?: Pose2D): Pose2D;
      }
      export interface PoseArray {
        header: std_msgs.msg.Header;
        poses: geometry_msgs.msg.Pose[];
      }
      export interface PoseArrayConstructor {
        new(other?: PoseArray): PoseArray;
      }
      export interface PoseStamped {
        header: std_msgs.msg.Header;
        pose: geometry_msgs.msg.Pose;
      }
      export interface PoseStampedConstructor {
        new(other?: PoseStamped): PoseStamped;
      }
      export interface PoseWithCovariance {
        pose: geometry_msgs.msg.Pose;
        covariance: number[] | Float64Array;
      }
      export interface PoseWithCovarianceConstructor {
        new(other?: PoseWithCovariance): PoseWithCovariance;
      }
      export interface PoseWithCovarianceStamped {
        header: std_msgs.msg.Header;
        pose: geometry_msgs.msg.PoseWithCovariance;
      }
      export interface PoseWithCovarianceStampedConstructor {
        new(other?: PoseWithCovarianceStamped): PoseWithCovarianceStamped;
      }
      export interface Quaternion {
        x: number;
        y: number;
        z: number;
        w: number;
      }
      export interface QuaternionConstructor {
        new(other?: Quaternion): Quaternion;
      }
      export interface QuaternionStamped {
        header: std_msgs.msg.Header;
        quaternion: geometry_msgs.msg.Quaternion;
      }
      export interface QuaternionStampedConstructor {
        new(other?: QuaternionStamped): QuaternionStamped;
      }
      export interface Transform {
        translation: geometry_msgs.msg.Vector3;
        rotation: geometry_msgs.msg.Quaternion;
      }
      export interface TransformConstructor {
        new(other?: Transform): Transform;
      }
      export interface TransformStamped {
        header: std_msgs.msg.Header;
        child_frame_id: string;
        transform: geometry_msgs.msg.Transform;
      }
      export interface TransformStampedConstructor {
        new(other?: TransformStamped): TransformStamped;
      }
      export interface Twist {
        linear: geometry_msgs.msg.Vector3;
        angular: geometry_msgs.msg.Vector3;
      }
      export interface TwistConstructor {
        new(other?: Twist): Twist;
      }
      export interface TwistStamped {
        header: std_msgs.msg.Header;
        twist: geometry_msgs.msg.Twist;
      }
      export interface TwistStampedConstructor {
        new(other?: TwistStamped): TwistStamped;
      }
      export interface TwistWithCovariance {
        twist: geometry_msgs.msg.Twist;
        covariance: number[] | Float64Array;
      }
      export interface TwistWithCovarianceConstructor {
        new(other?: TwistWithCovariance): TwistWithCovariance;
      }
      export interface TwistWithCovarianceStamped {
        header: std_msgs.msg.Header;
        twist: geometry_msgs.msg.TwistWithCovariance;
      }
      export interface TwistWithCovarianceStampedConstructor {
        new(other?: TwistWithCovarianceStamped): TwistWithCovarianceStamped;
      }
      export interface Vector3 {
        x: number;
        y: number;
        z: number;
      }
      export interface Vector3Constructor {
        new(other?: Vector3): Vector3;
      }
      export interface Vector3Stamped {
        header: std_msgs.msg.Header;
        vector: geometry_msgs.msg.Vector3;
      }
      export interface Vector3StampedConstructor {
        new(other?: Vector3Stamped): Vector3Stamped;
      }
      export interface Wrench {
        force: geometry_msgs.msg.Vector3;
        torque: geometry_msgs.msg.Vector3;
      }
      export interface WrenchConstructor {
        new(other?: Wrench): Wrench;
      }
      export interface WrenchStamped {
        header: std_msgs.msg.Header;
        wrench: geometry_msgs.msg.Wrench;
      }
      export interface WrenchStampedConstructor {
        new(other?: WrenchStamped): WrenchStamped;
      }
    }
  }

  namespace libstatistics_collector {
    namespace msg {
      export interface DummyMessage {
        header: std_msgs.msg.Header;
      }
      export interface DummyMessageConstructor {
        new(other?: DummyMessage): DummyMessage;
      }
    }
  }

  namespace lifecycle_msgs {
    namespace msg {
      export interface State {
        id: number;
        label: string;
      }
      export interface StateConstructor {
        readonly PRIMARY_STATE_UNKNOWN: number;
        readonly PRIMARY_STATE_UNCONFIGURED: number;
        readonly PRIMARY_STATE_INACTIVE: number;
        readonly PRIMARY_STATE_ACTIVE: number;
        readonly PRIMARY_STATE_FINALIZED: number;
        readonly TRANSITION_STATE_CONFIGURING: number;
        readonly TRANSITION_STATE_CLEANINGUP: number;
        readonly TRANSITION_STATE_SHUTTINGDOWN: number;
        readonly TRANSITION_STATE_ACTIVATING: number;
        readonly TRANSITION_STATE_DEACTIVATING: number;
        readonly TRANSITION_STATE_ERRORPROCESSING: number;
        new(other?: State): State;
      }
      export interface Transition {
        id: number;
        label: string;
      }
      export interface TransitionConstructor {
        readonly TRANSITION_CREATE: number;
        readonly TRANSITION_CONFIGURE: number;
        readonly TRANSITION_CLEANUP: number;
        readonly TRANSITION_ACTIVATE: number;
        readonly TRANSITION_DEACTIVATE: number;
        readonly TRANSITION_UNCONFIGURED_SHUTDOWN: number;
        readonly TRANSITION_INACTIVE_SHUTDOWN: number;
        readonly TRANSITION_ACTIVE_SHUTDOWN: number;
        readonly TRANSITION_DESTROY: number;
        readonly TRANSITION_ON_CONFIGURE_SUCCESS: number;
        readonly TRANSITION_ON_CONFIGURE_FAILURE: number;
        readonly TRANSITION_ON_CONFIGURE_ERROR: number;
        readonly TRANSITION_ON_CLEANUP_SUCCESS: number;
        readonly TRANSITION_ON_CLEANUP_FAILURE: number;
        readonly TRANSITION_ON_CLEANUP_ERROR: number;
        readonly TRANSITION_ON_ACTIVATE_SUCCESS: number;
        readonly TRANSITION_ON_ACTIVATE_FAILURE: number;
        readonly TRANSITION_ON_ACTIVATE_ERROR: number;
        readonly TRANSITION_ON_DEACTIVATE_SUCCESS: number;
        readonly TRANSITION_ON_DEACTIVATE_FAILURE: number;
        readonly TRANSITION_ON_DEACTIVATE_ERROR: number;
        readonly TRANSITION_ON_SHUTDOWN_SUCCESS: number;
        readonly TRANSITION_ON_SHUTDOWN_FAILURE: number;
        readonly TRANSITION_ON_SHUTDOWN_ERROR: number;
        readonly TRANSITION_ON_ERROR_SUCCESS: number;
        readonly TRANSITION_ON_ERROR_FAILURE: number;
        readonly TRANSITION_ON_ERROR_ERROR: number;
        readonly TRANSITION_CALLBACK_SUCCESS: number;
        readonly TRANSITION_CALLBACK_FAILURE: number;
        readonly TRANSITION_CALLBACK_ERROR: number;
        new(other?: Transition): Transition;
      }
      export interface TransitionDescription {
        transition: lifecycle_msgs.msg.Transition;
        start_state: lifecycle_msgs.msg.State;
        goal_state: lifecycle_msgs.msg.State;
      }
      export interface TransitionDescriptionConstructor {
        new(other?: TransitionDescription): TransitionDescription;
      }
      export interface TransitionEvent {
        timestamp: number;
        transition: lifecycle_msgs.msg.Transition;
        start_state: lifecycle_msgs.msg.State;
        goal_state: lifecycle_msgs.msg.State;
      }
      export interface TransitionEventConstructor {
        new(other?: TransitionEvent): TransitionEvent;
      }
    }
    namespace srv {
      export interface ChangeStateConstructor extends ROSService {
        readonly Request: ChangeState_RequestConstructor;
        readonly Response: ChangeState_ResponseConstructor;
      }
      export interface ChangeState_Request {
        transition: lifecycle_msgs.msg.Transition;
      }
      export interface ChangeState_RequestConstructor {
        new(other?: ChangeState_Request): ChangeState_Request;
      }
      export interface ChangeState_Response {
        success: boolean;
      }
      export interface ChangeState_ResponseConstructor {
        new(other?: ChangeState_Response): ChangeState_Response;
      }
      export interface GetAvailableStatesConstructor extends ROSService {
        readonly Request: GetAvailableStates_RequestConstructor;
        readonly Response: GetAvailableStates_ResponseConstructor;
      }
      export interface GetAvailableStates_Request {
      }
      export interface GetAvailableStates_RequestConstructor {
        new(other?: GetAvailableStates_Request): GetAvailableStates_Request;
      }
      export interface GetAvailableStates_Response {
        available_states: lifecycle_msgs.msg.State[];
      }
      export interface GetAvailableStates_ResponseConstructor {
        new(other?: GetAvailableStates_Response): GetAvailableStates_Response;
      }
      export interface GetAvailableTransitionsConstructor extends ROSService {
        readonly Request: GetAvailableTransitions_RequestConstructor;
        readonly Response: GetAvailableTransitions_ResponseConstructor;
      }
      export interface GetAvailableTransitions_Request {
      }
      export interface GetAvailableTransitions_RequestConstructor {
        new(other?: GetAvailableTransitions_Request): GetAvailableTransitions_Request;
      }
      export interface GetAvailableTransitions_Response {
        available_transitions: lifecycle_msgs.msg.TransitionDescription[];
      }
      export interface GetAvailableTransitions_ResponseConstructor {
        new(other?: GetAvailableTransitions_Response): GetAvailableTransitions_Response;
      }
      export interface GetStateConstructor extends ROSService {
        readonly Request: GetState_RequestConstructor;
        readonly Response: GetState_ResponseConstructor;
      }
      export interface GetState_Request {
      }
      export interface GetState_RequestConstructor {
        new(other?: GetState_Request): GetState_Request;
      }
      export interface GetState_Response {
        current_state: lifecycle_msgs.msg.State;
      }
      export interface GetState_ResponseConstructor {
        new(other?: GetState_Response): GetState_Response;
      }
    }
  }

  namespace nav_msgs {
    namespace msg {
      export interface GridCells {
        header: std_msgs.msg.Header;
        cell_width: number;
        cell_height: number;
        cells: geometry_msgs.msg.Point[];
      }
      export interface GridCellsConstructor {
        new(other?: GridCells): GridCells;
      }
      export interface MapMetaData {
        map_load_time: builtin_interfaces.msg.Time;
        resolution: number;
        width: number;
        height: number;
        origin: geometry_msgs.msg.Pose;
      }
      export interface MapMetaDataConstructor {
        new(other?: MapMetaData): MapMetaData;
      }
      export interface OccupancyGrid {
        header: std_msgs.msg.Header;
        info: nav_msgs.msg.MapMetaData;
        data: number[] | Int8Array;
      }
      export interface OccupancyGridConstructor {
        new(other?: OccupancyGrid): OccupancyGrid;
      }
      export interface Odometry {
        header: std_msgs.msg.Header;
        child_frame_id: string;
        pose: geometry_msgs.msg.PoseWithCovariance;
        twist: geometry_msgs.msg.TwistWithCovariance;
      }
      export interface OdometryConstructor {
        new(other?: Odometry): Odometry;
      }
      export interface Path {
        header: std_msgs.msg.Header;
        poses: geometry_msgs.msg.PoseStamped[];
      }
      export interface PathConstructor {
        new(other?: Path): Path;
      }
    }
    namespace srv {
      export interface GetMapConstructor extends ROSService {
        readonly Request: GetMap_RequestConstructor;
        readonly Response: GetMap_ResponseConstructor;
      }
      export interface GetMap_Request {
      }
      export interface GetMap_RequestConstructor {
        new(other?: GetMap_Request): GetMap_Request;
      }
      export interface GetMap_Response {
        map: nav_msgs.msg.OccupancyGrid;
      }
      export interface GetMap_ResponseConstructor {
        new(other?: GetMap_Response): GetMap_Response;
      }
      export interface GetPlanConstructor extends ROSService {
        readonly Request: GetPlan_RequestConstructor;
        readonly Response: GetPlan_ResponseConstructor;
      }
      export interface GetPlan_Request {
        start: geometry_msgs.msg.PoseStamped;
        goal: geometry_msgs.msg.PoseStamped;
        tolerance: number;
      }
      export interface GetPlan_RequestConstructor {
        new(other?: GetPlan_Request): GetPlan_Request;
      }
      export interface GetPlan_Response {
        plan: nav_msgs.msg.Path;
      }
      export interface GetPlan_ResponseConstructor {
        new(other?: GetPlan_Response): GetPlan_Response;
      }
      export interface SetMapConstructor extends ROSService {
        readonly Request: SetMap_RequestConstructor;
        readonly Response: SetMap_ResponseConstructor;
      }
      export interface SetMap_Request {
        map: nav_msgs.msg.OccupancyGrid;
        initial_pose: geometry_msgs.msg.PoseWithCovarianceStamped;
      }
      export interface SetMap_RequestConstructor {
        new(other?: SetMap_Request): SetMap_Request;
      }
      export interface SetMap_Response {
        success: boolean;
      }
      export interface SetMap_ResponseConstructor {
        new(other?: SetMap_Response): SetMap_Response;
      }
    }
  }

  namespace ouster_msgs {
    namespace msg {
      export interface Metadata {
        hostname: string;
        lidar_mode: string;
        timestamp_mode: string;
        beam_azimuth_angles: number[] | Float64Array;
        beam_altitude_angles: number[] | Float64Array;
        imu_to_sensor_transform: number[] | Float64Array;
        lidar_to_sensor_transform: number[] | Float64Array;
        serial_no: string;
        firmware_rev: string;
        imu_port: number;
        lidar_port: number;
      }
      export interface MetadataConstructor {
        new(other?: Metadata): Metadata;
      }
    }
    namespace srv {
      export interface GetMetadataConstructor extends ROSService {
        readonly Request: GetMetadata_RequestConstructor;
        readonly Response: GetMetadata_ResponseConstructor;
      }
      export interface GetMetadata_Request {
      }
      export interface GetMetadata_RequestConstructor {
        new(other?: GetMetadata_Request): GetMetadata_Request;
      }
      export interface GetMetadata_Response {
        metadata: ouster_msgs.msg.Metadata;
      }
      export interface GetMetadata_ResponseConstructor {
        new(other?: GetMetadata_Response): GetMetadata_Response;
      }
    }
  }

  namespace pcl_msgs {
    namespace msg {
      export interface ModelCoefficients {
        header: std_msgs.msg.Header;
        values: number[] | Float32Array;
      }
      export interface ModelCoefficientsConstructor {
        new(other?: ModelCoefficients): ModelCoefficients;
      }
      export interface PointIndices {
        header: std_msgs.msg.Header;
        indices: number[] | Int32Array;
      }
      export interface PointIndicesConstructor {
        new(other?: PointIndices): PointIndices;
      }
      export interface PolygonMesh {
        header: std_msgs.msg.Header;
        cloud: sensor_msgs.msg.PointCloud2;
        polygons: pcl_msgs.msg.Vertices[];
      }
      export interface PolygonMeshConstructor {
        new(other?: PolygonMesh): PolygonMesh;
      }
      export interface Vertices {
        vertices: number[] | Uint32Array;
      }
      export interface VerticesConstructor {
        new(other?: Vertices): Vertices;
      }
    }
    namespace srv {
      export interface UpdateFilenameConstructor extends ROSService {
        readonly Request: UpdateFilename_RequestConstructor;
        readonly Response: UpdateFilename_ResponseConstructor;
      }
      export interface UpdateFilename_Request {
        filename: string;
      }
      export interface UpdateFilename_RequestConstructor {
        new(other?: UpdateFilename_Request): UpdateFilename_Request;
      }
      export interface UpdateFilename_Response {
        success: boolean;
      }
      export interface UpdateFilename_ResponseConstructor {
        new(other?: UpdateFilename_Response): UpdateFilename_Response;
      }
    }
  }

  namespace rcl_interfaces {
    namespace msg {
      export interface FloatingPointRange {
        from_value: number;
        to_value: number;
        step: number;
      }
      export interface FloatingPointRangeConstructor {
        new(other?: FloatingPointRange): FloatingPointRange;
      }
      export interface IntegerRange {
        from_value: number;
        to_value: number;
        step: number;
      }
      export interface IntegerRangeConstructor {
        new(other?: IntegerRange): IntegerRange;
      }
      export interface ListParametersResult {
        names: string[];
        prefixes: string[];
      }
      export interface ListParametersResultConstructor {
        new(other?: ListParametersResult): ListParametersResult;
      }
      export interface Log {
        stamp: builtin_interfaces.msg.Time;
        level: number;
        name: string;
        msg: string;
        file: string;
        function: string;
        line: number;
      }
      export interface LogConstructor {
        readonly DEBUG: number;
        readonly INFO: number;
        readonly WARN: number;
        readonly ERROR: number;
        readonly FATAL: number;
        new(other?: Log): Log;
      }
      export interface Parameter {
        name: string;
        value: rcl_interfaces.msg.ParameterValue;
      }
      export interface ParameterConstructor {
        new(other?: Parameter): Parameter;
      }
      export interface ParameterDescriptor {
        name: string;
        type: number;
        description: string;
        additional_constraints: string;
        read_only: boolean;
        floating_point_range: rcl_interfaces.msg.FloatingPointRange[];
        integer_range: rcl_interfaces.msg.IntegerRange[];
      }
      export interface ParameterDescriptorConstructor {
        new(other?: ParameterDescriptor): ParameterDescriptor;
      }
      export interface ParameterEvent {
        stamp: builtin_interfaces.msg.Time;
        node: string;
        new_parameters: rcl_interfaces.msg.Parameter[];
        changed_parameters: rcl_interfaces.msg.Parameter[];
        deleted_parameters: rcl_interfaces.msg.Parameter[];
      }
      export interface ParameterEventConstructor {
        new(other?: ParameterEvent): ParameterEvent;
      }
      export interface ParameterEventDescriptors {
        new_parameters: rcl_interfaces.msg.ParameterDescriptor[];
        changed_parameters: rcl_interfaces.msg.ParameterDescriptor[];
        deleted_parameters: rcl_interfaces.msg.ParameterDescriptor[];
      }
      export interface ParameterEventDescriptorsConstructor {
        new(other?: ParameterEventDescriptors): ParameterEventDescriptors;
      }
      export interface ParameterType {
      }
      export interface ParameterTypeConstructor {
        readonly PARAMETER_NOT_SET: number;
        readonly PARAMETER_BOOL: number;
        readonly PARAMETER_INTEGER: number;
        readonly PARAMETER_DOUBLE: number;
        readonly PARAMETER_STRING: number;
        readonly PARAMETER_BYTE_ARRAY: number;
        readonly PARAMETER_BOOL_ARRAY: number;
        readonly PARAMETER_INTEGER_ARRAY: number;
        readonly PARAMETER_DOUBLE_ARRAY: number;
        readonly PARAMETER_STRING_ARRAY: number;
        new(other?: ParameterType): ParameterType;
      }
      export interface ParameterValue {
        type: number;
        bool_value: boolean;
        integer_value: number;
        double_value: number;
        string_value: string;
        byte_array_value: number[] | Uint8Array;
        bool_array_value: boolean[];
        integer_array_value: number[];
        double_array_value: number[] | Float64Array;
        string_array_value: string[];
      }
      export interface ParameterValueConstructor {
        new(other?: ParameterValue): ParameterValue;
      }
      export interface SetParametersResult {
        successful: boolean;
        reason: string;
      }
      export interface SetParametersResultConstructor {
        new(other?: SetParametersResult): SetParametersResult;
      }
    }
    namespace srv {
      export interface DescribeParametersConstructor extends ROSService {
        readonly Request: DescribeParameters_RequestConstructor;
        readonly Response: DescribeParameters_ResponseConstructor;
      }
      export interface DescribeParameters_Request {
        names: string[];
      }
      export interface DescribeParameters_RequestConstructor {
        new(other?: DescribeParameters_Request): DescribeParameters_Request;
      }
      export interface DescribeParameters_Response {
        descriptors: rcl_interfaces.msg.ParameterDescriptor[];
      }
      export interface DescribeParameters_ResponseConstructor {
        new(other?: DescribeParameters_Response): DescribeParameters_Response;
      }
      export interface GetParameterTypesConstructor extends ROSService {
        readonly Request: GetParameterTypes_RequestConstructor;
        readonly Response: GetParameterTypes_ResponseConstructor;
      }
      export interface GetParameterTypes_Request {
        names: string[];
      }
      export interface GetParameterTypes_RequestConstructor {
        new(other?: GetParameterTypes_Request): GetParameterTypes_Request;
      }
      export interface GetParameterTypes_Response {
        types: number[] | Uint8Array;
      }
      export interface GetParameterTypes_ResponseConstructor {
        new(other?: GetParameterTypes_Response): GetParameterTypes_Response;
      }
      export interface GetParametersConstructor extends ROSService {
        readonly Request: GetParameters_RequestConstructor;
        readonly Response: GetParameters_ResponseConstructor;
      }
      export interface GetParameters_Request {
        names: string[];
      }
      export interface GetParameters_RequestConstructor {
        new(other?: GetParameters_Request): GetParameters_Request;
      }
      export interface GetParameters_Response {
        values: rcl_interfaces.msg.ParameterValue[];
      }
      export interface GetParameters_ResponseConstructor {
        new(other?: GetParameters_Response): GetParameters_Response;
      }
      export interface ListParametersConstructor extends ROSService {
        readonly Request: ListParameters_RequestConstructor;
        readonly Response: ListParameters_ResponseConstructor;
      }
      export interface ListParameters_Request {
        prefixes: string[];
        depth: number;
      }
      export interface ListParameters_RequestConstructor {
        readonly DEPTH_RECURSIVE: number;
        new(other?: ListParameters_Request): ListParameters_Request;
      }
      export interface ListParameters_Response {
        result: rcl_interfaces.msg.ListParametersResult;
      }
      export interface ListParameters_ResponseConstructor {
        new(other?: ListParameters_Response): ListParameters_Response;
      }
      export interface SetParametersConstructor extends ROSService {
        readonly Request: SetParameters_RequestConstructor;
        readonly Response: SetParameters_ResponseConstructor;
      }
      export interface SetParametersAtomicallyConstructor extends ROSService {
        readonly Request: SetParametersAtomically_RequestConstructor;
        readonly Response: SetParametersAtomically_ResponseConstructor;
      }
      export interface SetParametersAtomically_Request {
        parameters: rcl_interfaces.msg.Parameter[];
      }
      export interface SetParametersAtomically_RequestConstructor {
        new(other?: SetParametersAtomically_Request): SetParametersAtomically_Request;
      }
      export interface SetParametersAtomically_Response {
        result: rcl_interfaces.msg.SetParametersResult;
      }
      export interface SetParametersAtomically_ResponseConstructor {
        new(other?: SetParametersAtomically_Response): SetParametersAtomically_Response;
      }
      export interface SetParameters_Request {
        parameters: rcl_interfaces.msg.Parameter[];
      }
      export interface SetParameters_RequestConstructor {
        new(other?: SetParameters_Request): SetParameters_Request;
      }
      export interface SetParameters_Response {
        results: rcl_interfaces.msg.SetParametersResult[];
      }
      export interface SetParameters_ResponseConstructor {
        new(other?: SetParameters_Response): SetParameters_Response;
      }
    }
  }

  namespace rmw_dds_common {
    namespace msg {
      export interface Gid {
        data: number[] | Int8Array;
      }
      export interface GidConstructor {
        new(other?: Gid): Gid;
      }
      export interface NodeEntitiesInfo {
        node_namespace: string;
        node_name: string;
        reader_gid_seq: rmw_dds_common.msg.Gid[];
        writer_gid_seq: rmw_dds_common.msg.Gid[];
      }
      export interface NodeEntitiesInfoConstructor {
        new(other?: NodeEntitiesInfo): NodeEntitiesInfo;
      }
      export interface ParticipantEntitiesInfo {
        gid: rmw_dds_common.msg.Gid;
        node_entities_info_seq: rmw_dds_common.msg.NodeEntitiesInfo[];
      }
      export interface ParticipantEntitiesInfoConstructor {
        new(other?: ParticipantEntitiesInfo): ParticipantEntitiesInfo;
      }
    }
  }

  namespace rosgraph_msgs {
    namespace msg {
      export interface Clock {
        clock: builtin_interfaces.msg.Time;
      }
      export interface ClockConstructor {
        new(other?: Clock): Clock;
      }
    }
  }

  namespace sdr_interfaces {
    namespace action {
      export interface ParkingConstructor {
        readonly Goal: Parking_GoalConstructor;
        readonly Result: Parking_ResultConstructor;
        readonly Feedback: Parking_FeedbackConstructor;
      }
      export interface Parking_Feedback {
        time_elapsed: number;
        tries: number;
      }
      export interface Parking_FeedbackConstructor {
        new(other?: Parking_Feedback): Parking_Feedback;
      }
      export interface Parking_FeedbackMessage {
        goal_id: unique_identifier_msgs.msg.UUID;
        feedback: sdr_interfaces.action.Parking_Feedback;
      }
      export interface Parking_FeedbackMessageConstructor {
        new(other?: Parking_FeedbackMessage): Parking_FeedbackMessage;
      }
      export interface Parking_GetResultConstructor extends ROSService {
        readonly Request: Parking_GetResult_RequestConstructor;
        readonly Response: Parking_GetResult_ResponseConstructor;
      }
      export interface Parking_GetResult_Request {
        goal_id: unique_identifier_msgs.msg.UUID;
      }
      export interface Parking_GetResult_RequestConstructor {
        new(other?: Parking_GetResult_Request): Parking_GetResult_Request;
      }
      export interface Parking_GetResult_Response {
        status: number;
        result: sdr_interfaces.action.Parking_Result;
      }
      export interface Parking_GetResult_ResponseConstructor {
        new(other?: Parking_GetResult_Response): Parking_GetResult_Response;
      }
      export interface Parking_Goal {
        parking_dock: number;
      }
      export interface Parking_GoalConstructor {
        new(other?: Parking_Goal): Parking_Goal;
      }
      export interface Parking_Result {
        successful: number;
      }
      export interface Parking_ResultConstructor {
        new(other?: Parking_Result): Parking_Result;
      }
      export interface Parking_SendGoalConstructor extends ROSService {
        readonly Request: Parking_SendGoal_RequestConstructor;
        readonly Response: Parking_SendGoal_ResponseConstructor;
      }
      export interface Parking_SendGoal_Request {
        goal_id: unique_identifier_msgs.msg.UUID;
        goal: sdr_interfaces.action.Parking_Goal;
      }
      export interface Parking_SendGoal_RequestConstructor {
        new(other?: Parking_SendGoal_Request): Parking_SendGoal_Request;
      }
      export interface Parking_SendGoal_Response {
        accepted: boolean;
        stamp: builtin_interfaces.msg.Time;
      }
      export interface Parking_SendGoal_ResponseConstructor {
        new(other?: Parking_SendGoal_Response): Parking_SendGoal_Response;
      }
    }
    namespace srv {
      export interface AddWaypointConstructor extends ROSService {
        readonly Request: AddWaypoint_RequestConstructor;
        readonly Response: AddWaypoint_ResponseConstructor;
      }
      export interface AddWaypoint_Request {
        id: number;
        name: string;
        wait: number;
        speed: number;
        x: number;
        y: number;
        z: number;
        qx: number;
        qy: number;
        qz: number;
        qw: number;
      }
      export interface AddWaypoint_RequestConstructor {
        new(other?: AddWaypoint_Request): AddWaypoint_Request;
      }
      export interface AddWaypoint_Response {
        response: string;
      }
      export interface AddWaypoint_ResponseConstructor {
        new(other?: AddWaypoint_Response): AddWaypoint_Response;
      }
      export interface RESTBackendConstructor extends ROSService {
        readonly Request: RESTBackend_RequestConstructor;
        readonly Response: RESTBackend_ResponseConstructor;
      }
      export interface RESTBackend_Request {
        id: number;
        string: string;
      }
      export interface RESTBackend_RequestConstructor {
        new(other?: RESTBackend_Request): RESTBackend_Request;
      }
      export interface RESTBackend_Response {
        response: string;
      }
      export interface RESTBackend_ResponseConstructor {
        new(other?: RESTBackend_Response): RESTBackend_Response;
      }
      export interface SwitchVelocityConstructor extends ROSService {
        readonly Request: SwitchVelocity_RequestConstructor;
        readonly Response: SwitchVelocity_ResponseConstructor;
      }
      export interface SwitchVelocity_Request {
        switch_to: string;
      }
      export interface SwitchVelocity_RequestConstructor {
        new(other?: SwitchVelocity_Request): SwitchVelocity_Request;
      }
      export interface SwitchVelocity_Response {
        switched: boolean;
      }
      export interface SwitchVelocity_ResponseConstructor {
        new(other?: SwitchVelocity_Response): SwitchVelocity_Response;
      }
    }
  }

  namespace sensor_msgs {
    namespace msg {
      export interface BatteryState {
        header: std_msgs.msg.Header;
        voltage: number;
        temperature: number;
        current: number;
        charge: number;
        capacity: number;
        design_capacity: number;
        percentage: number;
        power_supply_status: number;
        power_supply_health: number;
        power_supply_technology: number;
        present: boolean;
        cell_voltage: number[] | Float32Array;
        cell_temperature: number[] | Float32Array;
        location: string;
        serial_number: string;
      }
      export interface BatteryStateConstructor {
        readonly POWER_SUPPLY_STATUS_UNKNOWN: number;
        readonly POWER_SUPPLY_STATUS_CHARGING: number;
        readonly POWER_SUPPLY_STATUS_DISCHARGING: number;
        readonly POWER_SUPPLY_STATUS_NOT_CHARGING: number;
        readonly POWER_SUPPLY_STATUS_FULL: number;
        readonly POWER_SUPPLY_HEALTH_UNKNOWN: number;
        readonly POWER_SUPPLY_HEALTH_GOOD: number;
        readonly POWER_SUPPLY_HEALTH_OVERHEAT: number;
        readonly POWER_SUPPLY_HEALTH_DEAD: number;
        readonly POWER_SUPPLY_HEALTH_OVERVOLTAGE: number;
        readonly POWER_SUPPLY_HEALTH_UNSPEC_FAILURE: number;
        readonly POWER_SUPPLY_HEALTH_COLD: number;
        readonly POWER_SUPPLY_HEALTH_WATCHDOG_TIMER_EXPIRE: number;
        readonly POWER_SUPPLY_HEALTH_SAFETY_TIMER_EXPIRE: number;
        readonly POWER_SUPPLY_TECHNOLOGY_UNKNOWN: number;
        readonly POWER_SUPPLY_TECHNOLOGY_NIMH: number;
        readonly POWER_SUPPLY_TECHNOLOGY_LION: number;
        readonly POWER_SUPPLY_TECHNOLOGY_LIPO: number;
        readonly POWER_SUPPLY_TECHNOLOGY_LIFE: number;
        readonly POWER_SUPPLY_TECHNOLOGY_NICD: number;
        readonly POWER_SUPPLY_TECHNOLOGY_LIMN: number;
        new(other?: BatteryState): BatteryState;
      }
      export interface CameraInfo {
        header: std_msgs.msg.Header;
        height: number;
        width: number;
        distortion_model: string;
        d: number[] | Float64Array;
        k: number[] | Float64Array;
        r: number[] | Float64Array;
        p: number[] | Float64Array;
        binning_x: number;
        binning_y: number;
        roi: sensor_msgs.msg.RegionOfInterest;
      }
      export interface CameraInfoConstructor {
        new(other?: CameraInfo): CameraInfo;
      }
      export interface ChannelFloat32 {
        name: string;
        values: number[] | Float32Array;
      }
      export interface ChannelFloat32Constructor {
        new(other?: ChannelFloat32): ChannelFloat32;
      }
      export interface CompressedImage {
        header: std_msgs.msg.Header;
        format: string;
        data: number[] | Uint8Array;
      }
      export interface CompressedImageConstructor {
        new(other?: CompressedImage): CompressedImage;
      }
      export interface FluidPressure {
        header: std_msgs.msg.Header;
        fluid_pressure: number;
        variance: number;
      }
      export interface FluidPressureConstructor {
        new(other?: FluidPressure): FluidPressure;
      }
      export interface Illuminance {
        header: std_msgs.msg.Header;
        illuminance: number;
        variance: number;
      }
      export interface IlluminanceConstructor {
        new(other?: Illuminance): Illuminance;
      }
      export interface Image {
        header: std_msgs.msg.Header;
        height: number;
        width: number;
        encoding: string;
        is_bigendian: number;
        step: number;
        data: number[] | Uint8Array;
      }
      export interface ImageConstructor {
        new(other?: Image): Image;
      }
      export interface Imu {
        header: std_msgs.msg.Header;
        orientation: geometry_msgs.msg.Quaternion;
        orientation_covariance: number[] | Float64Array;
        angular_velocity: geometry_msgs.msg.Vector3;
        angular_velocity_covariance: number[] | Float64Array;
        linear_acceleration: geometry_msgs.msg.Vector3;
        linear_acceleration_covariance: number[] | Float64Array;
      }
      export interface ImuConstructor {
        new(other?: Imu): Imu;
      }
      export interface JointState {
        header: std_msgs.msg.Header;
        name: string[];
        position: number[] | Float64Array;
        velocity: number[] | Float64Array;
        effort: number[] | Float64Array;
      }
      export interface JointStateConstructor {
        new(other?: JointState): JointState;
      }
      export interface Joy {
        header: std_msgs.msg.Header;
        axes: number[] | Float32Array;
        buttons: number[] | Int32Array;
      }
      export interface JoyConstructor {
        new(other?: Joy): Joy;
      }
      export interface JoyFeedback {
        type: number;
        id: number;
        intensity: number;
      }
      export interface JoyFeedbackConstructor {
        readonly TYPE_LED: number;
        readonly TYPE_RUMBLE: number;
        readonly TYPE_BUZZER: number;
        new(other?: JoyFeedback): JoyFeedback;
      }
      export interface JoyFeedbackArray {
        array: sensor_msgs.msg.JoyFeedback[];
      }
      export interface JoyFeedbackArrayConstructor {
        new(other?: JoyFeedbackArray): JoyFeedbackArray;
      }
      export interface LaserEcho {
        echoes: number[] | Float32Array;
      }
      export interface LaserEchoConstructor {
        new(other?: LaserEcho): LaserEcho;
      }
      export interface LaserScan {
        header: std_msgs.msg.Header;
        angle_min: number;
        angle_max: number;
        angle_increment: number;
        time_increment: number;
        scan_time: number;
        range_min: number;
        range_max: number;
        ranges: number[] | Float32Array;
        intensities: number[] | Float32Array;
      }
      export interface LaserScanConstructor {
        new(other?: LaserScan): LaserScan;
      }
      export interface MagneticField {
        header: std_msgs.msg.Header;
        magnetic_field: geometry_msgs.msg.Vector3;
        magnetic_field_covariance: number[] | Float64Array;
      }
      export interface MagneticFieldConstructor {
        new(other?: MagneticField): MagneticField;
      }
      export interface MultiDOFJointState {
        header: std_msgs.msg.Header;
        joint_names: string[];
        transforms: geometry_msgs.msg.Transform[];
        twist: geometry_msgs.msg.Twist[];
        wrench: geometry_msgs.msg.Wrench[];
      }
      export interface MultiDOFJointStateConstructor {
        new(other?: MultiDOFJointState): MultiDOFJointState;
      }
      export interface MultiEchoLaserScan {
        header: std_msgs.msg.Header;
        angle_min: number;
        angle_max: number;
        angle_increment: number;
        time_increment: number;
        scan_time: number;
        range_min: number;
        range_max: number;
        ranges: sensor_msgs.msg.LaserEcho[];
        intensities: sensor_msgs.msg.LaserEcho[];
      }
      export interface MultiEchoLaserScanConstructor {
        new(other?: MultiEchoLaserScan): MultiEchoLaserScan;
      }
      export interface NavSatFix {
        header: std_msgs.msg.Header;
        status: sensor_msgs.msg.NavSatStatus;
        latitude: number;
        longitude: number;
        altitude: number;
        position_covariance: number[] | Float64Array;
        position_covariance_type: number;
      }
      export interface NavSatFixConstructor {
        readonly COVARIANCE_TYPE_UNKNOWN: number;
        readonly COVARIANCE_TYPE_APPROXIMATED: number;
        readonly COVARIANCE_TYPE_DIAGONAL_KNOWN: number;
        readonly COVARIANCE_TYPE_KNOWN: number;
        new(other?: NavSatFix): NavSatFix;
      }
      export interface NavSatStatus {
        status: number;
        service: number;
      }
      export interface NavSatStatusConstructor {
        readonly STATUS_NO_FIX: number;
        readonly STATUS_FIX: number;
        readonly STATUS_SBAS_FIX: number;
        readonly STATUS_GBAS_FIX: number;
        readonly SERVICE_GPS: number;
        readonly SERVICE_GLONASS: number;
        readonly SERVICE_COMPASS: number;
        readonly SERVICE_GALILEO: number;
        new(other?: NavSatStatus): NavSatStatus;
      }
      export interface PointCloud {
        header: std_msgs.msg.Header;
        points: geometry_msgs.msg.Point32[];
        channels: sensor_msgs.msg.ChannelFloat32[];
      }
      export interface PointCloudConstructor {
        new(other?: PointCloud): PointCloud;
      }
      export interface PointCloud2 {
        header: std_msgs.msg.Header;
        height: number;
        width: number;
        fields: sensor_msgs.msg.PointField[];
        is_bigendian: boolean;
        point_step: number;
        row_step: number;
        data: number[] | Uint8Array;
        is_dense: boolean;
      }
      export interface PointCloud2Constructor {
        new(other?: PointCloud2): PointCloud2;
      }
      export interface PointField {
        name: string;
        offset: number;
        datatype: number;
        count: number;
      }
      export interface PointFieldConstructor {
        readonly INT8: number;
        readonly UINT8: number;
        readonly INT16: number;
        readonly UINT16: number;
        readonly INT32: number;
        readonly UINT32: number;
        readonly FLOAT32: number;
        readonly FLOAT64: number;
        new(other?: PointField): PointField;
      }
      export interface Range {
        header: std_msgs.msg.Header;
        radiation_type: number;
        field_of_view: number;
        min_range: number;
        max_range: number;
        range: number;
      }
      export interface RangeConstructor {
        readonly ULTRASOUND: number;
        readonly INFRARED: number;
        new(other?: Range): Range;
      }
      export interface RegionOfInterest {
        x_offset: number;
        y_offset: number;
        height: number;
        width: number;
        do_rectify: boolean;
      }
      export interface RegionOfInterestConstructor {
        new(other?: RegionOfInterest): RegionOfInterest;
      }
      export interface RelativeHumidity {
        header: std_msgs.msg.Header;
        relative_humidity: number;
        variance: number;
      }
      export interface RelativeHumidityConstructor {
        new(other?: RelativeHumidity): RelativeHumidity;
      }
      export interface Temperature {
        header: std_msgs.msg.Header;
        temperature: number;
        variance: number;
      }
      export interface TemperatureConstructor {
        new(other?: Temperature): Temperature;
      }
      export interface TimeReference {
        header: std_msgs.msg.Header;
        time_ref: builtin_interfaces.msg.Time;
        source: string;
      }
      export interface TimeReferenceConstructor {
        new(other?: TimeReference): TimeReference;
      }
    }
    namespace srv {
      export interface SetCameraInfoConstructor extends ROSService {
        readonly Request: SetCameraInfo_RequestConstructor;
        readonly Response: SetCameraInfo_ResponseConstructor;
      }
      export interface SetCameraInfo_Request {
        camera_info: sensor_msgs.msg.CameraInfo;
      }
      export interface SetCameraInfo_RequestConstructor {
        new(other?: SetCameraInfo_Request): SetCameraInfo_Request;
      }
      export interface SetCameraInfo_Response {
        success: boolean;
        status_message: string;
      }
      export interface SetCameraInfo_ResponseConstructor {
        new(other?: SetCameraInfo_Response): SetCameraInfo_Response;
      }
    }
  }

  namespace shape_msgs {
    namespace msg {
      export interface Mesh {
        triangles: shape_msgs.msg.MeshTriangle[];
        vertices: geometry_msgs.msg.Point[];
      }
      export interface MeshConstructor {
        new(other?: Mesh): Mesh;
      }
      export interface MeshTriangle {
        vertex_indices: number[] | Uint32Array;
      }
      export interface MeshTriangleConstructor {
        new(other?: MeshTriangle): MeshTriangle;
      }
      export interface Plane {
        coef: number[] | Float64Array;
      }
      export interface PlaneConstructor {
        new(other?: Plane): Plane;
      }
      export interface SolidPrimitive {
        type: number;
        dimensions: number[] | Float64Array;
      }
      export interface SolidPrimitiveConstructor {
        readonly BOX: number;
        readonly SPHERE: number;
        readonly CYLINDER: number;
        readonly CONE: number;
        readonly BOX_X: number;
        readonly BOX_Y: number;
        readonly BOX_Z: number;
        readonly SPHERE_RADIUS: number;
        readonly CYLINDER_HEIGHT: number;
        readonly CYLINDER_RADIUS: number;
        readonly CONE_HEIGHT: number;
        readonly CONE_RADIUS: number;
        new(other?: SolidPrimitive): SolidPrimitive;
      }
    }
  }

  namespace statistics_msgs {
    namespace msg {
      export interface MetricsMessage {
        measurement_source_name: string;
        metrics_source: string;
        unit: string;
        window_start: builtin_interfaces.msg.Time;
        window_stop: builtin_interfaces.msg.Time;
        statistics: statistics_msgs.msg.StatisticDataPoint[];
      }
      export interface MetricsMessageConstructor {
        new(other?: MetricsMessage): MetricsMessage;
      }
      export interface StatisticDataPoint {
        data_type: number;
        data: number;
      }
      export interface StatisticDataPointConstructor {
        new(other?: StatisticDataPoint): StatisticDataPoint;
      }
      export interface StatisticDataType {
      }
      export interface StatisticDataTypeConstructor {
        readonly STATISTICS_DATA_TYPE_UNINITIALIZED: number;
        readonly STATISTICS_DATA_TYPE_AVERAGE: number;
        readonly STATISTICS_DATA_TYPE_MINIMUM: number;
        readonly STATISTICS_DATA_TYPE_MAXIMUM: number;
        readonly STATISTICS_DATA_TYPE_STDDEV: number;
        readonly STATISTICS_DATA_TYPE_SAMPLE_COUNT: number;
        new(other?: StatisticDataType): StatisticDataType;
      }
    }
  }

  namespace std_msgs {
    namespace msg {
      export interface Bool {
        data: boolean;
      }
      export interface BoolConstructor {
        new(other?: Bool): Bool;
      }
      export interface Byte {
        data: number;
      }
      export interface ByteConstructor {
        new(other?: Byte): Byte;
      }
      export interface ByteMultiArray {
        layout: std_msgs.msg.MultiArrayLayout;
        data: number[] | Uint8Array;
      }
      export interface ByteMultiArrayConstructor {
        new(other?: ByteMultiArray): ByteMultiArray;
      }
      export interface Char {
        data: number;
      }
      export interface CharConstructor {
        new(other?: Char): Char;
      }
      export interface ColorRGBA {
        r: number;
        g: number;
        b: number;
        a: number;
      }
      export interface ColorRGBAConstructor {
        new(other?: ColorRGBA): ColorRGBA;
      }
      export interface Empty {
      }
      export interface EmptyConstructor {
        new(other?: Empty): Empty;
      }
      export interface Float32 {
        data: number;
      }
      export interface Float32Constructor {
        new(other?: Float32): Float32;
      }
      export interface Float32MultiArray {
        layout: std_msgs.msg.MultiArrayLayout;
        data: number[] | Float32Array;
      }
      export interface Float32MultiArrayConstructor {
        new(other?: Float32MultiArray): Float32MultiArray;
      }
      export interface Float64 {
        data: number;
      }
      export interface Float64Constructor {
        new(other?: Float64): Float64;
      }
      export interface Float64MultiArray {
        layout: std_msgs.msg.MultiArrayLayout;
        data: number[] | Float64Array;
      }
      export interface Float64MultiArrayConstructor {
        new(other?: Float64MultiArray): Float64MultiArray;
      }
      export interface Header {
        stamp: builtin_interfaces.msg.Time;
        frame_id: string;
      }
      export interface HeaderConstructor {
        new(other?: Header): Header;
      }
      export interface Int16 {
        data: number;
      }
      export interface Int16Constructor {
        new(other?: Int16): Int16;
      }
      export interface Int16MultiArray {
        layout: std_msgs.msg.MultiArrayLayout;
        data: number[] | Int16Array;
      }
      export interface Int16MultiArrayConstructor {
        new(other?: Int16MultiArray): Int16MultiArray;
      }
      export interface Int32 {
        data: number;
      }
      export interface Int32Constructor {
        new(other?: Int32): Int32;
      }
      export interface Int32MultiArray {
        layout: std_msgs.msg.MultiArrayLayout;
        data: number[] | Int32Array;
      }
      export interface Int32MultiArrayConstructor {
        new(other?: Int32MultiArray): Int32MultiArray;
      }
      export interface Int64 {
        data: number;
      }
      export interface Int64Constructor {
        new(other?: Int64): Int64;
      }
      export interface Int64MultiArray {
        layout: std_msgs.msg.MultiArrayLayout;
        data: number[];
      }
      export interface Int64MultiArrayConstructor {
        new(other?: Int64MultiArray): Int64MultiArray;
      }
      export interface Int8 {
        data: number;
      }
      export interface Int8Constructor {
        new(other?: Int8): Int8;
      }
      export interface Int8MultiArray {
        layout: std_msgs.msg.MultiArrayLayout;
        data: number[] | Int8Array;
      }
      export interface Int8MultiArrayConstructor {
        new(other?: Int8MultiArray): Int8MultiArray;
      }
      export interface MultiArrayDimension {
        label: string;
        size: number;
        stride: number;
      }
      export interface MultiArrayDimensionConstructor {
        new(other?: MultiArrayDimension): MultiArrayDimension;
      }
      export interface MultiArrayLayout {
        dim: std_msgs.msg.MultiArrayDimension[];
        data_offset: number;
      }
      export interface MultiArrayLayoutConstructor {
        new(other?: MultiArrayLayout): MultiArrayLayout;
      }
      export interface String {
        data: string;
      }
      export interface StringConstructor {
        new(other?: String): String;
      }
      export interface UInt16 {
        data: number;
      }
      export interface UInt16Constructor {
        new(other?: UInt16): UInt16;
      }
      export interface UInt16MultiArray {
        layout: std_msgs.msg.MultiArrayLayout;
        data: number[] | Uint16Array;
      }
      export interface UInt16MultiArrayConstructor {
        new(other?: UInt16MultiArray): UInt16MultiArray;
      }
      export interface UInt32 {
        data: number;
      }
      export interface UInt32Constructor {
        new(other?: UInt32): UInt32;
      }
      export interface UInt32MultiArray {
        layout: std_msgs.msg.MultiArrayLayout;
        data: number[] | Uint32Array;
      }
      export interface UInt32MultiArrayConstructor {
        new(other?: UInt32MultiArray): UInt32MultiArray;
      }
      export interface UInt64 {
        data: number;
      }
      export interface UInt64Constructor {
        new(other?: UInt64): UInt64;
      }
      export interface UInt64MultiArray {
        layout: std_msgs.msg.MultiArrayLayout;
        data: number[];
      }
      export interface UInt64MultiArrayConstructor {
        new(other?: UInt64MultiArray): UInt64MultiArray;
      }
      export interface UInt8 {
        data: number;
      }
      export interface UInt8Constructor {
        new(other?: UInt8): UInt8;
      }
      export interface UInt8MultiArray {
        layout: std_msgs.msg.MultiArrayLayout;
        data: number[] | Uint8Array;
      }
      export interface UInt8MultiArrayConstructor {
        new(other?: UInt8MultiArray): UInt8MultiArray;
      }
    }
  }

  namespace std_srvs {
    namespace srv {
      export interface EmptyConstructor extends ROSService {
        readonly Request: Empty_RequestConstructor;
        readonly Response: Empty_ResponseConstructor;
      }
      export interface Empty_Request {
      }
      export interface Empty_RequestConstructor {
        new(other?: Empty_Request): Empty_Request;
      }
      export interface Empty_Response {
      }
      export interface Empty_ResponseConstructor {
        new(other?: Empty_Response): Empty_Response;
      }
      export interface SetBoolConstructor extends ROSService {
        readonly Request: SetBool_RequestConstructor;
        readonly Response: SetBool_ResponseConstructor;
      }
      export interface SetBool_Request {
        data: boolean;
      }
      export interface SetBool_RequestConstructor {
        new(other?: SetBool_Request): SetBool_Request;
      }
      export interface SetBool_Response {
        success: boolean;
        message: string;
      }
      export interface SetBool_ResponseConstructor {
        new(other?: SetBool_Response): SetBool_Response;
      }
      export interface TriggerConstructor extends ROSService {
        readonly Request: Trigger_RequestConstructor;
        readonly Response: Trigger_ResponseConstructor;
      }
      export interface Trigger_Request {
      }
      export interface Trigger_RequestConstructor {
        new(other?: Trigger_Request): Trigger_Request;
      }
      export interface Trigger_Response {
        success: boolean;
        message: string;
      }
      export interface Trigger_ResponseConstructor {
        new(other?: Trigger_Response): Trigger_Response;
      }
    }
  }

  namespace stereo_msgs {
    namespace msg {
      export interface DisparityImage {
        header: std_msgs.msg.Header;
        image: sensor_msgs.msg.Image;
        f: number;
        t: number;
        valid_window: sensor_msgs.msg.RegionOfInterest;
        min_disparity: number;
        max_disparity: number;
        delta_d: number;
      }
      export interface DisparityImageConstructor {
        new(other?: DisparityImage): DisparityImage;
      }
    }
  }

  namespace teleop_tools_msgs {
    namespace action {
      export interface IncrementConstructor {
        readonly Goal: Increment_GoalConstructor;
        readonly Result: Increment_ResultConstructor;
        readonly Feedback: Increment_FeedbackConstructor;
      }
      export interface Increment_Feedback {
      }
      export interface Increment_FeedbackConstructor {
        new(other?: Increment_Feedback): Increment_Feedback;
      }
      export interface Increment_FeedbackMessage {
        goal_id: unique_identifier_msgs.msg.UUID;
        feedback: teleop_tools_msgs.action.Increment_Feedback;
      }
      export interface Increment_FeedbackMessageConstructor {
        new(other?: Increment_FeedbackMessage): Increment_FeedbackMessage;
      }
      export interface Increment_GetResultConstructor extends ROSService {
        readonly Request: Increment_GetResult_RequestConstructor;
        readonly Response: Increment_GetResult_ResponseConstructor;
      }
      export interface Increment_GetResult_Request {
        goal_id: unique_identifier_msgs.msg.UUID;
      }
      export interface Increment_GetResult_RequestConstructor {
        new(other?: Increment_GetResult_Request): Increment_GetResult_Request;
      }
      export interface Increment_GetResult_Response {
        status: number;
        result: teleop_tools_msgs.action.Increment_Result;
      }
      export interface Increment_GetResult_ResponseConstructor {
        new(other?: Increment_GetResult_Response): Increment_GetResult_Response;
      }
      export interface Increment_Goal {
        increment_by: number[] | Float32Array;
      }
      export interface Increment_GoalConstructor {
        new(other?: Increment_Goal): Increment_Goal;
      }
      export interface Increment_Result {
      }
      export interface Increment_ResultConstructor {
        new(other?: Increment_Result): Increment_Result;
      }
      export interface Increment_SendGoalConstructor extends ROSService {
        readonly Request: Increment_SendGoal_RequestConstructor;
        readonly Response: Increment_SendGoal_ResponseConstructor;
      }
      export interface Increment_SendGoal_Request {
        goal_id: unique_identifier_msgs.msg.UUID;
        goal: teleop_tools_msgs.action.Increment_Goal;
      }
      export interface Increment_SendGoal_RequestConstructor {
        new(other?: Increment_SendGoal_Request): Increment_SendGoal_Request;
      }
      export interface Increment_SendGoal_Response {
        accepted: boolean;
        stamp: builtin_interfaces.msg.Time;
      }
      export interface Increment_SendGoal_ResponseConstructor {
        new(other?: Increment_SendGoal_Response): Increment_SendGoal_Response;
      }
    }
  }

  namespace tf2_msgs {
    namespace action {
      export interface LookupTransformConstructor {
        readonly Goal: LookupTransform_GoalConstructor;
        readonly Result: LookupTransform_ResultConstructor;
        readonly Feedback: LookupTransform_FeedbackConstructor;
      }
      export interface LookupTransform_Feedback {
      }
      export interface LookupTransform_FeedbackConstructor {
        new(other?: LookupTransform_Feedback): LookupTransform_Feedback;
      }
      export interface LookupTransform_FeedbackMessage {
        goal_id: unique_identifier_msgs.msg.UUID;
        feedback: tf2_msgs.action.LookupTransform_Feedback;
      }
      export interface LookupTransform_FeedbackMessageConstructor {
        new(other?: LookupTransform_FeedbackMessage): LookupTransform_FeedbackMessage;
      }
      export interface LookupTransform_GetResultConstructor extends ROSService {
        readonly Request: LookupTransform_GetResult_RequestConstructor;
        readonly Response: LookupTransform_GetResult_ResponseConstructor;
      }
      export interface LookupTransform_GetResult_Request {
        goal_id: unique_identifier_msgs.msg.UUID;
      }
      export interface LookupTransform_GetResult_RequestConstructor {
        new(other?: LookupTransform_GetResult_Request): LookupTransform_GetResult_Request;
      }
      export interface LookupTransform_GetResult_Response {
        status: number;
        result: tf2_msgs.action.LookupTransform_Result;
      }
      export interface LookupTransform_GetResult_ResponseConstructor {
        new(other?: LookupTransform_GetResult_Response): LookupTransform_GetResult_Response;
      }
      export interface LookupTransform_Goal {
        target_frame: string;
        source_frame: string;
        source_time: builtin_interfaces.msg.Time;
        timeout: builtin_interfaces.msg.Duration;
        target_time: builtin_interfaces.msg.Time;
        fixed_frame: string;
        advanced: boolean;
      }
      export interface LookupTransform_GoalConstructor {
        new(other?: LookupTransform_Goal): LookupTransform_Goal;
      }
      export interface LookupTransform_Result {
        transform: geometry_msgs.msg.TransformStamped;
        error: tf2_msgs.msg.TF2Error;
      }
      export interface LookupTransform_ResultConstructor {
        new(other?: LookupTransform_Result): LookupTransform_Result;
      }
      export interface LookupTransform_SendGoalConstructor extends ROSService {
        readonly Request: LookupTransform_SendGoal_RequestConstructor;
        readonly Response: LookupTransform_SendGoal_ResponseConstructor;
      }
      export interface LookupTransform_SendGoal_Request {
        goal_id: unique_identifier_msgs.msg.UUID;
        goal: tf2_msgs.action.LookupTransform_Goal;
      }
      export interface LookupTransform_SendGoal_RequestConstructor {
        new(other?: LookupTransform_SendGoal_Request): LookupTransform_SendGoal_Request;
      }
      export interface LookupTransform_SendGoal_Response {
        accepted: boolean;
        stamp: builtin_interfaces.msg.Time;
      }
      export interface LookupTransform_SendGoal_ResponseConstructor {
        new(other?: LookupTransform_SendGoal_Response): LookupTransform_SendGoal_Response;
      }
    }
    namespace msg {
      export interface TF2Error {
        error: number;
        error_string: string;
      }
      export interface TF2ErrorConstructor {
        readonly NO_ERROR: number;
        readonly LOOKUP_ERROR: number;
        readonly CONNECTIVITY_ERROR: number;
        readonly EXTRAPOLATION_ERROR: number;
        readonly INVALID_ARGUMENT_ERROR: number;
        readonly TIMEOUT_ERROR: number;
        readonly TRANSFORM_ERROR: number;
        new(other?: TF2Error): TF2Error;
      }
      export interface TFMessage {
        transforms: geometry_msgs.msg.TransformStamped[];
      }
      export interface TFMessageConstructor {
        new(other?: TFMessage): TFMessage;
      }
    }
    namespace srv {
      export interface FrameGraphConstructor extends ROSService {
        readonly Request: FrameGraph_RequestConstructor;
        readonly Response: FrameGraph_ResponseConstructor;
      }
      export interface FrameGraph_Request {
      }
      export interface FrameGraph_RequestConstructor {
        new(other?: FrameGraph_Request): FrameGraph_Request;
      }
      export interface FrameGraph_Response {
        frame_yaml: string;
      }
      export interface FrameGraph_ResponseConstructor {
        new(other?: FrameGraph_Response): FrameGraph_Response;
      }
    }
  }

  namespace trajectory_msgs {
    namespace msg {
      export interface JointTrajectory {
        header: std_msgs.msg.Header;
        joint_names: string[];
        points: trajectory_msgs.msg.JointTrajectoryPoint[];
      }
      export interface JointTrajectoryConstructor {
        new(other?: JointTrajectory): JointTrajectory;
      }
      export interface JointTrajectoryPoint {
        positions: number[] | Float64Array;
        velocities: number[] | Float64Array;
        accelerations: number[] | Float64Array;
        effort: number[] | Float64Array;
        time_from_start: builtin_interfaces.msg.Duration;
      }
      export interface JointTrajectoryPointConstructor {
        new(other?: JointTrajectoryPoint): JointTrajectoryPoint;
      }
      export interface MultiDOFJointTrajectory {
        header: std_msgs.msg.Header;
        joint_names: string[];
        points: trajectory_msgs.msg.MultiDOFJointTrajectoryPoint[];
      }
      export interface MultiDOFJointTrajectoryConstructor {
        new(other?: MultiDOFJointTrajectory): MultiDOFJointTrajectory;
      }
      export interface MultiDOFJointTrajectoryPoint {
        transforms: geometry_msgs.msg.Transform[];
        velocities: geometry_msgs.msg.Twist[];
        accelerations: geometry_msgs.msg.Twist[];
        time_from_start: builtin_interfaces.msg.Duration;
      }
      export interface MultiDOFJointTrajectoryPointConstructor {
        new(other?: MultiDOFJointTrajectoryPoint): MultiDOFJointTrajectoryPoint;
      }
    }
  }

  namespace unique_identifier_msgs {
    namespace msg {
      export interface UUID {
        uuid: number[] | Uint8Array;
      }
      export interface UUIDConstructor {
        new(other?: UUID): UUID;
      }
    }
  }

  namespace visualization_msgs {
    namespace msg {
      export interface ImageMarker {
        header: std_msgs.msg.Header;
        ns: string;
        id: number;
        type: number;
        action: number;
        position: geometry_msgs.msg.Point;
        scale: number;
        outline_color: std_msgs.msg.ColorRGBA;
        filled: number;
        fill_color: std_msgs.msg.ColorRGBA;
        lifetime: builtin_interfaces.msg.Duration;
        points: geometry_msgs.msg.Point[];
        outline_colors: std_msgs.msg.ColorRGBA[];
      }
      export interface ImageMarkerConstructor {
        readonly CIRCLE: number;
        readonly LINE_STRIP: number;
        readonly LINE_LIST: number;
        readonly POLYGON: number;
        readonly POINTS: number;
        readonly ADD: number;
        readonly REMOVE: number;
        new(other?: ImageMarker): ImageMarker;
      }
      export interface InteractiveMarker {
        header: std_msgs.msg.Header;
        pose: geometry_msgs.msg.Pose;
        name: string;
        description: string;
        scale: number;
        menu_entries: visualization_msgs.msg.MenuEntry[];
        controls: visualization_msgs.msg.InteractiveMarkerControl[];
      }
      export interface InteractiveMarkerConstructor {
        new(other?: InteractiveMarker): InteractiveMarker;
      }
      export interface InteractiveMarkerControl {
        name: string;
        orientation: geometry_msgs.msg.Quaternion;
        orientation_mode: number;
        interaction_mode: number;
        always_visible: boolean;
        markers: visualization_msgs.msg.Marker[];
        independent_marker_orientation: boolean;
        description: string;
      }
      export interface InteractiveMarkerControlConstructor {
        readonly INHERIT: number;
        readonly FIXED: number;
        readonly VIEW_FACING: number;
        readonly NONE: number;
        readonly MENU: number;
        readonly BUTTON: number;
        readonly MOVE_AXIS: number;
        readonly MOVE_PLANE: number;
        readonly ROTATE_AXIS: number;
        readonly MOVE_ROTATE: number;
        readonly MOVE_3D: number;
        readonly ROTATE_3D: number;
        readonly MOVE_ROTATE_3D: number;
        new(other?: InteractiveMarkerControl): InteractiveMarkerControl;
      }
      export interface InteractiveMarkerFeedback {
        header: std_msgs.msg.Header;
        client_id: string;
        marker_name: string;
        control_name: string;
        event_type: number;
        pose: geometry_msgs.msg.Pose;
        menu_entry_id: number;
        mouse_point: geometry_msgs.msg.Point;
        mouse_point_valid: boolean;
      }
      export interface InteractiveMarkerFeedbackConstructor {
        readonly KEEP_ALIVE: number;
        readonly POSE_UPDATE: number;
        readonly MENU_SELECT: number;
        readonly BUTTON_CLICK: number;
        readonly MOUSE_DOWN: number;
        readonly MOUSE_UP: number;
        new(other?: InteractiveMarkerFeedback): InteractiveMarkerFeedback;
      }
      export interface InteractiveMarkerInit {
        server_id: string;
        seq_num: number;
        markers: visualization_msgs.msg.InteractiveMarker[];
      }
      export interface InteractiveMarkerInitConstructor {
        new(other?: InteractiveMarkerInit): InteractiveMarkerInit;
      }
      export interface InteractiveMarkerPose {
        header: std_msgs.msg.Header;
        pose: geometry_msgs.msg.Pose;
        name: string;
      }
      export interface InteractiveMarkerPoseConstructor {
        new(other?: InteractiveMarkerPose): InteractiveMarkerPose;
      }
      export interface InteractiveMarkerUpdate {
        server_id: string;
        seq_num: number;
        type: number;
        markers: visualization_msgs.msg.InteractiveMarker[];
        poses: visualization_msgs.msg.InteractiveMarkerPose[];
        erases: string[];
      }
      export interface InteractiveMarkerUpdateConstructor {
        readonly KEEP_ALIVE: number;
        readonly UPDATE: number;
        new(other?: InteractiveMarkerUpdate): InteractiveMarkerUpdate;
      }
      export interface Marker {
        header: std_msgs.msg.Header;
        ns: string;
        id: number;
        type: number;
        action: number;
        pose: geometry_msgs.msg.Pose;
        scale: geometry_msgs.msg.Vector3;
        color: std_msgs.msg.ColorRGBA;
        lifetime: builtin_interfaces.msg.Duration;
        frame_locked: boolean;
        points: geometry_msgs.msg.Point[];
        colors: std_msgs.msg.ColorRGBA[];
        text: string;
        mesh_resource: string;
        mesh_use_embedded_materials: boolean;
      }
      export interface MarkerConstructor {
        readonly ARROW: number;
        readonly CUBE: number;
        readonly SPHERE: number;
        readonly CYLINDER: number;
        readonly LINE_STRIP: number;
        readonly LINE_LIST: number;
        readonly CUBE_LIST: number;
        readonly SPHERE_LIST: number;
        readonly POINTS: number;
        readonly TEXT_VIEW_FACING: number;
        readonly MESH_RESOURCE: number;
        readonly TRIANGLE_LIST: number;
        readonly ADD: number;
        readonly MODIFY: number;
        readonly DELETE: number;
        readonly DELETEALL: number;
        new(other?: Marker): Marker;
      }
      export interface MarkerArray {
        markers: visualization_msgs.msg.Marker[];
      }
      export interface MarkerArrayConstructor {
        new(other?: MarkerArray): MarkerArray;
      }
      export interface MenuEntry {
        id: number;
        parent_id: number;
        title: string;
        command: string;
        command_type: number;
      }
      export interface MenuEntryConstructor {
        readonly FEEDBACK: number;
        readonly ROSRUN: number;
        readonly ROSLAUNCH: number;
        new(other?: MenuEntry): MenuEntry;
      }
    }
    namespace srv {
      export interface GetInteractiveMarkersConstructor extends ROSService {
        readonly Request: GetInteractiveMarkers_RequestConstructor;
        readonly Response: GetInteractiveMarkers_ResponseConstructor;
      }
      export interface GetInteractiveMarkers_Request {
      }
      export interface GetInteractiveMarkers_RequestConstructor {
        new(other?: GetInteractiveMarkers_Request): GetInteractiveMarkers_Request;
      }
      export interface GetInteractiveMarkers_Response {
        sequence_number: number;
        markers: visualization_msgs.msg.InteractiveMarker[];
      }
      export interface GetInteractiveMarkers_ResponseConstructor {
        new(other?: GetInteractiveMarkers_Response): GetInteractiveMarkers_Response;
      }
    }
  }

  type MessagesMap = {
    'string': string,
    'action_msgs/msg/GoalInfo': action_msgs.msg.GoalInfo,
    'action_msgs/msg/GoalStatus': action_msgs.msg.GoalStatus,
    'action_msgs/msg/GoalStatusArray': action_msgs.msg.GoalStatusArray,
    'action_msgs/srv/CancelGoal_Request': action_msgs.srv.CancelGoal_Request,
    'action_msgs/srv/CancelGoal_Response': action_msgs.srv.CancelGoal_Response,
    'actionlib_msgs/msg/GoalID': actionlib_msgs.msg.GoalID,
    'actionlib_msgs/msg/GoalStatus': actionlib_msgs.msg.GoalStatus,
    'actionlib_msgs/msg/GoalStatusArray': actionlib_msgs.msg.GoalStatusArray,
    'builtin_interfaces/msg/Duration': builtin_interfaces.msg.Duration,
    'builtin_interfaces/msg/Time': builtin_interfaces.msg.Time,
    'cartographer_ros_msgs/msg/LandmarkEntry': cartographer_ros_msgs.msg.LandmarkEntry,
    'cartographer_ros_msgs/msg/LandmarkList': cartographer_ros_msgs.msg.LandmarkList,
    'cartographer_ros_msgs/msg/SensorTopics': cartographer_ros_msgs.msg.SensorTopics,
    'cartographer_ros_msgs/msg/StatusCode': cartographer_ros_msgs.msg.StatusCode,
    'cartographer_ros_msgs/msg/StatusResponse': cartographer_ros_msgs.msg.StatusResponse,
    'cartographer_ros_msgs/msg/SubmapEntry': cartographer_ros_msgs.msg.SubmapEntry,
    'cartographer_ros_msgs/msg/SubmapList': cartographer_ros_msgs.msg.SubmapList,
    'cartographer_ros_msgs/msg/SubmapTexture': cartographer_ros_msgs.msg.SubmapTexture,
    'cartographer_ros_msgs/msg/TrajectoryOptions': cartographer_ros_msgs.msg.TrajectoryOptions,
    'cartographer_ros_msgs/srv/FinishTrajectory_Request': cartographer_ros_msgs.srv.FinishTrajectory_Request,
    'cartographer_ros_msgs/srv/FinishTrajectory_Response': cartographer_ros_msgs.srv.FinishTrajectory_Response,
    'cartographer_ros_msgs/srv/StartTrajectory_Request': cartographer_ros_msgs.srv.StartTrajectory_Request,
    'cartographer_ros_msgs/srv/StartTrajectory_Response': cartographer_ros_msgs.srv.StartTrajectory_Response,
    'cartographer_ros_msgs/srv/SubmapQuery_Request': cartographer_ros_msgs.srv.SubmapQuery_Request,
    'cartographer_ros_msgs/srv/SubmapQuery_Response': cartographer_ros_msgs.srv.SubmapQuery_Response,
    'cartographer_ros_msgs/srv/WriteState_Request': cartographer_ros_msgs.srv.WriteState_Request,
    'cartographer_ros_msgs/srv/WriteState_Response': cartographer_ros_msgs.srv.WriteState_Response,
    'composition_interfaces/srv/ListNodes_Request': composition_interfaces.srv.ListNodes_Request,
    'composition_interfaces/srv/ListNodes_Response': composition_interfaces.srv.ListNodes_Response,
    'composition_interfaces/srv/LoadNode_Request': composition_interfaces.srv.LoadNode_Request,
    'composition_interfaces/srv/LoadNode_Response': composition_interfaces.srv.LoadNode_Response,
    'composition_interfaces/srv/UnloadNode_Request': composition_interfaces.srv.UnloadNode_Request,
    'composition_interfaces/srv/UnloadNode_Response': composition_interfaces.srv.UnloadNode_Response,
    'control_msgs/action/FollowJointTrajectory_Feedback': control_msgs.action.FollowJointTrajectory_Feedback,
    'control_msgs/action/FollowJointTrajectory_FeedbackMessage': control_msgs.action.FollowJointTrajectory_FeedbackMessage,
    'control_msgs/action/FollowJointTrajectory_GetResult_Request': control_msgs.action.FollowJointTrajectory_GetResult_Request,
    'control_msgs/action/FollowJointTrajectory_GetResult_Response': control_msgs.action.FollowJointTrajectory_GetResult_Response,
    'control_msgs/action/FollowJointTrajectory_Goal': control_msgs.action.FollowJointTrajectory_Goal,
    'control_msgs/action/FollowJointTrajectory_Result': control_msgs.action.FollowJointTrajectory_Result,
    'control_msgs/action/FollowJointTrajectory_SendGoal_Request': control_msgs.action.FollowJointTrajectory_SendGoal_Request,
    'control_msgs/action/FollowJointTrajectory_SendGoal_Response': control_msgs.action.FollowJointTrajectory_SendGoal_Response,
    'control_msgs/action/GripperCommand_Feedback': control_msgs.action.GripperCommand_Feedback,
    'control_msgs/action/GripperCommand_FeedbackMessage': control_msgs.action.GripperCommand_FeedbackMessage,
    'control_msgs/action/GripperCommand_GetResult_Request': control_msgs.action.GripperCommand_GetResult_Request,
    'control_msgs/action/GripperCommand_GetResult_Response': control_msgs.action.GripperCommand_GetResult_Response,
    'control_msgs/action/GripperCommand_Goal': control_msgs.action.GripperCommand_Goal,
    'control_msgs/action/GripperCommand_Result': control_msgs.action.GripperCommand_Result,
    'control_msgs/action/GripperCommand_SendGoal_Request': control_msgs.action.GripperCommand_SendGoal_Request,
    'control_msgs/action/GripperCommand_SendGoal_Response': control_msgs.action.GripperCommand_SendGoal_Response,
    'control_msgs/action/JointTrajectory_Feedback': control_msgs.action.JointTrajectory_Feedback,
    'control_msgs/action/JointTrajectory_FeedbackMessage': control_msgs.action.JointTrajectory_FeedbackMessage,
    'control_msgs/action/JointTrajectory_GetResult_Request': control_msgs.action.JointTrajectory_GetResult_Request,
    'control_msgs/action/JointTrajectory_GetResult_Response': control_msgs.action.JointTrajectory_GetResult_Response,
    'control_msgs/action/JointTrajectory_Goal': control_msgs.action.JointTrajectory_Goal,
    'control_msgs/action/JointTrajectory_Result': control_msgs.action.JointTrajectory_Result,
    'control_msgs/action/JointTrajectory_SendGoal_Request': control_msgs.action.JointTrajectory_SendGoal_Request,
    'control_msgs/action/JointTrajectory_SendGoal_Response': control_msgs.action.JointTrajectory_SendGoal_Response,
    'control_msgs/action/PointHead_Feedback': control_msgs.action.PointHead_Feedback,
    'control_msgs/action/PointHead_FeedbackMessage': control_msgs.action.PointHead_FeedbackMessage,
    'control_msgs/action/PointHead_GetResult_Request': control_msgs.action.PointHead_GetResult_Request,
    'control_msgs/action/PointHead_GetResult_Response': control_msgs.action.PointHead_GetResult_Response,
    'control_msgs/action/PointHead_Goal': control_msgs.action.PointHead_Goal,
    'control_msgs/action/PointHead_Result': control_msgs.action.PointHead_Result,
    'control_msgs/action/PointHead_SendGoal_Request': control_msgs.action.PointHead_SendGoal_Request,
    'control_msgs/action/PointHead_SendGoal_Response': control_msgs.action.PointHead_SendGoal_Response,
    'control_msgs/action/SingleJointPosition_Feedback': control_msgs.action.SingleJointPosition_Feedback,
    'control_msgs/action/SingleJointPosition_FeedbackMessage': control_msgs.action.SingleJointPosition_FeedbackMessage,
    'control_msgs/action/SingleJointPosition_GetResult_Request': control_msgs.action.SingleJointPosition_GetResult_Request,
    'control_msgs/action/SingleJointPosition_GetResult_Response': control_msgs.action.SingleJointPosition_GetResult_Response,
    'control_msgs/action/SingleJointPosition_Goal': control_msgs.action.SingleJointPosition_Goal,
    'control_msgs/action/SingleJointPosition_Result': control_msgs.action.SingleJointPosition_Result,
    'control_msgs/action/SingleJointPosition_SendGoal_Request': control_msgs.action.SingleJointPosition_SendGoal_Request,
    'control_msgs/action/SingleJointPosition_SendGoal_Response': control_msgs.action.SingleJointPosition_SendGoal_Response,
    'control_msgs/msg/DynamicJointState': control_msgs.msg.DynamicJointState,
    'control_msgs/msg/GripperCommand': control_msgs.msg.GripperCommand,
    'control_msgs/msg/InterfaceValue': control_msgs.msg.InterfaceValue,
    'control_msgs/msg/JointControllerState': control_msgs.msg.JointControllerState,
    'control_msgs/msg/JointJog': control_msgs.msg.JointJog,
    'control_msgs/msg/JointTolerance': control_msgs.msg.JointTolerance,
    'control_msgs/msg/JointTrajectoryControllerState': control_msgs.msg.JointTrajectoryControllerState,
    'control_msgs/msg/PidState': control_msgs.msg.PidState,
    'control_msgs/srv/QueryCalibrationState_Request': control_msgs.srv.QueryCalibrationState_Request,
    'control_msgs/srv/QueryCalibrationState_Response': control_msgs.srv.QueryCalibrationState_Response,
    'control_msgs/srv/QueryTrajectoryState_Request': control_msgs.srv.QueryTrajectoryState_Request,
    'control_msgs/srv/QueryTrajectoryState_Response': control_msgs.srv.QueryTrajectoryState_Response,
    'diagnostic_msgs/msg/DiagnosticArray': diagnostic_msgs.msg.DiagnosticArray,
    'diagnostic_msgs/msg/DiagnosticStatus': diagnostic_msgs.msg.DiagnosticStatus,
    'diagnostic_msgs/msg/KeyValue': diagnostic_msgs.msg.KeyValue,
    'diagnostic_msgs/srv/AddDiagnostics_Request': diagnostic_msgs.srv.AddDiagnostics_Request,
    'diagnostic_msgs/srv/AddDiagnostics_Response': diagnostic_msgs.srv.AddDiagnostics_Response,
    'diagnostic_msgs/srv/SelfTest_Request': diagnostic_msgs.srv.SelfTest_Request,
    'diagnostic_msgs/srv/SelfTest_Response': diagnostic_msgs.srv.SelfTest_Response,
    'geometry_msgs/msg/Accel': geometry_msgs.msg.Accel,
    'geometry_msgs/msg/AccelStamped': geometry_msgs.msg.AccelStamped,
    'geometry_msgs/msg/AccelWithCovariance': geometry_msgs.msg.AccelWithCovariance,
    'geometry_msgs/msg/AccelWithCovarianceStamped': geometry_msgs.msg.AccelWithCovarianceStamped,
    'geometry_msgs/msg/Inertia': geometry_msgs.msg.Inertia,
    'geometry_msgs/msg/InertiaStamped': geometry_msgs.msg.InertiaStamped,
    'geometry_msgs/msg/Point': geometry_msgs.msg.Point,
    'geometry_msgs/msg/Point32': geometry_msgs.msg.Point32,
    'geometry_msgs/msg/PointStamped': geometry_msgs.msg.PointStamped,
    'geometry_msgs/msg/Polygon': geometry_msgs.msg.Polygon,
    'geometry_msgs/msg/PolygonStamped': geometry_msgs.msg.PolygonStamped,
    'geometry_msgs/msg/Pose': geometry_msgs.msg.Pose,
    'geometry_msgs/msg/Pose2D': geometry_msgs.msg.Pose2D,
    'geometry_msgs/msg/PoseArray': geometry_msgs.msg.PoseArray,
    'geometry_msgs/msg/PoseStamped': geometry_msgs.msg.PoseStamped,
    'geometry_msgs/msg/PoseWithCovariance': geometry_msgs.msg.PoseWithCovariance,
    'geometry_msgs/msg/PoseWithCovarianceStamped': geometry_msgs.msg.PoseWithCovarianceStamped,
    'geometry_msgs/msg/Quaternion': geometry_msgs.msg.Quaternion,
    'geometry_msgs/msg/QuaternionStamped': geometry_msgs.msg.QuaternionStamped,
    'geometry_msgs/msg/Transform': geometry_msgs.msg.Transform,
    'geometry_msgs/msg/TransformStamped': geometry_msgs.msg.TransformStamped,
    'geometry_msgs/msg/Twist': geometry_msgs.msg.Twist,
    'geometry_msgs/msg/TwistStamped': geometry_msgs.msg.TwistStamped,
    'geometry_msgs/msg/TwistWithCovariance': geometry_msgs.msg.TwistWithCovariance,
    'geometry_msgs/msg/TwistWithCovarianceStamped': geometry_msgs.msg.TwistWithCovarianceStamped,
    'geometry_msgs/msg/Vector3': geometry_msgs.msg.Vector3,
    'geometry_msgs/msg/Vector3Stamped': geometry_msgs.msg.Vector3Stamped,
    'geometry_msgs/msg/Wrench': geometry_msgs.msg.Wrench,
    'geometry_msgs/msg/WrenchStamped': geometry_msgs.msg.WrenchStamped,
    'libstatistics_collector/msg/DummyMessage': libstatistics_collector.msg.DummyMessage,
    'lifecycle_msgs/msg/State': lifecycle_msgs.msg.State,
    'lifecycle_msgs/msg/Transition': lifecycle_msgs.msg.Transition,
    'lifecycle_msgs/msg/TransitionDescription': lifecycle_msgs.msg.TransitionDescription,
    'lifecycle_msgs/msg/TransitionEvent': lifecycle_msgs.msg.TransitionEvent,
    'lifecycle_msgs/srv/ChangeState_Request': lifecycle_msgs.srv.ChangeState_Request,
    'lifecycle_msgs/srv/ChangeState_Response': lifecycle_msgs.srv.ChangeState_Response,
    'lifecycle_msgs/srv/GetAvailableStates_Request': lifecycle_msgs.srv.GetAvailableStates_Request,
    'lifecycle_msgs/srv/GetAvailableStates_Response': lifecycle_msgs.srv.GetAvailableStates_Response,
    'lifecycle_msgs/srv/GetAvailableTransitions_Request': lifecycle_msgs.srv.GetAvailableTransitions_Request,
    'lifecycle_msgs/srv/GetAvailableTransitions_Response': lifecycle_msgs.srv.GetAvailableTransitions_Response,
    'lifecycle_msgs/srv/GetState_Request': lifecycle_msgs.srv.GetState_Request,
    'lifecycle_msgs/srv/GetState_Response': lifecycle_msgs.srv.GetState_Response,
    'nav_msgs/msg/GridCells': nav_msgs.msg.GridCells,
    'nav_msgs/msg/MapMetaData': nav_msgs.msg.MapMetaData,
    'nav_msgs/msg/OccupancyGrid': nav_msgs.msg.OccupancyGrid,
    'nav_msgs/msg/Odometry': nav_msgs.msg.Odometry,
    'nav_msgs/msg/Path': nav_msgs.msg.Path,
    'nav_msgs/srv/GetMap_Request': nav_msgs.srv.GetMap_Request,
    'nav_msgs/srv/GetMap_Response': nav_msgs.srv.GetMap_Response,
    'nav_msgs/srv/GetPlan_Request': nav_msgs.srv.GetPlan_Request,
    'nav_msgs/srv/GetPlan_Response': nav_msgs.srv.GetPlan_Response,
    'nav_msgs/srv/SetMap_Request': nav_msgs.srv.SetMap_Request,
    'nav_msgs/srv/SetMap_Response': nav_msgs.srv.SetMap_Response,
    'ouster_msgs/msg/Metadata': ouster_msgs.msg.Metadata,
    'ouster_msgs/srv/GetMetadata_Request': ouster_msgs.srv.GetMetadata_Request,
    'ouster_msgs/srv/GetMetadata_Response': ouster_msgs.srv.GetMetadata_Response,
    'pcl_msgs/msg/ModelCoefficients': pcl_msgs.msg.ModelCoefficients,
    'pcl_msgs/msg/PointIndices': pcl_msgs.msg.PointIndices,
    'pcl_msgs/msg/PolygonMesh': pcl_msgs.msg.PolygonMesh,
    'pcl_msgs/msg/Vertices': pcl_msgs.msg.Vertices,
    'pcl_msgs/srv/UpdateFilename_Request': pcl_msgs.srv.UpdateFilename_Request,
    'pcl_msgs/srv/UpdateFilename_Response': pcl_msgs.srv.UpdateFilename_Response,
    'rcl_interfaces/msg/FloatingPointRange': rcl_interfaces.msg.FloatingPointRange,
    'rcl_interfaces/msg/IntegerRange': rcl_interfaces.msg.IntegerRange,
    'rcl_interfaces/msg/ListParametersResult': rcl_interfaces.msg.ListParametersResult,
    'rcl_interfaces/msg/Log': rcl_interfaces.msg.Log,
    'rcl_interfaces/msg/Parameter': rcl_interfaces.msg.Parameter,
    'rcl_interfaces/msg/ParameterDescriptor': rcl_interfaces.msg.ParameterDescriptor,
    'rcl_interfaces/msg/ParameterEvent': rcl_interfaces.msg.ParameterEvent,
    'rcl_interfaces/msg/ParameterEventDescriptors': rcl_interfaces.msg.ParameterEventDescriptors,
    'rcl_interfaces/msg/ParameterType': rcl_interfaces.msg.ParameterType,
    'rcl_interfaces/msg/ParameterValue': rcl_interfaces.msg.ParameterValue,
    'rcl_interfaces/msg/SetParametersResult': rcl_interfaces.msg.SetParametersResult,
    'rcl_interfaces/srv/DescribeParameters_Request': rcl_interfaces.srv.DescribeParameters_Request,
    'rcl_interfaces/srv/DescribeParameters_Response': rcl_interfaces.srv.DescribeParameters_Response,
    'rcl_interfaces/srv/GetParameterTypes_Request': rcl_interfaces.srv.GetParameterTypes_Request,
    'rcl_interfaces/srv/GetParameterTypes_Response': rcl_interfaces.srv.GetParameterTypes_Response,
    'rcl_interfaces/srv/GetParameters_Request': rcl_interfaces.srv.GetParameters_Request,
    'rcl_interfaces/srv/GetParameters_Response': rcl_interfaces.srv.GetParameters_Response,
    'rcl_interfaces/srv/ListParameters_Request': rcl_interfaces.srv.ListParameters_Request,
    'rcl_interfaces/srv/ListParameters_Response': rcl_interfaces.srv.ListParameters_Response,
    'rcl_interfaces/srv/SetParametersAtomically_Request': rcl_interfaces.srv.SetParametersAtomically_Request,
    'rcl_interfaces/srv/SetParametersAtomically_Response': rcl_interfaces.srv.SetParametersAtomically_Response,
    'rcl_interfaces/srv/SetParameters_Request': rcl_interfaces.srv.SetParameters_Request,
    'rcl_interfaces/srv/SetParameters_Response': rcl_interfaces.srv.SetParameters_Response,
    'rmw_dds_common/msg/Gid': rmw_dds_common.msg.Gid,
    'rmw_dds_common/msg/NodeEntitiesInfo': rmw_dds_common.msg.NodeEntitiesInfo,
    'rmw_dds_common/msg/ParticipantEntitiesInfo': rmw_dds_common.msg.ParticipantEntitiesInfo,
    'rosgraph_msgs/msg/Clock': rosgraph_msgs.msg.Clock,
    'sdr_interfaces/action/Parking_Feedback': sdr_interfaces.action.Parking_Feedback,
    'sdr_interfaces/action/Parking_FeedbackMessage': sdr_interfaces.action.Parking_FeedbackMessage,
    'sdr_interfaces/action/Parking_GetResult_Request': sdr_interfaces.action.Parking_GetResult_Request,
    'sdr_interfaces/action/Parking_GetResult_Response': sdr_interfaces.action.Parking_GetResult_Response,
    'sdr_interfaces/action/Parking_Goal': sdr_interfaces.action.Parking_Goal,
    'sdr_interfaces/action/Parking_Result': sdr_interfaces.action.Parking_Result,
    'sdr_interfaces/action/Parking_SendGoal_Request': sdr_interfaces.action.Parking_SendGoal_Request,
    'sdr_interfaces/action/Parking_SendGoal_Response': sdr_interfaces.action.Parking_SendGoal_Response,
    'sdr_interfaces/srv/AddWaypoint_Request': sdr_interfaces.srv.AddWaypoint_Request,
    'sdr_interfaces/srv/AddWaypoint_Response': sdr_interfaces.srv.AddWaypoint_Response,
    'sdr_interfaces/srv/RESTBackend_Request': sdr_interfaces.srv.RESTBackend_Request,
    'sdr_interfaces/srv/RESTBackend_Response': sdr_interfaces.srv.RESTBackend_Response,
    'sdr_interfaces/srv/SwitchVelocity_Request': sdr_interfaces.srv.SwitchVelocity_Request,
    'sdr_interfaces/srv/SwitchVelocity_Response': sdr_interfaces.srv.SwitchVelocity_Response,
    'sensor_msgs/msg/BatteryState': sensor_msgs.msg.BatteryState,
    'sensor_msgs/msg/CameraInfo': sensor_msgs.msg.CameraInfo,
    'sensor_msgs/msg/ChannelFloat32': sensor_msgs.msg.ChannelFloat32,
    'sensor_msgs/msg/CompressedImage': sensor_msgs.msg.CompressedImage,
    'sensor_msgs/msg/FluidPressure': sensor_msgs.msg.FluidPressure,
    'sensor_msgs/msg/Illuminance': sensor_msgs.msg.Illuminance,
    'sensor_msgs/msg/Image': sensor_msgs.msg.Image,
    'sensor_msgs/msg/Imu': sensor_msgs.msg.Imu,
    'sensor_msgs/msg/JointState': sensor_msgs.msg.JointState,
    'sensor_msgs/msg/Joy': sensor_msgs.msg.Joy,
    'sensor_msgs/msg/JoyFeedback': sensor_msgs.msg.JoyFeedback,
    'sensor_msgs/msg/JoyFeedbackArray': sensor_msgs.msg.JoyFeedbackArray,
    'sensor_msgs/msg/LaserEcho': sensor_msgs.msg.LaserEcho,
    'sensor_msgs/msg/LaserScan': sensor_msgs.msg.LaserScan,
    'sensor_msgs/msg/MagneticField': sensor_msgs.msg.MagneticField,
    'sensor_msgs/msg/MultiDOFJointState': sensor_msgs.msg.MultiDOFJointState,
    'sensor_msgs/msg/MultiEchoLaserScan': sensor_msgs.msg.MultiEchoLaserScan,
    'sensor_msgs/msg/NavSatFix': sensor_msgs.msg.NavSatFix,
    'sensor_msgs/msg/NavSatStatus': sensor_msgs.msg.NavSatStatus,
    'sensor_msgs/msg/PointCloud': sensor_msgs.msg.PointCloud,
    'sensor_msgs/msg/PointCloud2': sensor_msgs.msg.PointCloud2,
    'sensor_msgs/msg/PointField': sensor_msgs.msg.PointField,
    'sensor_msgs/msg/Range': sensor_msgs.msg.Range,
    'sensor_msgs/msg/RegionOfInterest': sensor_msgs.msg.RegionOfInterest,
    'sensor_msgs/msg/RelativeHumidity': sensor_msgs.msg.RelativeHumidity,
    'sensor_msgs/msg/Temperature': sensor_msgs.msg.Temperature,
    'sensor_msgs/msg/TimeReference': sensor_msgs.msg.TimeReference,
    'sensor_msgs/srv/SetCameraInfo_Request': sensor_msgs.srv.SetCameraInfo_Request,
    'sensor_msgs/srv/SetCameraInfo_Response': sensor_msgs.srv.SetCameraInfo_Response,
    'shape_msgs/msg/Mesh': shape_msgs.msg.Mesh,
    'shape_msgs/msg/MeshTriangle': shape_msgs.msg.MeshTriangle,
    'shape_msgs/msg/Plane': shape_msgs.msg.Plane,
    'shape_msgs/msg/SolidPrimitive': shape_msgs.msg.SolidPrimitive,
    'statistics_msgs/msg/MetricsMessage': statistics_msgs.msg.MetricsMessage,
    'statistics_msgs/msg/StatisticDataPoint': statistics_msgs.msg.StatisticDataPoint,
    'statistics_msgs/msg/StatisticDataType': statistics_msgs.msg.StatisticDataType,
    'std_msgs/msg/Bool': std_msgs.msg.Bool,
    'std_msgs/msg/Byte': std_msgs.msg.Byte,
    'std_msgs/msg/ByteMultiArray': std_msgs.msg.ByteMultiArray,
    'std_msgs/msg/Char': std_msgs.msg.Char,
    'std_msgs/msg/ColorRGBA': std_msgs.msg.ColorRGBA,
    'std_msgs/msg/Empty': std_msgs.msg.Empty,
    'std_msgs/msg/Float32': std_msgs.msg.Float32,
    'std_msgs/msg/Float32MultiArray': std_msgs.msg.Float32MultiArray,
    'std_msgs/msg/Float64': std_msgs.msg.Float64,
    'std_msgs/msg/Float64MultiArray': std_msgs.msg.Float64MultiArray,
    'std_msgs/msg/Header': std_msgs.msg.Header,
    'std_msgs/msg/Int16': std_msgs.msg.Int16,
    'std_msgs/msg/Int16MultiArray': std_msgs.msg.Int16MultiArray,
    'std_msgs/msg/Int32': std_msgs.msg.Int32,
    'std_msgs/msg/Int32MultiArray': std_msgs.msg.Int32MultiArray,
    'std_msgs/msg/Int64': std_msgs.msg.Int64,
    'std_msgs/msg/Int64MultiArray': std_msgs.msg.Int64MultiArray,
    'std_msgs/msg/Int8': std_msgs.msg.Int8,
    'std_msgs/msg/Int8MultiArray': std_msgs.msg.Int8MultiArray,
    'std_msgs/msg/MultiArrayDimension': std_msgs.msg.MultiArrayDimension,
    'std_msgs/msg/MultiArrayLayout': std_msgs.msg.MultiArrayLayout,
    'std_msgs/msg/String': std_msgs.msg.String,
    'std_msgs/msg/UInt16': std_msgs.msg.UInt16,
    'std_msgs/msg/UInt16MultiArray': std_msgs.msg.UInt16MultiArray,
    'std_msgs/msg/UInt32': std_msgs.msg.UInt32,
    'std_msgs/msg/UInt32MultiArray': std_msgs.msg.UInt32MultiArray,
    'std_msgs/msg/UInt64': std_msgs.msg.UInt64,
    'std_msgs/msg/UInt64MultiArray': std_msgs.msg.UInt64MultiArray,
    'std_msgs/msg/UInt8': std_msgs.msg.UInt8,
    'std_msgs/msg/UInt8MultiArray': std_msgs.msg.UInt8MultiArray,
    'std_srvs/srv/Empty_Request': std_srvs.srv.Empty_Request,
    'std_srvs/srv/Empty_Response': std_srvs.srv.Empty_Response,
    'std_srvs/srv/SetBool_Request': std_srvs.srv.SetBool_Request,
    'std_srvs/srv/SetBool_Response': std_srvs.srv.SetBool_Response,
    'std_srvs/srv/Trigger_Request': std_srvs.srv.Trigger_Request,
    'std_srvs/srv/Trigger_Response': std_srvs.srv.Trigger_Response,
    'stereo_msgs/msg/DisparityImage': stereo_msgs.msg.DisparityImage,
    'teleop_tools_msgs/action/Increment_Feedback': teleop_tools_msgs.action.Increment_Feedback,
    'teleop_tools_msgs/action/Increment_FeedbackMessage': teleop_tools_msgs.action.Increment_FeedbackMessage,
    'teleop_tools_msgs/action/Increment_GetResult_Request': teleop_tools_msgs.action.Increment_GetResult_Request,
    'teleop_tools_msgs/action/Increment_GetResult_Response': teleop_tools_msgs.action.Increment_GetResult_Response,
    'teleop_tools_msgs/action/Increment_Goal': teleop_tools_msgs.action.Increment_Goal,
    'teleop_tools_msgs/action/Increment_Result': teleop_tools_msgs.action.Increment_Result,
    'teleop_tools_msgs/action/Increment_SendGoal_Request': teleop_tools_msgs.action.Increment_SendGoal_Request,
    'teleop_tools_msgs/action/Increment_SendGoal_Response': teleop_tools_msgs.action.Increment_SendGoal_Response,
    'tf2_msgs/action/LookupTransform_Feedback': tf2_msgs.action.LookupTransform_Feedback,
    'tf2_msgs/action/LookupTransform_FeedbackMessage': tf2_msgs.action.LookupTransform_FeedbackMessage,
    'tf2_msgs/action/LookupTransform_GetResult_Request': tf2_msgs.action.LookupTransform_GetResult_Request,
    'tf2_msgs/action/LookupTransform_GetResult_Response': tf2_msgs.action.LookupTransform_GetResult_Response,
    'tf2_msgs/action/LookupTransform_Goal': tf2_msgs.action.LookupTransform_Goal,
    'tf2_msgs/action/LookupTransform_Result': tf2_msgs.action.LookupTransform_Result,
    'tf2_msgs/action/LookupTransform_SendGoal_Request': tf2_msgs.action.LookupTransform_SendGoal_Request,
    'tf2_msgs/action/LookupTransform_SendGoal_Response': tf2_msgs.action.LookupTransform_SendGoal_Response,
    'tf2_msgs/msg/TF2Error': tf2_msgs.msg.TF2Error,
    'tf2_msgs/msg/TFMessage': tf2_msgs.msg.TFMessage,
    'tf2_msgs/srv/FrameGraph_Request': tf2_msgs.srv.FrameGraph_Request,
    'tf2_msgs/srv/FrameGraph_Response': tf2_msgs.srv.FrameGraph_Response,
    'trajectory_msgs/msg/JointTrajectory': trajectory_msgs.msg.JointTrajectory,
    'trajectory_msgs/msg/JointTrajectoryPoint': trajectory_msgs.msg.JointTrajectoryPoint,
    'trajectory_msgs/msg/MultiDOFJointTrajectory': trajectory_msgs.msg.MultiDOFJointTrajectory,
    'trajectory_msgs/msg/MultiDOFJointTrajectoryPoint': trajectory_msgs.msg.MultiDOFJointTrajectoryPoint,
    'unique_identifier_msgs/msg/UUID': unique_identifier_msgs.msg.UUID,
    'visualization_msgs/msg/ImageMarker': visualization_msgs.msg.ImageMarker,
    'visualization_msgs/msg/InteractiveMarker': visualization_msgs.msg.InteractiveMarker,
    'visualization_msgs/msg/InteractiveMarkerControl': visualization_msgs.msg.InteractiveMarkerControl,
    'visualization_msgs/msg/InteractiveMarkerFeedback': visualization_msgs.msg.InteractiveMarkerFeedback,
    'visualization_msgs/msg/InteractiveMarkerInit': visualization_msgs.msg.InteractiveMarkerInit,
    'visualization_msgs/msg/InteractiveMarkerPose': visualization_msgs.msg.InteractiveMarkerPose,
    'visualization_msgs/msg/InteractiveMarkerUpdate': visualization_msgs.msg.InteractiveMarkerUpdate,
    'visualization_msgs/msg/Marker': visualization_msgs.msg.Marker,
    'visualization_msgs/msg/MarkerArray': visualization_msgs.msg.MarkerArray,
    'visualization_msgs/msg/MenuEntry': visualization_msgs.msg.MenuEntry,
    'visualization_msgs/srv/GetInteractiveMarkers_Request': visualization_msgs.srv.GetInteractiveMarkers_Request,
    'visualization_msgs/srv/GetInteractiveMarkers_Response': visualization_msgs.srv.GetInteractiveMarkers_Response,
  };
  type MessageTypeClassName = keyof MessagesMap;
  type Message = MessagesMap[MessageTypeClassName];
  type MessageType<T> = T extends MessageTypeClassName ? MessagesMap[T] : object;

  type MessageTypeClassConstructorMap = {
    'string': never,
    'action_msgs/msg/GoalInfo': action_msgs.msg.GoalInfoConstructor,
    'action_msgs/msg/GoalStatus': action_msgs.msg.GoalStatusConstructor,
    'action_msgs/msg/GoalStatusArray': action_msgs.msg.GoalStatusArrayConstructor,
    'action_msgs/srv/CancelGoal_Request': action_msgs.srv.CancelGoal_RequestConstructor,
    'action_msgs/srv/CancelGoal_Response': action_msgs.srv.CancelGoal_ResponseConstructor,
    'actionlib_msgs/msg/GoalID': actionlib_msgs.msg.GoalIDConstructor,
    'actionlib_msgs/msg/GoalStatus': actionlib_msgs.msg.GoalStatusConstructor,
    'actionlib_msgs/msg/GoalStatusArray': actionlib_msgs.msg.GoalStatusArrayConstructor,
    'builtin_interfaces/msg/Duration': builtin_interfaces.msg.DurationConstructor,
    'builtin_interfaces/msg/Time': builtin_interfaces.msg.TimeConstructor,
    'cartographer_ros_msgs/msg/LandmarkEntry': cartographer_ros_msgs.msg.LandmarkEntryConstructor,
    'cartographer_ros_msgs/msg/LandmarkList': cartographer_ros_msgs.msg.LandmarkListConstructor,
    'cartographer_ros_msgs/msg/SensorTopics': cartographer_ros_msgs.msg.SensorTopicsConstructor,
    'cartographer_ros_msgs/msg/StatusCode': cartographer_ros_msgs.msg.StatusCodeConstructor,
    'cartographer_ros_msgs/msg/StatusResponse': cartographer_ros_msgs.msg.StatusResponseConstructor,
    'cartographer_ros_msgs/msg/SubmapEntry': cartographer_ros_msgs.msg.SubmapEntryConstructor,
    'cartographer_ros_msgs/msg/SubmapList': cartographer_ros_msgs.msg.SubmapListConstructor,
    'cartographer_ros_msgs/msg/SubmapTexture': cartographer_ros_msgs.msg.SubmapTextureConstructor,
    'cartographer_ros_msgs/msg/TrajectoryOptions': cartographer_ros_msgs.msg.TrajectoryOptionsConstructor,
    'cartographer_ros_msgs/srv/FinishTrajectory_Request': cartographer_ros_msgs.srv.FinishTrajectory_RequestConstructor,
    'cartographer_ros_msgs/srv/FinishTrajectory_Response': cartographer_ros_msgs.srv.FinishTrajectory_ResponseConstructor,
    'cartographer_ros_msgs/srv/StartTrajectory_Request': cartographer_ros_msgs.srv.StartTrajectory_RequestConstructor,
    'cartographer_ros_msgs/srv/StartTrajectory_Response': cartographer_ros_msgs.srv.StartTrajectory_ResponseConstructor,
    'cartographer_ros_msgs/srv/SubmapQuery_Request': cartographer_ros_msgs.srv.SubmapQuery_RequestConstructor,
    'cartographer_ros_msgs/srv/SubmapQuery_Response': cartographer_ros_msgs.srv.SubmapQuery_ResponseConstructor,
    'cartographer_ros_msgs/srv/WriteState_Request': cartographer_ros_msgs.srv.WriteState_RequestConstructor,
    'cartographer_ros_msgs/srv/WriteState_Response': cartographer_ros_msgs.srv.WriteState_ResponseConstructor,
    'composition_interfaces/srv/ListNodes_Request': composition_interfaces.srv.ListNodes_RequestConstructor,
    'composition_interfaces/srv/ListNodes_Response': composition_interfaces.srv.ListNodes_ResponseConstructor,
    'composition_interfaces/srv/LoadNode_Request': composition_interfaces.srv.LoadNode_RequestConstructor,
    'composition_interfaces/srv/LoadNode_Response': composition_interfaces.srv.LoadNode_ResponseConstructor,
    'composition_interfaces/srv/UnloadNode_Request': composition_interfaces.srv.UnloadNode_RequestConstructor,
    'composition_interfaces/srv/UnloadNode_Response': composition_interfaces.srv.UnloadNode_ResponseConstructor,
    'control_msgs/action/FollowJointTrajectory_Feedback': control_msgs.action.FollowJointTrajectory_FeedbackConstructor,
    'control_msgs/action/FollowJointTrajectory_FeedbackMessage': control_msgs.action.FollowJointTrajectory_FeedbackMessageConstructor,
    'control_msgs/action/FollowJointTrajectory_GetResult_Request': control_msgs.action.FollowJointTrajectory_GetResult_RequestConstructor,
    'control_msgs/action/FollowJointTrajectory_GetResult_Response': control_msgs.action.FollowJointTrajectory_GetResult_ResponseConstructor,
    'control_msgs/action/FollowJointTrajectory_Goal': control_msgs.action.FollowJointTrajectory_GoalConstructor,
    'control_msgs/action/FollowJointTrajectory_Result': control_msgs.action.FollowJointTrajectory_ResultConstructor,
    'control_msgs/action/FollowJointTrajectory_SendGoal_Request': control_msgs.action.FollowJointTrajectory_SendGoal_RequestConstructor,
    'control_msgs/action/FollowJointTrajectory_SendGoal_Response': control_msgs.action.FollowJointTrajectory_SendGoal_ResponseConstructor,
    'control_msgs/action/GripperCommand_Feedback': control_msgs.action.GripperCommand_FeedbackConstructor,
    'control_msgs/action/GripperCommand_FeedbackMessage': control_msgs.action.GripperCommand_FeedbackMessageConstructor,
    'control_msgs/action/GripperCommand_GetResult_Request': control_msgs.action.GripperCommand_GetResult_RequestConstructor,
    'control_msgs/action/GripperCommand_GetResult_Response': control_msgs.action.GripperCommand_GetResult_ResponseConstructor,
    'control_msgs/action/GripperCommand_Goal': control_msgs.action.GripperCommand_GoalConstructor,
    'control_msgs/action/GripperCommand_Result': control_msgs.action.GripperCommand_ResultConstructor,
    'control_msgs/action/GripperCommand_SendGoal_Request': control_msgs.action.GripperCommand_SendGoal_RequestConstructor,
    'control_msgs/action/GripperCommand_SendGoal_Response': control_msgs.action.GripperCommand_SendGoal_ResponseConstructor,
    'control_msgs/action/JointTrajectory_Feedback': control_msgs.action.JointTrajectory_FeedbackConstructor,
    'control_msgs/action/JointTrajectory_FeedbackMessage': control_msgs.action.JointTrajectory_FeedbackMessageConstructor,
    'control_msgs/action/JointTrajectory_GetResult_Request': control_msgs.action.JointTrajectory_GetResult_RequestConstructor,
    'control_msgs/action/JointTrajectory_GetResult_Response': control_msgs.action.JointTrajectory_GetResult_ResponseConstructor,
    'control_msgs/action/JointTrajectory_Goal': control_msgs.action.JointTrajectory_GoalConstructor,
    'control_msgs/action/JointTrajectory_Result': control_msgs.action.JointTrajectory_ResultConstructor,
    'control_msgs/action/JointTrajectory_SendGoal_Request': control_msgs.action.JointTrajectory_SendGoal_RequestConstructor,
    'control_msgs/action/JointTrajectory_SendGoal_Response': control_msgs.action.JointTrajectory_SendGoal_ResponseConstructor,
    'control_msgs/action/PointHead_Feedback': control_msgs.action.PointHead_FeedbackConstructor,
    'control_msgs/action/PointHead_FeedbackMessage': control_msgs.action.PointHead_FeedbackMessageConstructor,
    'control_msgs/action/PointHead_GetResult_Request': control_msgs.action.PointHead_GetResult_RequestConstructor,
    'control_msgs/action/PointHead_GetResult_Response': control_msgs.action.PointHead_GetResult_ResponseConstructor,
    'control_msgs/action/PointHead_Goal': control_msgs.action.PointHead_GoalConstructor,
    'control_msgs/action/PointHead_Result': control_msgs.action.PointHead_ResultConstructor,
    'control_msgs/action/PointHead_SendGoal_Request': control_msgs.action.PointHead_SendGoal_RequestConstructor,
    'control_msgs/action/PointHead_SendGoal_Response': control_msgs.action.PointHead_SendGoal_ResponseConstructor,
    'control_msgs/action/SingleJointPosition_Feedback': control_msgs.action.SingleJointPosition_FeedbackConstructor,
    'control_msgs/action/SingleJointPosition_FeedbackMessage': control_msgs.action.SingleJointPosition_FeedbackMessageConstructor,
    'control_msgs/action/SingleJointPosition_GetResult_Request': control_msgs.action.SingleJointPosition_GetResult_RequestConstructor,
    'control_msgs/action/SingleJointPosition_GetResult_Response': control_msgs.action.SingleJointPosition_GetResult_ResponseConstructor,
    'control_msgs/action/SingleJointPosition_Goal': control_msgs.action.SingleJointPosition_GoalConstructor,
    'control_msgs/action/SingleJointPosition_Result': control_msgs.action.SingleJointPosition_ResultConstructor,
    'control_msgs/action/SingleJointPosition_SendGoal_Request': control_msgs.action.SingleJointPosition_SendGoal_RequestConstructor,
    'control_msgs/action/SingleJointPosition_SendGoal_Response': control_msgs.action.SingleJointPosition_SendGoal_ResponseConstructor,
    'control_msgs/msg/DynamicJointState': control_msgs.msg.DynamicJointStateConstructor,
    'control_msgs/msg/GripperCommand': control_msgs.msg.GripperCommandConstructor,
    'control_msgs/msg/InterfaceValue': control_msgs.msg.InterfaceValueConstructor,
    'control_msgs/msg/JointControllerState': control_msgs.msg.JointControllerStateConstructor,
    'control_msgs/msg/JointJog': control_msgs.msg.JointJogConstructor,
    'control_msgs/msg/JointTolerance': control_msgs.msg.JointToleranceConstructor,
    'control_msgs/msg/JointTrajectoryControllerState': control_msgs.msg.JointTrajectoryControllerStateConstructor,
    'control_msgs/msg/PidState': control_msgs.msg.PidStateConstructor,
    'control_msgs/srv/QueryCalibrationState_Request': control_msgs.srv.QueryCalibrationState_RequestConstructor,
    'control_msgs/srv/QueryCalibrationState_Response': control_msgs.srv.QueryCalibrationState_ResponseConstructor,
    'control_msgs/srv/QueryTrajectoryState_Request': control_msgs.srv.QueryTrajectoryState_RequestConstructor,
    'control_msgs/srv/QueryTrajectoryState_Response': control_msgs.srv.QueryTrajectoryState_ResponseConstructor,
    'diagnostic_msgs/msg/DiagnosticArray': diagnostic_msgs.msg.DiagnosticArrayConstructor,
    'diagnostic_msgs/msg/DiagnosticStatus': diagnostic_msgs.msg.DiagnosticStatusConstructor,
    'diagnostic_msgs/msg/KeyValue': diagnostic_msgs.msg.KeyValueConstructor,
    'diagnostic_msgs/srv/AddDiagnostics_Request': diagnostic_msgs.srv.AddDiagnostics_RequestConstructor,
    'diagnostic_msgs/srv/AddDiagnostics_Response': diagnostic_msgs.srv.AddDiagnostics_ResponseConstructor,
    'diagnostic_msgs/srv/SelfTest_Request': diagnostic_msgs.srv.SelfTest_RequestConstructor,
    'diagnostic_msgs/srv/SelfTest_Response': diagnostic_msgs.srv.SelfTest_ResponseConstructor,
    'geometry_msgs/msg/Accel': geometry_msgs.msg.AccelConstructor,
    'geometry_msgs/msg/AccelStamped': geometry_msgs.msg.AccelStampedConstructor,
    'geometry_msgs/msg/AccelWithCovariance': geometry_msgs.msg.AccelWithCovarianceConstructor,
    'geometry_msgs/msg/AccelWithCovarianceStamped': geometry_msgs.msg.AccelWithCovarianceStampedConstructor,
    'geometry_msgs/msg/Inertia': geometry_msgs.msg.InertiaConstructor,
    'geometry_msgs/msg/InertiaStamped': geometry_msgs.msg.InertiaStampedConstructor,
    'geometry_msgs/msg/Point': geometry_msgs.msg.PointConstructor,
    'geometry_msgs/msg/Point32': geometry_msgs.msg.Point32Constructor,
    'geometry_msgs/msg/PointStamped': geometry_msgs.msg.PointStampedConstructor,
    'geometry_msgs/msg/Polygon': geometry_msgs.msg.PolygonConstructor,
    'geometry_msgs/msg/PolygonStamped': geometry_msgs.msg.PolygonStampedConstructor,
    'geometry_msgs/msg/Pose': geometry_msgs.msg.PoseConstructor,
    'geometry_msgs/msg/Pose2D': geometry_msgs.msg.Pose2DConstructor,
    'geometry_msgs/msg/PoseArray': geometry_msgs.msg.PoseArrayConstructor,
    'geometry_msgs/msg/PoseStamped': geometry_msgs.msg.PoseStampedConstructor,
    'geometry_msgs/msg/PoseWithCovariance': geometry_msgs.msg.PoseWithCovarianceConstructor,
    'geometry_msgs/msg/PoseWithCovarianceStamped': geometry_msgs.msg.PoseWithCovarianceStampedConstructor,
    'geometry_msgs/msg/Quaternion': geometry_msgs.msg.QuaternionConstructor,
    'geometry_msgs/msg/QuaternionStamped': geometry_msgs.msg.QuaternionStampedConstructor,
    'geometry_msgs/msg/Transform': geometry_msgs.msg.TransformConstructor,
    'geometry_msgs/msg/TransformStamped': geometry_msgs.msg.TransformStampedConstructor,
    'geometry_msgs/msg/Twist': geometry_msgs.msg.TwistConstructor,
    'geometry_msgs/msg/TwistStamped': geometry_msgs.msg.TwistStampedConstructor,
    'geometry_msgs/msg/TwistWithCovariance': geometry_msgs.msg.TwistWithCovarianceConstructor,
    'geometry_msgs/msg/TwistWithCovarianceStamped': geometry_msgs.msg.TwistWithCovarianceStampedConstructor,
    'geometry_msgs/msg/Vector3': geometry_msgs.msg.Vector3Constructor,
    'geometry_msgs/msg/Vector3Stamped': geometry_msgs.msg.Vector3StampedConstructor,
    'geometry_msgs/msg/Wrench': geometry_msgs.msg.WrenchConstructor,
    'geometry_msgs/msg/WrenchStamped': geometry_msgs.msg.WrenchStampedConstructor,
    'libstatistics_collector/msg/DummyMessage': libstatistics_collector.msg.DummyMessageConstructor,
    'lifecycle_msgs/msg/State': lifecycle_msgs.msg.StateConstructor,
    'lifecycle_msgs/msg/Transition': lifecycle_msgs.msg.TransitionConstructor,
    'lifecycle_msgs/msg/TransitionDescription': lifecycle_msgs.msg.TransitionDescriptionConstructor,
    'lifecycle_msgs/msg/TransitionEvent': lifecycle_msgs.msg.TransitionEventConstructor,
    'lifecycle_msgs/srv/ChangeState_Request': lifecycle_msgs.srv.ChangeState_RequestConstructor,
    'lifecycle_msgs/srv/ChangeState_Response': lifecycle_msgs.srv.ChangeState_ResponseConstructor,
    'lifecycle_msgs/srv/GetAvailableStates_Request': lifecycle_msgs.srv.GetAvailableStates_RequestConstructor,
    'lifecycle_msgs/srv/GetAvailableStates_Response': lifecycle_msgs.srv.GetAvailableStates_ResponseConstructor,
    'lifecycle_msgs/srv/GetAvailableTransitions_Request': lifecycle_msgs.srv.GetAvailableTransitions_RequestConstructor,
    'lifecycle_msgs/srv/GetAvailableTransitions_Response': lifecycle_msgs.srv.GetAvailableTransitions_ResponseConstructor,
    'lifecycle_msgs/srv/GetState_Request': lifecycle_msgs.srv.GetState_RequestConstructor,
    'lifecycle_msgs/srv/GetState_Response': lifecycle_msgs.srv.GetState_ResponseConstructor,
    'nav_msgs/msg/GridCells': nav_msgs.msg.GridCellsConstructor,
    'nav_msgs/msg/MapMetaData': nav_msgs.msg.MapMetaDataConstructor,
    'nav_msgs/msg/OccupancyGrid': nav_msgs.msg.OccupancyGridConstructor,
    'nav_msgs/msg/Odometry': nav_msgs.msg.OdometryConstructor,
    'nav_msgs/msg/Path': nav_msgs.msg.PathConstructor,
    'nav_msgs/srv/GetMap_Request': nav_msgs.srv.GetMap_RequestConstructor,
    'nav_msgs/srv/GetMap_Response': nav_msgs.srv.GetMap_ResponseConstructor,
    'nav_msgs/srv/GetPlan_Request': nav_msgs.srv.GetPlan_RequestConstructor,
    'nav_msgs/srv/GetPlan_Response': nav_msgs.srv.GetPlan_ResponseConstructor,
    'nav_msgs/srv/SetMap_Request': nav_msgs.srv.SetMap_RequestConstructor,
    'nav_msgs/srv/SetMap_Response': nav_msgs.srv.SetMap_ResponseConstructor,
    'ouster_msgs/msg/Metadata': ouster_msgs.msg.MetadataConstructor,
    'ouster_msgs/srv/GetMetadata_Request': ouster_msgs.srv.GetMetadata_RequestConstructor,
    'ouster_msgs/srv/GetMetadata_Response': ouster_msgs.srv.GetMetadata_ResponseConstructor,
    'pcl_msgs/msg/ModelCoefficients': pcl_msgs.msg.ModelCoefficientsConstructor,
    'pcl_msgs/msg/PointIndices': pcl_msgs.msg.PointIndicesConstructor,
    'pcl_msgs/msg/PolygonMesh': pcl_msgs.msg.PolygonMeshConstructor,
    'pcl_msgs/msg/Vertices': pcl_msgs.msg.VerticesConstructor,
    'pcl_msgs/srv/UpdateFilename_Request': pcl_msgs.srv.UpdateFilename_RequestConstructor,
    'pcl_msgs/srv/UpdateFilename_Response': pcl_msgs.srv.UpdateFilename_ResponseConstructor,
    'rcl_interfaces/msg/FloatingPointRange': rcl_interfaces.msg.FloatingPointRangeConstructor,
    'rcl_interfaces/msg/IntegerRange': rcl_interfaces.msg.IntegerRangeConstructor,
    'rcl_interfaces/msg/ListParametersResult': rcl_interfaces.msg.ListParametersResultConstructor,
    'rcl_interfaces/msg/Log': rcl_interfaces.msg.LogConstructor,
    'rcl_interfaces/msg/Parameter': rcl_interfaces.msg.ParameterConstructor,
    'rcl_interfaces/msg/ParameterDescriptor': rcl_interfaces.msg.ParameterDescriptorConstructor,
    'rcl_interfaces/msg/ParameterEvent': rcl_interfaces.msg.ParameterEventConstructor,
    'rcl_interfaces/msg/ParameterEventDescriptors': rcl_interfaces.msg.ParameterEventDescriptorsConstructor,
    'rcl_interfaces/msg/ParameterType': rcl_interfaces.msg.ParameterTypeConstructor,
    'rcl_interfaces/msg/ParameterValue': rcl_interfaces.msg.ParameterValueConstructor,
    'rcl_interfaces/msg/SetParametersResult': rcl_interfaces.msg.SetParametersResultConstructor,
    'rcl_interfaces/srv/DescribeParameters_Request': rcl_interfaces.srv.DescribeParameters_RequestConstructor,
    'rcl_interfaces/srv/DescribeParameters_Response': rcl_interfaces.srv.DescribeParameters_ResponseConstructor,
    'rcl_interfaces/srv/GetParameterTypes_Request': rcl_interfaces.srv.GetParameterTypes_RequestConstructor,
    'rcl_interfaces/srv/GetParameterTypes_Response': rcl_interfaces.srv.GetParameterTypes_ResponseConstructor,
    'rcl_interfaces/srv/GetParameters_Request': rcl_interfaces.srv.GetParameters_RequestConstructor,
    'rcl_interfaces/srv/GetParameters_Response': rcl_interfaces.srv.GetParameters_ResponseConstructor,
    'rcl_interfaces/srv/ListParameters_Request': rcl_interfaces.srv.ListParameters_RequestConstructor,
    'rcl_interfaces/srv/ListParameters_Response': rcl_interfaces.srv.ListParameters_ResponseConstructor,
    'rcl_interfaces/srv/SetParametersAtomically_Request': rcl_interfaces.srv.SetParametersAtomically_RequestConstructor,
    'rcl_interfaces/srv/SetParametersAtomically_Response': rcl_interfaces.srv.SetParametersAtomically_ResponseConstructor,
    'rcl_interfaces/srv/SetParameters_Request': rcl_interfaces.srv.SetParameters_RequestConstructor,
    'rcl_interfaces/srv/SetParameters_Response': rcl_interfaces.srv.SetParameters_ResponseConstructor,
    'rmw_dds_common/msg/Gid': rmw_dds_common.msg.GidConstructor,
    'rmw_dds_common/msg/NodeEntitiesInfo': rmw_dds_common.msg.NodeEntitiesInfoConstructor,
    'rmw_dds_common/msg/ParticipantEntitiesInfo': rmw_dds_common.msg.ParticipantEntitiesInfoConstructor,
    'rosgraph_msgs/msg/Clock': rosgraph_msgs.msg.ClockConstructor,
    'sdr_interfaces/action/Parking_Feedback': sdr_interfaces.action.Parking_FeedbackConstructor,
    'sdr_interfaces/action/Parking_FeedbackMessage': sdr_interfaces.action.Parking_FeedbackMessageConstructor,
    'sdr_interfaces/action/Parking_GetResult_Request': sdr_interfaces.action.Parking_GetResult_RequestConstructor,
    'sdr_interfaces/action/Parking_GetResult_Response': sdr_interfaces.action.Parking_GetResult_ResponseConstructor,
    'sdr_interfaces/action/Parking_Goal': sdr_interfaces.action.Parking_GoalConstructor,
    'sdr_interfaces/action/Parking_Result': sdr_interfaces.action.Parking_ResultConstructor,
    'sdr_interfaces/action/Parking_SendGoal_Request': sdr_interfaces.action.Parking_SendGoal_RequestConstructor,
    'sdr_interfaces/action/Parking_SendGoal_Response': sdr_interfaces.action.Parking_SendGoal_ResponseConstructor,
    'sdr_interfaces/srv/AddWaypoint_Request': sdr_interfaces.srv.AddWaypoint_RequestConstructor,
    'sdr_interfaces/srv/AddWaypoint_Response': sdr_interfaces.srv.AddWaypoint_ResponseConstructor,
    'sdr_interfaces/srv/RESTBackend_Request': sdr_interfaces.srv.RESTBackend_RequestConstructor,
    'sdr_interfaces/srv/RESTBackend_Response': sdr_interfaces.srv.RESTBackend_ResponseConstructor,
    'sdr_interfaces/srv/SwitchVelocity_Request': sdr_interfaces.srv.SwitchVelocity_RequestConstructor,
    'sdr_interfaces/srv/SwitchVelocity_Response': sdr_interfaces.srv.SwitchVelocity_ResponseConstructor,
    'sensor_msgs/msg/BatteryState': sensor_msgs.msg.BatteryStateConstructor,
    'sensor_msgs/msg/CameraInfo': sensor_msgs.msg.CameraInfoConstructor,
    'sensor_msgs/msg/ChannelFloat32': sensor_msgs.msg.ChannelFloat32Constructor,
    'sensor_msgs/msg/CompressedImage': sensor_msgs.msg.CompressedImageConstructor,
    'sensor_msgs/msg/FluidPressure': sensor_msgs.msg.FluidPressureConstructor,
    'sensor_msgs/msg/Illuminance': sensor_msgs.msg.IlluminanceConstructor,
    'sensor_msgs/msg/Image': sensor_msgs.msg.ImageConstructor,
    'sensor_msgs/msg/Imu': sensor_msgs.msg.ImuConstructor,
    'sensor_msgs/msg/JointState': sensor_msgs.msg.JointStateConstructor,
    'sensor_msgs/msg/Joy': sensor_msgs.msg.JoyConstructor,
    'sensor_msgs/msg/JoyFeedback': sensor_msgs.msg.JoyFeedbackConstructor,
    'sensor_msgs/msg/JoyFeedbackArray': sensor_msgs.msg.JoyFeedbackArrayConstructor,
    'sensor_msgs/msg/LaserEcho': sensor_msgs.msg.LaserEchoConstructor,
    'sensor_msgs/msg/LaserScan': sensor_msgs.msg.LaserScanConstructor,
    'sensor_msgs/msg/MagneticField': sensor_msgs.msg.MagneticFieldConstructor,
    'sensor_msgs/msg/MultiDOFJointState': sensor_msgs.msg.MultiDOFJointStateConstructor,
    'sensor_msgs/msg/MultiEchoLaserScan': sensor_msgs.msg.MultiEchoLaserScanConstructor,
    'sensor_msgs/msg/NavSatFix': sensor_msgs.msg.NavSatFixConstructor,
    'sensor_msgs/msg/NavSatStatus': sensor_msgs.msg.NavSatStatusConstructor,
    'sensor_msgs/msg/PointCloud': sensor_msgs.msg.PointCloudConstructor,
    'sensor_msgs/msg/PointCloud2': sensor_msgs.msg.PointCloud2Constructor,
    'sensor_msgs/msg/PointField': sensor_msgs.msg.PointFieldConstructor,
    'sensor_msgs/msg/Range': sensor_msgs.msg.RangeConstructor,
    'sensor_msgs/msg/RegionOfInterest': sensor_msgs.msg.RegionOfInterestConstructor,
    'sensor_msgs/msg/RelativeHumidity': sensor_msgs.msg.RelativeHumidityConstructor,
    'sensor_msgs/msg/Temperature': sensor_msgs.msg.TemperatureConstructor,
    'sensor_msgs/msg/TimeReference': sensor_msgs.msg.TimeReferenceConstructor,
    'sensor_msgs/srv/SetCameraInfo_Request': sensor_msgs.srv.SetCameraInfo_RequestConstructor,
    'sensor_msgs/srv/SetCameraInfo_Response': sensor_msgs.srv.SetCameraInfo_ResponseConstructor,
    'shape_msgs/msg/Mesh': shape_msgs.msg.MeshConstructor,
    'shape_msgs/msg/MeshTriangle': shape_msgs.msg.MeshTriangleConstructor,
    'shape_msgs/msg/Plane': shape_msgs.msg.PlaneConstructor,
    'shape_msgs/msg/SolidPrimitive': shape_msgs.msg.SolidPrimitiveConstructor,
    'statistics_msgs/msg/MetricsMessage': statistics_msgs.msg.MetricsMessageConstructor,
    'statistics_msgs/msg/StatisticDataPoint': statistics_msgs.msg.StatisticDataPointConstructor,
    'statistics_msgs/msg/StatisticDataType': statistics_msgs.msg.StatisticDataTypeConstructor,
    'std_msgs/msg/Bool': std_msgs.msg.BoolConstructor,
    'std_msgs/msg/Byte': std_msgs.msg.ByteConstructor,
    'std_msgs/msg/ByteMultiArray': std_msgs.msg.ByteMultiArrayConstructor,
    'std_msgs/msg/Char': std_msgs.msg.CharConstructor,
    'std_msgs/msg/ColorRGBA': std_msgs.msg.ColorRGBAConstructor,
    'std_msgs/msg/Empty': std_msgs.msg.EmptyConstructor,
    'std_msgs/msg/Float32': std_msgs.msg.Float32Constructor,
    'std_msgs/msg/Float32MultiArray': std_msgs.msg.Float32MultiArrayConstructor,
    'std_msgs/msg/Float64': std_msgs.msg.Float64Constructor,
    'std_msgs/msg/Float64MultiArray': std_msgs.msg.Float64MultiArrayConstructor,
    'std_msgs/msg/Header': std_msgs.msg.HeaderConstructor,
    'std_msgs/msg/Int16': std_msgs.msg.Int16Constructor,
    'std_msgs/msg/Int16MultiArray': std_msgs.msg.Int16MultiArrayConstructor,
    'std_msgs/msg/Int32': std_msgs.msg.Int32Constructor,
    'std_msgs/msg/Int32MultiArray': std_msgs.msg.Int32MultiArrayConstructor,
    'std_msgs/msg/Int64': std_msgs.msg.Int64Constructor,
    'std_msgs/msg/Int64MultiArray': std_msgs.msg.Int64MultiArrayConstructor,
    'std_msgs/msg/Int8': std_msgs.msg.Int8Constructor,
    'std_msgs/msg/Int8MultiArray': std_msgs.msg.Int8MultiArrayConstructor,
    'std_msgs/msg/MultiArrayDimension': std_msgs.msg.MultiArrayDimensionConstructor,
    'std_msgs/msg/MultiArrayLayout': std_msgs.msg.MultiArrayLayoutConstructor,
    'std_msgs/msg/String': std_msgs.msg.StringConstructor,
    'std_msgs/msg/UInt16': std_msgs.msg.UInt16Constructor,
    'std_msgs/msg/UInt16MultiArray': std_msgs.msg.UInt16MultiArrayConstructor,
    'std_msgs/msg/UInt32': std_msgs.msg.UInt32Constructor,
    'std_msgs/msg/UInt32MultiArray': std_msgs.msg.UInt32MultiArrayConstructor,
    'std_msgs/msg/UInt64': std_msgs.msg.UInt64Constructor,
    'std_msgs/msg/UInt64MultiArray': std_msgs.msg.UInt64MultiArrayConstructor,
    'std_msgs/msg/UInt8': std_msgs.msg.UInt8Constructor,
    'std_msgs/msg/UInt8MultiArray': std_msgs.msg.UInt8MultiArrayConstructor,
    'std_srvs/srv/Empty_Request': std_srvs.srv.Empty_RequestConstructor,
    'std_srvs/srv/Empty_Response': std_srvs.srv.Empty_ResponseConstructor,
    'std_srvs/srv/SetBool_Request': std_srvs.srv.SetBool_RequestConstructor,
    'std_srvs/srv/SetBool_Response': std_srvs.srv.SetBool_ResponseConstructor,
    'std_srvs/srv/Trigger_Request': std_srvs.srv.Trigger_RequestConstructor,
    'std_srvs/srv/Trigger_Response': std_srvs.srv.Trigger_ResponseConstructor,
    'stereo_msgs/msg/DisparityImage': stereo_msgs.msg.DisparityImageConstructor,
    'teleop_tools_msgs/action/Increment_Feedback': teleop_tools_msgs.action.Increment_FeedbackConstructor,
    'teleop_tools_msgs/action/Increment_FeedbackMessage': teleop_tools_msgs.action.Increment_FeedbackMessageConstructor,
    'teleop_tools_msgs/action/Increment_GetResult_Request': teleop_tools_msgs.action.Increment_GetResult_RequestConstructor,
    'teleop_tools_msgs/action/Increment_GetResult_Response': teleop_tools_msgs.action.Increment_GetResult_ResponseConstructor,
    'teleop_tools_msgs/action/Increment_Goal': teleop_tools_msgs.action.Increment_GoalConstructor,
    'teleop_tools_msgs/action/Increment_Result': teleop_tools_msgs.action.Increment_ResultConstructor,
    'teleop_tools_msgs/action/Increment_SendGoal_Request': teleop_tools_msgs.action.Increment_SendGoal_RequestConstructor,
    'teleop_tools_msgs/action/Increment_SendGoal_Response': teleop_tools_msgs.action.Increment_SendGoal_ResponseConstructor,
    'tf2_msgs/action/LookupTransform_Feedback': tf2_msgs.action.LookupTransform_FeedbackConstructor,
    'tf2_msgs/action/LookupTransform_FeedbackMessage': tf2_msgs.action.LookupTransform_FeedbackMessageConstructor,
    'tf2_msgs/action/LookupTransform_GetResult_Request': tf2_msgs.action.LookupTransform_GetResult_RequestConstructor,
    'tf2_msgs/action/LookupTransform_GetResult_Response': tf2_msgs.action.LookupTransform_GetResult_ResponseConstructor,
    'tf2_msgs/action/LookupTransform_Goal': tf2_msgs.action.LookupTransform_GoalConstructor,
    'tf2_msgs/action/LookupTransform_Result': tf2_msgs.action.LookupTransform_ResultConstructor,
    'tf2_msgs/action/LookupTransform_SendGoal_Request': tf2_msgs.action.LookupTransform_SendGoal_RequestConstructor,
    'tf2_msgs/action/LookupTransform_SendGoal_Response': tf2_msgs.action.LookupTransform_SendGoal_ResponseConstructor,
    'tf2_msgs/msg/TF2Error': tf2_msgs.msg.TF2ErrorConstructor,
    'tf2_msgs/msg/TFMessage': tf2_msgs.msg.TFMessageConstructor,
    'tf2_msgs/srv/FrameGraph_Request': tf2_msgs.srv.FrameGraph_RequestConstructor,
    'tf2_msgs/srv/FrameGraph_Response': tf2_msgs.srv.FrameGraph_ResponseConstructor,
    'trajectory_msgs/msg/JointTrajectory': trajectory_msgs.msg.JointTrajectoryConstructor,
    'trajectory_msgs/msg/JointTrajectoryPoint': trajectory_msgs.msg.JointTrajectoryPointConstructor,
    'trajectory_msgs/msg/MultiDOFJointTrajectory': trajectory_msgs.msg.MultiDOFJointTrajectoryConstructor,
    'trajectory_msgs/msg/MultiDOFJointTrajectoryPoint': trajectory_msgs.msg.MultiDOFJointTrajectoryPointConstructor,
    'unique_identifier_msgs/msg/UUID': unique_identifier_msgs.msg.UUIDConstructor,
    'visualization_msgs/msg/ImageMarker': visualization_msgs.msg.ImageMarkerConstructor,
    'visualization_msgs/msg/InteractiveMarker': visualization_msgs.msg.InteractiveMarkerConstructor,
    'visualization_msgs/msg/InteractiveMarkerControl': visualization_msgs.msg.InteractiveMarkerControlConstructor,
    'visualization_msgs/msg/InteractiveMarkerFeedback': visualization_msgs.msg.InteractiveMarkerFeedbackConstructor,
    'visualization_msgs/msg/InteractiveMarkerInit': visualization_msgs.msg.InteractiveMarkerInitConstructor,
    'visualization_msgs/msg/InteractiveMarkerPose': visualization_msgs.msg.InteractiveMarkerPoseConstructor,
    'visualization_msgs/msg/InteractiveMarkerUpdate': visualization_msgs.msg.InteractiveMarkerUpdateConstructor,
    'visualization_msgs/msg/Marker': visualization_msgs.msg.MarkerConstructor,
    'visualization_msgs/msg/MarkerArray': visualization_msgs.msg.MarkerArrayConstructor,
    'visualization_msgs/msg/MenuEntry': visualization_msgs.msg.MenuEntryConstructor,
    'visualization_msgs/srv/GetInteractiveMarkers_Request': visualization_msgs.srv.GetInteractiveMarkers_RequestConstructor,
    'visualization_msgs/srv/GetInteractiveMarkers_Response': visualization_msgs.srv.GetInteractiveMarkers_ResponseConstructor,
  };
  type MessageConstructorType<T> = T extends MessageTypeClassName ? MessageTypeClassConstructorMap[T] : object;

  type ServicesMap = {
    'action_msgs/srv/CancelGoal': action_msgs.srv.CancelGoalConstructor,
    'cartographer_ros_msgs/srv/FinishTrajectory': cartographer_ros_msgs.srv.FinishTrajectoryConstructor,
    'cartographer_ros_msgs/srv/StartTrajectory': cartographer_ros_msgs.srv.StartTrajectoryConstructor,
    'cartographer_ros_msgs/srv/SubmapQuery': cartographer_ros_msgs.srv.SubmapQueryConstructor,
    'cartographer_ros_msgs/srv/WriteState': cartographer_ros_msgs.srv.WriteStateConstructor,
    'composition_interfaces/srv/ListNodes': composition_interfaces.srv.ListNodesConstructor,
    'composition_interfaces/srv/LoadNode': composition_interfaces.srv.LoadNodeConstructor,
    'composition_interfaces/srv/UnloadNode': composition_interfaces.srv.UnloadNodeConstructor,
    'control_msgs/srv/QueryCalibrationState': control_msgs.srv.QueryCalibrationStateConstructor,
    'control_msgs/srv/QueryTrajectoryState': control_msgs.srv.QueryTrajectoryStateConstructor,
    'diagnostic_msgs/srv/AddDiagnostics': diagnostic_msgs.srv.AddDiagnosticsConstructor,
    'diagnostic_msgs/srv/SelfTest': diagnostic_msgs.srv.SelfTestConstructor,
    'lifecycle_msgs/srv/ChangeState': lifecycle_msgs.srv.ChangeStateConstructor,
    'lifecycle_msgs/srv/GetAvailableStates': lifecycle_msgs.srv.GetAvailableStatesConstructor,
    'lifecycle_msgs/srv/GetAvailableTransitions': lifecycle_msgs.srv.GetAvailableTransitionsConstructor,
    'lifecycle_msgs/srv/GetState': lifecycle_msgs.srv.GetStateConstructor,
    'nav_msgs/srv/GetMap': nav_msgs.srv.GetMapConstructor,
    'nav_msgs/srv/GetPlan': nav_msgs.srv.GetPlanConstructor,
    'nav_msgs/srv/SetMap': nav_msgs.srv.SetMapConstructor,
    'ouster_msgs/srv/GetMetadata': ouster_msgs.srv.GetMetadataConstructor,
    'pcl_msgs/srv/UpdateFilename': pcl_msgs.srv.UpdateFilenameConstructor,
    'rcl_interfaces/srv/DescribeParameters': rcl_interfaces.srv.DescribeParametersConstructor,
    'rcl_interfaces/srv/GetParameterTypes': rcl_interfaces.srv.GetParameterTypesConstructor,
    'rcl_interfaces/srv/GetParameters': rcl_interfaces.srv.GetParametersConstructor,
    'rcl_interfaces/srv/ListParameters': rcl_interfaces.srv.ListParametersConstructor,
    'rcl_interfaces/srv/SetParameters': rcl_interfaces.srv.SetParametersConstructor,
    'rcl_interfaces/srv/SetParametersAtomically': rcl_interfaces.srv.SetParametersAtomicallyConstructor,
    'sdr_interfaces/srv/AddWaypoint': sdr_interfaces.srv.AddWaypointConstructor,
    'sdr_interfaces/srv/RESTBackend': sdr_interfaces.srv.RESTBackendConstructor,
    'sdr_interfaces/srv/SwitchVelocity': sdr_interfaces.srv.SwitchVelocityConstructor,
    'sensor_msgs/srv/SetCameraInfo': sensor_msgs.srv.SetCameraInfoConstructor,
    'std_srvs/srv/Empty': std_srvs.srv.EmptyConstructor,
    'std_srvs/srv/SetBool': std_srvs.srv.SetBoolConstructor,
    'std_srvs/srv/Trigger': std_srvs.srv.TriggerConstructor,
    'tf2_msgs/srv/FrameGraph': tf2_msgs.srv.FrameGraphConstructor,
    'visualization_msgs/srv/GetInteractiveMarkers': visualization_msgs.srv.GetInteractiveMarkersConstructor,
  };
  type ServiceTypeClassName = keyof ServicesMap;
  type Service = ServicesMap[ServiceTypeClassName];
  type ServiceType<T> = T extends ServiceTypeClassName ? ServicesMap[T] : object;

  type ActionsMap = {
    'control_msgs/action/FollowJointTrajectory': control_msgs.action.FollowJointTrajectoryConstructor,
    'control_msgs/action/GripperCommand': control_msgs.action.GripperCommandConstructor,
    'control_msgs/action/JointTrajectory': control_msgs.action.JointTrajectoryConstructor,
    'control_msgs/action/PointHead': control_msgs.action.PointHeadConstructor,
    'control_msgs/action/SingleJointPosition': control_msgs.action.SingleJointPositionConstructor,
    'sdr_interfaces/action/Parking': sdr_interfaces.action.ParkingConstructor,
    'teleop_tools_msgs/action/Increment': teleop_tools_msgs.action.IncrementConstructor,
    'tf2_msgs/action/LookupTransform': tf2_msgs.action.LookupTransformConstructor,
  };
  type ActionTypeClassName = keyof ActionsMap;
  type Action = ActionsMap[ActionTypeClassName];
  type ActionType<T> = T extends ActionTypeClassName ? ActionsMap[T] : object;

  type TypeClassName = MessageTypeClassName | ServiceTypeClassName | ActionTypeClassName;
  type InterfaceType<T> = T extends TypeClassName ? (MessageTypeClassConstructorMap & ServicesMap & ActionsMap)[T] : object;
}
